#ifndef ACCELEGLOVE_H
#define ACCELEGLOVE_H

class BHand;
class Visualizer;

class Glove {

    public:
        Glove(BHand* bh, Visualizer* opengl);
        virtual ~Glove();

        int port;
        void RunOnce();
        void AbortRun();
        void PortSelect(int port);
        bool Initialize();
	bool PrepareRT();

    private:
        bool RTPositionUpdate();
        int OpenGloveSerial(int port);
        unsigned int* serial_port_data_to_array(int glove_fd, unsigned int * data);

        //int accdiff(unsigned int data[18],int olddata[18], int z);
        int spreadposition(unsigned int data[18], int motor, int datadif[18]);
        int motor1position(unsigned int data[18], int motor, int datadif[18]);
        int motor2position(unsigned int data[18], int motor, int datadif[18]);
        int motor3position(unsigned int data[18], int motor, int datadif[18]);
       // unsigned int* calibvalues(unsigned int data[18]);



        BHand* m_hand;
        Visualizer* m_opengl;
        int glove_fd;
        int m_port;

        unsigned int data[18]; //pointer to array
        int olddata[18];
        int datadif[18];

        int motor1, motor2, motor3, spread;
};

#endif //ACCELEGLOVE_H
