#ifndef BOOTLOADER_262_H
#define BOOTLOADER_262_H

#include "BHandHardware.h"

#ifdef BH8_262_HARDWARE

#include "Bootloader.h"

class Bootloader262 : public BGUIBootloader
{
public:
	Bootloader262(BHand *bhand, wxNotebook *bhNotebook, wxGauge* gauge, wxStaticText* firmOH, wxStaticText* helpMSG);
	virtual ~Bootloader262();

	virtual bool UploadPrepareFirmware(unsigned int comport);
	virtual bool UploadWaitReset();
	virtual bool UploadFirmwareLine();
	virtual void UploadCleanup(bool errorFlag = false);

private:

	// communication methods with the hand
	char Read();
	void Write(char ch);
	void EchoWrite(char ch);

};

#endif // BH8_262_HARDWARE

#endif // BOOTLOADER_262_H
