#ifndef BOOTLOADER_PUCK2_H
#define BOOTLOADER_PUCK2_H

#include "BHandHardware.h"

#ifdef BH8_280_HARDWARE

#include "Bootloader.h"


class BootloaderPuck2 : public BGUIBootloader
{
public:
	BootloaderPuck2(BHand *bhand, wxNotebook *bhNotebook, wxGauge* gauge, wxStaticText* firmOH, wxStaticText* helpMSG);
	virtual ~BootloaderPuck2();

	virtual bool UploadPrepareFirmware(unsigned int comport);
	virtual bool UploadWaitReset();
	virtual bool UploadFirmwareLine();
	virtual void UploadCleanup(bool errorFlag = false);

private:

	int setPropertySlow(int bus, unsigned int puckID, unsigned int puckProperty, bool verify, unsigned int value);

	int canReadMsg(int bus, int *id, int *len, unsigned char *data, int blocking);
	int canSendMsg(int bus, int id, char len, unsigned char *data, int blocking);

	// Helper
	void unlockPuck(unsigned int puckID);
	int setRole(unsigned int puckID, unsigned int lower7bits);
	bool awakePuck(int puckID);
	bool finishPuck(int puckID);

	bool finishUpload();

	// firmware download state
	unsigned int puckDownloadIndex;
	unsigned int puckDownloadIDS[10];
	unsigned int puckDownloadNum;

	FILE *fp;

	int in_id;
	int in_len;
	unsigned char in_data[8];
	unsigned char out_Data[8];
	int i;
	int cnt;
	int rcpt;
	int lineTotal, lineCt;

};

#endif // BH8_280_HARDWARE

#endif // BOOTLOADER_PUCK2_H
