#ifndef CPPGENERATOR_H_INCLUDED
#define CPPGENERATOR_H_INCLUDED

#include <wx/string.h>
#include <vector>

class wxTextCtrl;

//! convert ASCII and/or real-time commands into C++ code
//! this class also generates makefiles that will work for the C++ generated files

class CppGenerator {

    public:
        //generate a cpp file of supervisory commands
        static wxString generateSupervisoryFile(wxString commands);
        static wxString generateRealTimeFile(wxString before_commands, wxString after_commands, wxString rt_prepare, wxString rt_start, std::vector<wxTextCtrl *>* rt_cv, std::vector<wxTextCtrl *>* rt_cpg, wxTextCtrl* rt_t_condition, wxString file_path, bool* flags);
        //generate a makefile to correspond with the cpp file
        static wxString generateMakefile(wxString name);

    private:
        //helper functions
        static wxString generateHeaderAndInit();
        static wxString generateSupervisoryFunction(wxString commands, wxString function_name);
        static wxString generateMainSupervisory();
        static wxString generateMainRealTime();
        static wxString generatePrepareRT(wxString function, wxString file_path);
        static wxString generateRunRT(wxString function, std::vector<wxTextCtrl *>* rt_cv, std::vector<wxTextCtrl *>* rt_cpg, wxTextCtrl* rt_t_condition, bool* flags);
};

#endif // CPPGENERATOR_H_INCLUDED

