#include "Vector4.h"
#include <assert.h>

Vector4::Vector4() {
    x = 0;
    y = 0;
    z = 0;
    w = 0;
}

Vector4::Vector4(const float _x, const float _y, const float _z, const float _w) {
    x = _x;
    y = _y;
    z = _z;
    w = _w;
}

Vector4::Vector4(const Vector4* v) {
   x = v->x;
   y = v->y;
   z = v->z;
   w = v->w;
}

Vector4::~Vector4() {
}

void Vector4::setTo(const Vector4* v) {
   x = v->x;
   y = v->y;
   z = v->z;
   w = v->w;
}

float Vector4::r(int position) {
    assert(position >= 0 && position < 4);

    switch(position) {
        case 0:
            return x;
        case 1:
            return y;
        case 2:
            return z;
        case 3:
            return w;
        default:
            return 0;
    }

    return 0;
}
