#ifndef MYEVENT_H
#define MYEVENT_H

#include <wx/wx.h>

class RTRunEvent : public wxEvent
{
public:
	RTRunEvent(wxWindow* win = (wxWindow*) NULL);

	wxEvent *Clone() const;

	DECLARE_DYNAMIC_CLASS(RTRunEvent)
};


class RTAbortEvent : public wxEvent
{
public:
	RTAbortEvent(wxWindow* win = (wxWindow*) NULL);

	wxEvent *Clone() const;

	DECLARE_DYNAMIC_CLASS(RTAbortEvent)
};

typedef void (wxEvtHandler::*RTRunEventFunction)(RTRunEvent&);
typedef void (wxEvtHandler::*RTAbortEventFunction)(RTAbortEvent&);

BEGIN_DECLARE_EVENT_TYPES()
	DECLARE_EVENT_TYPE(myRT_ABORT_EVENT, 1)
	DECLARE_EVENT_TYPE(myRT_RUN_EVENT, 2)
END_DECLARE_EVENT_TYPES()

#define EVT_RTABORT(func)                       \
	DECLARE_EVENT_TABLE_ENTRY(myRT_ABORT_EVENT, \
		-1,                                     \
		-1,                                     \
		(wxObjectEventFunction)                 \
		(RTAbortEventFunction) & func,          \
		(wxObject *) NULL ),

#define EVT_RTRUN(func)                         \
	DECLARE_EVENT_TABLE_ENTRY(myRT_RUN_EVENT,   \
		-1,                                     \
		-1,                                     \
		(wxObjectEventFunction)                 \
		(RTRunEventFunction) & func,            \
		(wxObject *) NULL ),

#endif
