#include "GraphData.h"
#include <cmath>

using namespace std;

double GraphData::m_highest = 0;
double GraphData::m_lowest = 0;


GraphData::GraphData(wxString name, int flags) : mpProfile(name, flags) {
    m_data = 0;
    //layer will show up on the graph legend
    m_type = mpLAYER_PLOT;
}

double GraphData::GetY (double x) {

    if(!m_data || m_data->empty() || ceil(x) > m_data->size() - 1 || floor(x) < 0)
        return 0;

    int bot = (int)floor(x);
    int top = (int)ceil(x);

    double value = (1.0 - (x - bot)) * m_data->at(bot) + (x - bot) * m_data->at(top);

    if(value > m_highest)
        m_highest = value;

    if(value < m_lowest)
        m_lowest = value;

    return value;
}

double GraphData::getLowest() {
    return m_lowest;
}

double GraphData::getHighest() {
    return m_highest;
}

void GraphData::resetExtrema() {
    m_lowest = 0;
    m_highest = 0;
}

void GraphData::setGraphData(std::deque<float>* data) {
    m_data = data;
}
