#ifndef GRAPH_DATA_INCLUDED
#define GRAPH_DATA_INCLUDED

#include "../../Common/mathplot.h"
#include <deque>

//! wxmathplot F(X)->Y graph implmentation (mpProfile allows for smooth lines rather than a locus of points / scatterplot)

class GraphData : public mpProfile {

    public:

        GraphData(wxString name=wxEmptyString, int flags=mpALIGN_RIGHT);
        virtual ~GraphData() {};

        //! needs to be overridden
        virtual double GetY (double x);
        //! sets the "function" of the GraphData (values of the deque)
        void setGraphData(std::deque<float>* data);

        //! for fitting the graph to the window
        //! save the absolute highest and lowest values of all functions graphed
        static double getLowest();
        static double getHighest();
        static void resetExtrema();

    private:
        static double m_lowest;
        static double m_highest;
        //pointer to an array for graph data
        //deque is used for dynamic insertion
        std::deque<float>*  m_data;
};

#endif
