#ifndef NODEEXPR_H_INCLUDED
#define NODEEXPR_H_INCLUDED

#include <wx/string.h>

//! Node class for used in parsing and interpreting expressions

class NodeExpr {

    public:
        NodeExpr() {};
        NodeExpr(NodeExpr* left, NodeExpr* right, wxString val);
        virtual ~NodeExpr();
        //assign values for variables through substitution
        virtual bool Subst(wxString name, float* val);
        //interpret and return the value of the expression
        virtual float Interp();
        //print the expression (debugging)
        virtual void Print();
    protected:

        //values for the expression
        NodeExpr* m_left;
        NodeExpr* m_right;
        wxString m_val;
};

#endif // NODEEXPR_H_INCLUDED
