#ifndef PARSERRT_H_INCLUDED
#define PARSERRT_H_INCLUDED

#include <wx/string.h>

class NodeExpr;

class ParserRT {

    public:
        //! parse an expression
        static NodeExpr* Parse(wxString expr, int motor_num);
    private:
        //! parser helper functions
        static NodeExpr* ParseExpression(wxString* expr, int motor_num);
        static NodeExpr* ParseNumber(wxString* expr);
        static NodeExpr* ParseVar(wxString* expr, int motor_num);
        static NodeExpr* ParseMath(wxString* expr, NodeExpr* variable, int motor_num);
        //! format the expression accordingly
        static wxString CleanWhiteSpace(wxString* expr);
        static void CleanParentheses(wxString* expr);
};

#endif // PARSERRT_H_INCLUDED
