#include "RealPanel.h"

//(*InternalHeaders(RealPanel)
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
#include <wx/statbox.h>
#include <wx/intl.h>
#include <wx/button.h>
#include <wx/string.h>
//*)

//#include "wx/wx.h"
#include <wx/msgdlg.h>
#include "wx/file.h"

#include "BHand.h"

#include "Common/CppGenerator.h"
#include "Graph/GraphData.h"
#include "Parser/ParserRT.h"
#include "Parser/NodeExpr.h"
#include "RealTime_Tab/RealPlotPanel.h"
#include "Super_Tab/SuperPanel.h"

#include <stdio.h>
#include <string.h>


extern bool use280Config;


//(*IdInit(RealPanel)
const long RealPanel::ID_REAL_RealTimeControl_StaticBox = wxNewId();
const long RealPanel::ID_REAL_ControlVelocity_CheckBox = wxNewId();
const long RealPanel::ID_REAL_ControlPropGain_CheckBox = wxNewId();
const long RealPanel::ID_REAL_Motor1_CheckBox = wxNewId();
const long RealPanel::ID_REAL_Motor2_CheckBox = wxNewId();
const long RealPanel::ID_REAL_Motor3_CheckBox = wxNewId();
const long RealPanel::ID_REAL_Motor4_CheckBox = wxNewId();
const long RealPanel::ID_REAL_Cv1_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Cv2_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Cv3_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Cv4_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Cpg1_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Cpg2_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Cpg3_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Cpg4_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_LoadCode_Button = wxNewId();
const long RealPanel::ID_REAL_GenerateCpp_Button = wxNewId();
const long RealPanel::ID_REAL_SaveCode_Button = wxNewId();
const long RealPanel::ID_REAL_ClearCode_Button = wxNewId();
const long RealPanel::ID_REAL_ExecuteBefore_CheckBox = wxNewId();
const long RealPanel::ID_REAL_LoadBefore_Button = wxNewId();
const long RealPanel::ID_REAL_ExecuteAfter_CheckBox = wxNewId();
const long RealPanel::ID_REAL_LoadAfter_Button = wxNewId();
const long RealPanel::ID_REAL_Before_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_After_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Run_Button = wxNewId();
const long RealPanel::ID_REAL_Abort_Button = wxNewId();
const long RealPanel::ID_REAL_RealTimeParameters_StaticBox = wxNewId();
const long RealPanel::ID_REAL_TerminationCondition_StaticBox = wxNewId();
const long RealPanel::ID_REAL_TerminationCondition_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_Position_CheckBox = wxNewId();
const long RealPanel::ID_REAL_Strain_CheckBox = wxNewId();
const long RealPanel::ID_REAL_Velocity_CheckBox = wxNewId();
const long RealPanel::ID_REAL_Delta_CheckBox = wxNewId();
const long RealPanel::ID_REAL_FVelMultiplier_StaticText = wxNewId();
const long RealPanel::ID_REAL_DeltaMultiplier_StaticText = wxNewId();
const long RealPanel::ID_REAL_CVelMultiplier_StaticText = wxNewId();
const long RealPanel::ID_REAL_FVelMultiplier_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_DeltaMultiplier_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_CVelMultiplier_TextCtrl = wxNewId();
const long RealPanel::ID_REAL_DataFrpmFile_StaticBox = wxNewId();
const long RealPanel::ID_REAL_File_StaticText = wxNewId();
const long RealPanel::ID_REAL_File_StaticBox = wxNewId();
const long RealPanel::ID_REAL_LoadFile_Button = wxNewId();
const long RealPanel::ID_REAL_FileName_StaticText = wxNewId();
const long RealPanel::ID_STATICTEXT1 = wxNewId();
const long RealPanel::ID_REAL_HELP_BUTTON = wxNewId();
//*)

BEGIN_EVENT_TABLE(RealPanel,wxPanel)
	//(*EventTable(RealPanel)
	//*)
END_EVENT_TABLE()

RealPanel::RealPanel(wxWindow* parent, BHand *hand, SuperPanel *super_panel, wxWindowID id, const wxPoint& pos, const wxSize& size)
	: m_hand(hand), m_super_panel(super_panel), m_real_before_running(false), m_real_realtime_running(false), m_real_after_running(false)
{
	//(*Initialize(RealPanel)
	Create(parent, wxID_ANY, wxDefaultPosition, wxSize(776,560), wxTAB_TRAVERSAL, _T("wxID_ANY"));
	REAL_RealTimeControl_StaticBox = new wxStaticBox(this, ID_REAL_RealTimeControl_StaticBox, _("Real Time Control"), wxPoint(8,8), wxSize(760,480), 0, _T("ID_REAL_RealTimeControl_StaticBox"));
	REAL_ControlVelocity_CheckBox = new wxCheckBox(this, ID_REAL_ControlVelocity_CheckBox, _("Control Velocity"), wxPoint(368,40), wxSize(168,22), 0, wxDefaultValidator, _T("ID_REAL_ControlVelocity_CheckBox"));
	REAL_ControlVelocity_CheckBox->SetValue(true);
	REAL_ControlPropGain_CheckBox = new wxCheckBox(this, ID_REAL_ControlPropGain_CheckBox, _("Control Proportional Gain"), wxPoint(568,40), wxSize(196,22), 0, wxDefaultValidator, _T("ID_REAL_ControlPropGain_CheckBox"));
	REAL_ControlPropGain_CheckBox->SetValue(false);
	REAL_Motor1_CheckBox = new wxCheckBox(this, ID_REAL_Motor1_CheckBox, _("One"), wxPoint(292,76), wxSize(72,22), 0, wxDefaultValidator, _T("ID_REAL_Motor1_CheckBox"));
	REAL_Motor1_CheckBox->SetValue(false);
	REAL_Motor2_CheckBox = new wxCheckBox(this, ID_REAL_Motor2_CheckBox, _("Two"), wxPoint(292,132), wxSize(76,22), 0, wxDefaultValidator, _T("ID_REAL_Motor2_CheckBox"));
	REAL_Motor2_CheckBox->SetValue(false);
	REAL_Motor3_CheckBox = new wxCheckBox(this, ID_REAL_Motor3_CheckBox, _("Three"), wxPoint(292,188), wxSize(76,22), 0, wxDefaultValidator, _T("ID_REAL_Motor3_CheckBox"));
	REAL_Motor3_CheckBox->SetValue(false);
	REAL_Motor4_CheckBox = new wxCheckBox(this, ID_REAL_Motor4_CheckBox, _("Spread"), wxPoint(292,236), wxSize(76,22), 0, wxDefaultValidator, _T("ID_REAL_Motor4_CheckBox"));
	REAL_Motor4_CheckBox->SetValue(false);
	REAL_Cv1_TextCtrl = new wxTextCtrl(this, ID_REAL_Cv1_TextCtrl, wxEmptyString, wxPoint(368,72), wxSize(168,32), 0, wxDefaultValidator, _T("ID_REAL_Cv1_TextCtrl"));
	REAL_Cv1_TextCtrl->Disable();
	REAL_Cv2_TextCtrl = new wxTextCtrl(this, ID_REAL_Cv2_TextCtrl, wxEmptyString, wxPoint(368,128), wxSize(168,32), 0, wxDefaultValidator, _T("ID_REAL_Cv2_TextCtrl"));
	REAL_Cv2_TextCtrl->Disable();
	REAL_Cv3_TextCtrl = new wxTextCtrl(this, ID_REAL_Cv3_TextCtrl, wxEmptyString, wxPoint(368,184), wxSize(168,32), 0, wxDefaultValidator, _T("ID_REAL_Cv3_TextCtrl"));
	REAL_Cv3_TextCtrl->Disable();
	REAL_Cv4_TextCtrl = new wxTextCtrl(this, ID_REAL_Cv4_TextCtrl, wxEmptyString, wxPoint(368,232), wxSize(168,32), 0, wxDefaultValidator, _T("ID_REAL_Cv4_TextCtrl"));
	REAL_Cv4_TextCtrl->Disable();
	REAL_Cpg1_TextCtrl = new wxTextCtrl(this, ID_REAL_Cpg1_TextCtrl, wxEmptyString, wxPoint(568,72), wxSize(168,32), 0, wxDefaultValidator, _T("ID_REAL_Cpg1_TextCtrl"));
	REAL_Cpg1_TextCtrl->Disable();
	REAL_Cpg2_TextCtrl = new wxTextCtrl(this, ID_REAL_Cpg2_TextCtrl, wxEmptyString, wxPoint(568,128), wxSize(168,32), 0, wxDefaultValidator, _T("ID_REAL_Cpg2_TextCtrl"));
	REAL_Cpg2_TextCtrl->Disable();
	REAL_Cpg3_TextCtrl = new wxTextCtrl(this, ID_REAL_Cpg3_TextCtrl, wxEmptyString, wxPoint(568,184), wxSize(168,32), 0, wxDefaultValidator, _T("ID_REAL_Cpg3_TextCtrl"));
	REAL_Cpg3_TextCtrl->Disable();
	REAL_Cpg4_TextCtrl = new wxTextCtrl(this, ID_REAL_Cpg4_TextCtrl, wxEmptyString, wxPoint(568,232), wxSize(168,32), 0, wxDefaultValidator, _T("ID_REAL_Cpg4_TextCtrl"));
	REAL_Cpg4_TextCtrl->Disable();
	REAL_LoadCode_Button = new wxButton(this, ID_REAL_LoadCode_Button, _("Load Code"), wxPoint(29,44), wxSize(106,28), 0, wxDefaultValidator, _T("ID_REAL_LoadCode_Button"));
	REAL_GenerateCpp_Button = new wxButton(this, ID_REAL_GenerateCpp_Button, _("Generate C++"), wxPoint(153,44), wxSize(106,28), 0, wxDefaultValidator, _T("ID_REAL_GenerateCpp_Button"));
	REAL_SaveCode_Button = new wxButton(this, ID_REAL_SaveCode_Button, _("Save Code"), wxPoint(29,80), wxSize(106,28), 0, wxDefaultValidator, _T("ID_REAL_SaveCode_Button"));
	REAL_ClearCode_Button = new wxButton(this, ID_REAL_ClearCode_Button, _("Clear Code"), wxPoint(153,80), wxSize(106,28), 0, wxDefaultValidator, _T("ID_REAL_ClearCode_Button"));
	REAL_ExecuteBefore_CheckBox = new wxCheckBox(this, ID_REAL_ExecuteBefore_CheckBox, _("Execute Before"), wxPoint(24,124), wxDefaultSize, 0, wxDefaultValidator, _T("ID_REAL_ExecuteBefore_CheckBox"));
	REAL_ExecuteBefore_CheckBox->SetValue(false);
	REAL_LoadBefore_Button = new wxButton(this, ID_REAL_LoadBefore_Button, _("Load"), wxPoint(176,116), wxSize(75,28), 0, wxDefaultValidator, _T("ID_REAL_LoadBefore_Button"));
	REAL_ExecuteAfter_CheckBox = new wxCheckBox(this, ID_REAL_ExecuteAfter_CheckBox, _("Execute After"), wxPoint(24,304), wxSize(144,22), 0, wxDefaultValidator, _T("ID_REAL_ExecuteAfter_CheckBox"));
	REAL_ExecuteAfter_CheckBox->SetValue(false);
	REAL_LoadAfter_Button = new wxButton(this, ID_REAL_LoadAfter_Button, _("Load"), wxPoint(176,300), wxSize(75,28), 0, wxDefaultValidator, _T("ID_REAL_LoadAfter_Button"));
	REAL_Before_TextCtrl = new wxTextCtrl(this, ID_REAL_Before_TextCtrl, wxEmptyString, wxPoint(24,152), wxSize(240,136), wxTE_MULTILINE, wxDefaultValidator, _T("ID_REAL_Before_TextCtrl"));
	REAL_Before_TextCtrl->Disable();
	REAL_After_TextCtrl = new wxTextCtrl(this, ID_REAL_After_TextCtrl, wxEmptyString, wxPoint(24,336), wxSize(240,136), wxTE_MULTILINE, wxDefaultValidator, _T("ID_REAL_After_TextCtrl"));
	REAL_After_TextCtrl->Disable();
	REAL_Run_Button = new wxButton(this, ID_REAL_Run_Button, _("Run"), wxPoint(280,336), wxSize(72,32), wxDOUBLE_BORDER, wxDefaultValidator, _T("ID_REAL_Run_Button"));
	REAL_Abort_Button = new wxButton(this, ID_REAL_Abort_Button, _("Abort"), wxPoint(280,384), wxSize(72,32), 0, wxDefaultValidator, _T("ID_REAL_Abort_Button"));
	REAL_Abort_Button->Disable();
	REAL_RealTimeParameters_StaticBox = new wxStaticBox(this, ID_REAL_RealTimeParameters_StaticBox, _("Real Time Parameters"), wxPoint(368,288), wxSize(200,184), 0, _T("ID_REAL_RealTimeParameters_StaticBox"));
	REAL_TerminationCondition_StaticBox = new wxStaticBox(this, ID_REAL_TerminationCondition_StaticBox, _("Termination Condition"), wxPoint(592,288), wxSize(160,64), 0, _T("ID_REAL_TerminationCondition_StaticBox"));
	REAL_TerminationCondition_TextCtrl = new wxTextCtrl(this, ID_REAL_TerminationCondition_TextCtrl, wxEmptyString, wxPoint(600,312), wxSize(144,32), 0, wxDefaultValidator, _T("ID_REAL_TerminationCondition_TextCtrl"));
	REAL_Position_CheckBox = new wxCheckBox(this, ID_REAL_Position_CheckBox, _("Position"), wxPoint(384,312), wxSize(88,24), 0, wxDefaultValidator, _T("ID_REAL_Position_CheckBox"));
	REAL_Position_CheckBox->SetValue(false);
	REAL_Strain_CheckBox = new wxCheckBox(this, ID_REAL_Strain_CheckBox, _("Strain"), wxPoint(480,312), wxSize(80,24), 0, wxDefaultValidator, _T("ID_REAL_Strain_CheckBox"));
	REAL_Strain_CheckBox->SetValue(false);
	REAL_Velocity_CheckBox = new wxCheckBox(this, ID_REAL_Velocity_CheckBox, _("Velocity"), wxPoint(384,336), wxSize(96,24), 0, wxDefaultValidator, _T("ID_REAL_Velocity_CheckBox"));
	REAL_Velocity_CheckBox->SetValue(false);
	REAL_Delta_CheckBox = new wxCheckBox(this, ID_REAL_Delta_CheckBox, _("Delta"), wxPoint(480,336), wxSize(80,24), 0, wxDefaultValidator, _T("ID_REAL_Delta_CheckBox"));
	REAL_Delta_CheckBox->SetValue(false);
	REAL_FVelMultiplier_StaticText = new wxStaticText(this, ID_REAL_FVelMultiplier_StaticText, _("FVEL Multiplier"), wxPoint(376,368), wxSize(120,24), 0, _T("ID_REAL_FVelMultiplier_StaticText"));
	REAL_DeltaMultiplier_StaticText = new wxStaticText(this, ID_REAL_DeltaMultiplier_StaticText, _("Delta Multiplier"), wxPoint(376,400), wxSize(120,24), 0, _T("ID_REAL_DeltaMultiplier_StaticText"));
	REAL_CVelMultiplier_StaticText = new wxStaticText(this, ID_REAL_CVelMultiplier_StaticText, _("CVel Multiplier"), wxPoint(376,432), wxSize(120,24), 0, _T("ID_REAL_CVelMultiplier_StaticText"));
	REAL_FVelMultiplier_TextCtrl = new wxTextCtrl(this, ID_REAL_FVelMultiplier_TextCtrl, _("1"), wxPoint(504,368), wxSize(56,27), wxTE_RIGHT, wxDefaultValidator, _T("ID_REAL_FVelMultiplier_TextCtrl"));
	REAL_DeltaMultiplier_TextCtrl = new wxTextCtrl(this, ID_REAL_DeltaMultiplier_TextCtrl, _("1"), wxPoint(504,400), wxSize(56,27), wxTE_RIGHT, wxDefaultValidator, _T("ID_REAL_DeltaMultiplier_TextCtrl"));
	REAL_CVelMultiplier_TextCtrl = new wxTextCtrl(this, ID_REAL_CVelMultiplier_TextCtrl, _("1"), wxPoint(504,432), wxSize(56,27), wxTE_RIGHT, wxDefaultValidator, _T("ID_REAL_CVelMultiplier_TextCtrl"));
	REAL_DataFrpmFile_StaticBox = new wxStaticBox(this, ID_REAL_DataFrpmFile_StaticBox, _("Data from File"), wxPoint(8,504), wxSize(760,80), 0, _T("ID_REAL_DataFrpmFile_StaticBox"));
	REAL_File_StaticText = new wxStaticText(this, ID_REAL_File_StaticText, _("File:"), wxPoint(24,544), wxSize(40,17), 0, _T("ID_REAL_File_StaticText"));
	REAL_File_StaticBox = new wxStaticBox(this, ID_REAL_File_StaticBox, wxEmptyString, wxPoint(56,528), wxSize(608,40), 0, _T("ID_REAL_File_StaticBox"));
	REAL_LoadFile_Button = new wxButton(this, ID_REAL_LoadFile_Button, _("Load"), wxPoint(672,536), wxDefaultSize, 0, wxDefaultValidator, _T("ID_REAL_LoadFile_Button"));
	REAL_FileName_StaticText = new wxStaticText(this, ID_REAL_FileName_StaticText, _("n/a"), wxPoint(64,544), wxSize(592,17), 0, _T("ID_REAL_FileName_StaticText"));
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("TIP: Get started by loading the \"RealTime2*.rt\" file and read about creating programs in the BH Control GUI Manual"), wxPoint(28,24), wxSize(728,13), 0, _T("ID_STATICTEXT1"));
	Real_Help_Button = new wxButton(this, ID_REAL_HELP_BUTTON, _("Help"), wxPoint(280,432), wxSize(72,32), 0, wxDefaultValidator, _T("ID_REAL_HELP_BUTTON"));
	//*)

	init();

	//!Real Time - Control
	Connect(ID_REAL_LoadCode_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTLoadCode);
	Connect(ID_REAL_SaveCode_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTSaveCode);
	Connect(ID_REAL_GenerateCpp_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTGenerateCpp);
	Connect(ID_REAL_ClearCode_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTClearCode);
	Connect(ID_REAL_LoadBefore_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTLoadBefore);
	Connect(ID_REAL_LoadAfter_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTLoadAfter);
	Connect(ID_REAL_Run_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTRun);
	Connect(ID_REAL_LoadFile_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTLoadFile);
	Connect(ID_REAL_Abort_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTAbort);
	Connect(ID_REAL_HELP_BUTTON, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTHelp);

	Connect(ID_REAL_ExecuteBefore_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTExecuteBefore);
	Connect(ID_REAL_ExecuteAfter_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPanel::OnRTExecuteAfter);
	Connect(ID_REAL_Motor1_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPanel::OnSetCVandCPGTextboxEnable);
	Connect(ID_REAL_Motor2_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPanel::OnSetCVandCPGTextboxEnable);
	Connect(ID_REAL_Motor3_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPanel::OnSetCVandCPGTextboxEnable);
	Connect(ID_REAL_Motor4_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPanel::OnSetCVandCPGTextboxEnable);
	Connect(ID_REAL_ControlVelocity_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPanel::OnSetCVandCPGTextboxEnable);
	Connect(ID_REAL_ControlPropGain_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPanel::OnSetCVandCPGTextboxEnable);
}

RealPanel::~RealPanel()
{
	// Remove old expressions
    for (int i = 0; i < 8; i++)
        if (m_exprs[i] != NULL)
        {
            delete m_exprs[i];
            m_exprs[i] = NULL;
        }

	if (m_term_expr != NULL)
	{
		delete m_term_expr;
		m_term_expr = NULL;
	}

	// Clear the deque
	for (unsigned int i = 0; i < file_data.size(); i++)
	{
		if (file_data[i] != NULL)
			delete[] file_data[i];
	}

	//(*Destroy(RealPanel)
	//*)
}

void RealPanel::init()
{
	N = 0;
	time = 0;

	m_cv.push_back(REAL_Cv1_TextCtrl);
	m_cv.push_back(REAL_Cv2_TextCtrl);
	m_cv.push_back(REAL_Cv3_TextCtrl);
	m_cv.push_back(REAL_Cv4_TextCtrl);
	m_cpg.push_back(REAL_Cpg1_TextCtrl);
	m_cpg.push_back(REAL_Cpg2_TextCtrl);
	m_cpg.push_back(REAL_Cpg3_TextCtrl);
	m_cpg.push_back(REAL_Cpg4_TextCtrl);

	for (int i = 0; i < 8; i++)
		m_exprs[i] = NULL;

	m_term_expr = 0;

	// Set memory for real-time data buffer to zero
	for (int i = 0; i < 4; i++)
		for (int j = 0; j < 7; j++)
			motor_data[i][j] = 0;
}

void RealPanel::SetRealPlotPanel(RealPlotPanel *real_plot_panel)
{
	m_real_plot_panel = real_plot_panel;

	m_graphs[0] = m_real_plot_panel->getHistogramRealTime(0);
	m_graphs[1] = m_real_plot_panel->getHistogramRealTime(1);
	m_graphs[2] = m_real_plot_panel->getHistogramRealTime(2);
	m_graphs[3] = m_real_plot_panel->getHistogramRealTime(3);

	wxString graph_names[8] = {
		wxT("Position"),
		wxT("Velocity"),
		wxT("Strain"),
		wxT("Delta"),
		wxT("F_Data"),
		wxT("Time"),
		wxT("Ctrl_Vel"),
		wxT("Ctrl_Gain")
		};

	// Set colors for graph functions
	wxColour colors[8] = {
		wxColour(50,50,180),
		wxColour(120,115,62),
		wxColour(245,122,0),
		wxColour(20,170,220),
		wxColour(20,180,20),
		wxColour(180,20,180),
		wxColour(20,40,50),
		wxColour(245,0,0)
		};


	// Initialize graph windows with legends for all functions
	// Functions can be toggled on/off with the listbox
	for (int i = 0; i < 4; i++)
	{
		for (int j = 0; j < 8; j++)
		{
			GraphData* g = new GraphData(graph_names[j]);
			g->SetDrawOutsideMargins(false);
			wxPen p(colors[j], 2);
			g->SetPen(p);

			m_plots[i].push_back(g);

			g->setGraphData(&(m_graph_data[i][j]));
			g->ShowName(false);
			g->SetVisible(false);
			m_graphs[i]->AddLayer(g);
		}

		m_graphs[i]->AddLayer(new mpInfoCoords(wxRect(44,2, 0,0)));
		mpLayer* legend = new mpInfoLegend(wxRect(479,2, 0, 0));
		legend->SetVisible(true);
		m_graphs[i]->AddLayer(legend);
	}
}


void RealPanel::OnRTLoadCode(wxCommandEvent& event)
{
	wxFileDialog FileDialog_RT(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_OPEN, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	FileDialog_RT.SetWildcard(wxT("Real Time Code (*.rt)|*.rt"));

	if (FileDialog_RT.ShowModal() == wxID_OK)
	{
		cycleFilePath = FileDialog_RT.GetPath();
		LoadCode(cycleFilePath);
	}
}

void RealPanel::OnRTSaveCode(wxCommandEvent& event)
{
	// Saves an ".rt" file, preserving the GUI state
	wxFileDialog FileSave(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_SAVE|wxFD_OVERWRITE_PROMPT, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));

	FileSave.SetWildcard(wxT("Real Time Code (*.rt)|*.rt"));

	if (FileSave.ShowModal() == wxID_OK)
		SaveCode(FileSave.GetPath());

	FileSave.SetPath(wxT(""));
}

void RealPanel::OnRTClearCode(wxCommandEvent& event)
{
	// Clears the GUI to default values

	// Set default checkbox state
	REAL_Motor1_CheckBox->SetValue(false);
	REAL_Motor2_CheckBox->SetValue(false);
	REAL_Motor3_CheckBox->SetValue(false);
	REAL_Motor4_CheckBox->SetValue(false);

	REAL_ControlVelocity_CheckBox->SetValue(true);
	REAL_ControlPropGain_CheckBox->SetValue(false);

	// Enable/disable the textboxes
	SetEnableForCVandCPGTextboxes();

	// Clear Execute Before checkbox and disable the textbox
	REAL_ExecuteBefore_CheckBox->SetValue(false);
	REAL_Before_TextCtrl->Enable(false);

	// Clear Execute After checkbox and disable the textbox
	REAL_ExecuteAfter_CheckBox->SetValue(false);
	REAL_After_TextCtrl->Enable(false);

	// Clear Real Time Parameter checkboxes
	REAL_Delta_CheckBox->SetValue(false);
	REAL_Position_CheckBox->SetValue(false);
	REAL_Strain_CheckBox->SetValue(false);
	REAL_Velocity_CheckBox->SetValue(false);

	// Clear or reset all other textboxes
	REAL_Before_TextCtrl->Clear();
	REAL_After_TextCtrl->Clear();
	REAL_Cv1_TextCtrl->Clear();
	REAL_Cv2_TextCtrl->Clear();
	REAL_Cv3_TextCtrl->Clear();
	REAL_Cv4_TextCtrl->Clear();
	REAL_Cpg1_TextCtrl->Clear();
	REAL_Cpg2_TextCtrl->Clear();
	REAL_Cpg3_TextCtrl->Clear();
	REAL_Cpg4_TextCtrl->Clear();
	REAL_FVelMultiplier_TextCtrl->SetValue(wxT("1"));
	REAL_DeltaMultiplier_TextCtrl->SetValue(wxT("1"));
	REAL_CVelMultiplier_TextCtrl->SetValue(wxT("1"));
	REAL_TerminationCondition_TextCtrl->Clear();

	ClearCode();
}


void RealPanel::OnRTGenerateCpp(wxCommandEvent& event)
{
	// Generates a RealTime ".cpp" file, along with a Makefile in the same directory
	wxFileDialog FileSave(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_SAVE|wxFD_OVERWRITE_PROMPT, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));

	FileSave.SetWildcard(wxT("C++ File (*.cpp)|*.cpp"));

	if (FileSave.ShowModal() == wxID_OK)
		GenerateCpp(FileSave.GetPath());

	FileSave.SetPath(wxT(""));
}


void RealPanel::OnRTExecuteBefore(wxCommandEvent& event)
{
	// Enables/disables executing of supervisory code before RealTime mode
	REAL_Before_TextCtrl->Enable(REAL_ExecuteBefore_CheckBox->GetValue());
}


void RealPanel::OnRTExecuteAfter(wxCommandEvent& event)
{
	// Enables/disables executing of supervisory code after RealTime mode
	REAL_After_TextCtrl->Enable(REAL_ExecuteAfter_CheckBox->GetValue());
}


void RealPanel::OnRTLoadBefore(wxCommandEvent& event)
{
	// Load supervisory code to be executed before RealTime code
	wxFileDialog FileDialog_BH(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_OPEN, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	FileDialog_BH.SetWildcard(wxT("BHand Commands (*.bh)|*.bh"));

	if (FileDialog_BH.ShowModal() == wxID_OK)
		REAL_Before_TextCtrl->LoadFile(FileDialog_BH.GetPath());
}


void RealPanel::OnRTLoadAfter(wxCommandEvent& event)
{
	// Load supervisory code to be executed after RealTime code
	wxFileDialog FileDialog_BH(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_OPEN, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	FileDialog_BH.SetWildcard(wxT("BHand Commands (*.bh)|*.bh"));

	if (FileDialog_BH.ShowModal() == wxID_OK)
		REAL_After_TextCtrl->LoadFile(FileDialog_BH.GetPath());
}


void RealPanel::OnRTAbort(wxCommandEvent& event)
{
	RTAbort();
}


void RealPanel::OnRTRun(wxCommandEvent& event)
{
	RTRun();
}


void RealPanel::OnRTHelp(wxCommandEvent& event)
{
	wxString helpMsg = wxT("This is a summary of what can be found in the BHControl GUI Manual.\n");
	helpMsg += wxT("The RealTime tab allows the creation of complex control velocity expressions.\n\n");

	helpMsg += wxT("BH8-280 Puck motor controllers implement velocity mode on top of a position controller updated\n");
	helpMsg += wxT("at a kilohertz.  Velocity references in units of encoder ticks/ms are added to the present\n");
	helpMsg += wxT("commanded position each servo cycle.  KP, KI, and KD affect both position and velocity PID gains.\n\n");

	helpMsg += wxT("BH8-262 motor controllers responds according to the following equation in the HCTL-1100 datasheet:\n");
	helpMsg += wxT("   MCn = (K/4) * Yn\n");
	helpMsg += wxT("   Where K depends on the boolean flag (LCPG) determined by the Control Proportional Gain check box.\n");
	helpMsg += wxT("        If LCPG check box is checked then K is the evaluation of the Control Proportional Gain expression,\n");
	helpMsg += wxT("        otherwise K is equal to the value of the \"FPG\" property.\n");
	helpMsg += wxT("   Yn is the velocity error and equals (Control Velocity Expression * CVel Multiplier - Actual Velocity)\n\n");
	helpMsg += wxT("   Multipliers are 8-bit unsigned integer coefficients for the BH8-262 hand\n\n");
	helpMsg += wxT("      CVel multiplier is a velocity coefficient (LCVC) that amplifies the commanded control velocity.\n");
	helpMsg += wxT("      Delta multiplier is a delta position coefficient (LFDPC) that the delta position feedback is divided by.\n");
	helpMsg += wxT("      FVel multiplier is a velocity coefficient (LFVC) that the feedback velocity is divided by.\n\n");

	helpMsg += wxT("Refer to the manual for details on how expressions are interpreted.");

	wxMessageDialog response(NULL, helpMsg, wxT("RealTime Help"), wxOK);
	response.ShowModal();
}


void RealPanel::OnSetCVandCPGTextboxEnable(wxCommandEvent& event) { SetEnableForCVandCPGTextboxes(); }


void RealPanel::OnRTLoadFile(wxCommandEvent& event)
{
	// Loads a RealTime data file ".rtd" to be used during RealTime mode
	// in the expression windows (F1,F2,F3,F4 are values corresponding to
	// each motor.  The value of F1-F4 is based on the current update number, N during
	// each iteration of the real-time loop)

	wxFileDialog FileDialog_RTD(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_OPEN, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	FileDialog_RTD.SetWildcard(wxT("Real Time Data (*.rtd)|*.rtd"));

	if (FileDialog_RTD.ShowModal() == wxID_OK)
		LoadFile(FileDialog_RTD.GetPath());
}


void RealPanel::SetEnableForCVandCPGTextboxes()
{
	REAL_Cv1_TextCtrl->Enable(REAL_Motor1_CheckBox->GetValue() && REAL_ControlVelocity_CheckBox->GetValue());
	REAL_Cv2_TextCtrl->Enable(REAL_Motor2_CheckBox->GetValue() && REAL_ControlVelocity_CheckBox->GetValue());
	REAL_Cv3_TextCtrl->Enable(REAL_Motor3_CheckBox->GetValue() && REAL_ControlVelocity_CheckBox->GetValue());
	REAL_Cv4_TextCtrl->Enable(REAL_Motor4_CheckBox->GetValue() && REAL_ControlVelocity_CheckBox->GetValue());

	REAL_Cpg1_TextCtrl->Enable(REAL_Motor1_CheckBox->GetValue() && REAL_ControlPropGain_CheckBox->GetValue());
	REAL_Cpg2_TextCtrl->Enable(REAL_Motor2_CheckBox->GetValue() && REAL_ControlPropGain_CheckBox->GetValue());
	REAL_Cpg3_TextCtrl->Enable(REAL_Motor3_CheckBox->GetValue() && REAL_ControlPropGain_CheckBox->GetValue());
	REAL_Cpg4_TextCtrl->Enable(REAL_Motor4_CheckBox->GetValue() && REAL_ControlPropGain_CheckBox->GetValue());
}


char* DecodeRTFileLine(char * str)
{
	// Convert symbols into newline characters
	if (str[strlen(str)-1] == '\n')
		str[strlen(str)-1] = 0;

	for (size_t i = 0; i < strlen(str); i++)
	{
		if (str[i] == '#')
			str[i] = '\n';
		if (str[i] =='$')
			str[i] = '\n';
	}

	return str;
}


wxString* EncodeRTFileLine(wxString* toEncode)
{
	// Convert newline characters and carriage returns into symbols
	toEncode->Replace(wxT("\n"), wxT("#"));
	toEncode->Replace(wxT("\r"), wxT("$"));

	return toEncode;
}


void WriteLineToFile(wxString temp, FILE *fp)
{
	// Write a wxString to a line in a file
    EncodeRTFileLine(&temp);

    char buf[500];

    strcpy(buf, temp.mb_str());

	fprintf(fp, "%s\n", buf);
}


void RealPanel::LoadCode(wxString toLoad)
{
	// Load RealTime parameters into GUI
	FILE* fp = fopen(toLoad.mb_str(), "rt");
	if (!fp)
		return;

	int _buffer, _cvmult, _delmult, _velmult, cpg, cv, delta, position, spread, strain, three, two, velocity, one, after, before;

	char buf[501];

	// scan through the file and set windows / text boxes accordingly
	fscanf(fp, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
		&_buffer, &cpg, &cv, &_cvmult, &_delmult, &delta,
		&position, &spread, &strain, &three, &two, &_velmult,
		&velocity, &one, &after, &before );
	fgets(buf, 500, fp);

	REAL_CVelMultiplier_TextCtrl->SetValue(wxString::Format(wxT("%i"), _cvmult));
	REAL_DeltaMultiplier_TextCtrl->SetValue(wxString::Format(wxT("%i"), _delmult));
	REAL_FVelMultiplier_TextCtrl->SetValue(wxString::Format(wxT("%i"), _velmult));

	REAL_ControlPropGain_CheckBox->SetValue(cpg != 0);
	REAL_ControlVelocity_CheckBox->SetValue(cv != 0);

	REAL_Motor1_CheckBox->SetValue(one != 0);
	REAL_Motor2_CheckBox->SetValue(two != 0);
	REAL_Motor3_CheckBox->SetValue(three != 0);
	REAL_Motor4_CheckBox->SetValue(spread != 0);

	SetEnableForCVandCPGTextboxes();

	REAL_Delta_CheckBox->SetValue(delta != 0);
	REAL_Position_CheckBox->SetValue(position != 0);
	REAL_Strain_CheckBox->SetValue(strain != 0);
	REAL_Velocity_CheckBox->SetValue(velocity != 0);

	REAL_ExecuteBefore_CheckBox->SetValue(before != 0);
	REAL_Before_TextCtrl->Enable(before != 0);

	REAL_ExecuteAfter_CheckBox->SetValue(after != 0);
	REAL_After_TextCtrl->Enable(after != 0);

	fgets(buf, 500, fp); m_cv[0]->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); m_cv[1]->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); m_cv[2]->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); m_cv[3]->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));

	fgets(buf, 500, fp); m_cpg[0]->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); m_cpg[1]->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); m_cpg[2]->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); m_cpg[3]->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));

	fgets(buf, 500, fp); REAL_TerminationCondition_TextCtrl->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); REAL_Before_TextCtrl->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); REAL_After_TextCtrl->SetValue(wxString(DecodeRTFileLine(buf), wxConvUTF8));
	fgets(buf, 500, fp); REAL_FileName_StaticText->SetLabel(wxString(DecodeRTFileLine(buf), wxConvUTF8));

	LoadFile(REAL_FileName_StaticText->GetLabel());

	fclose(fp);
}


void RealPanel::SaveCode(wxString toSave)
{
	// Save all the RealTime parameters into a file
	if (!toSave.EndsWith(wxT(".rt")))
		toSave = toSave + wxT(".rt");

	// Read values from the GUI and save them to a file
	long _buffer, _cvmult, _delmult, _velmult, cpg, cv, delta, position, spread, strain, three, two, velocity, one, after, before;

	if (!(REAL_CVelMultiplier_TextCtrl->GetValue()).ToLong(&_cvmult))
		return;
	if (!(REAL_FVelMultiplier_TextCtrl->GetValue()).ToLong(&_velmult))
		return;
	if (!(REAL_DeltaMultiplier_TextCtrl->GetValue()).ToLong(&_delmult))
		return;

	cpg = (int)REAL_ControlPropGain_CheckBox->GetValue();
	cv = (int)REAL_ControlVelocity_CheckBox->GetValue();

	delta = (int)REAL_Delta_CheckBox->GetValue();
	position = (int)REAL_Position_CheckBox->GetValue();
	strain = (int)REAL_Strain_CheckBox->GetValue();
	velocity = (int)REAL_Velocity_CheckBox->GetValue();

	after = (int)REAL_ExecuteAfter_CheckBox->GetValue();
	before = (int)REAL_ExecuteBefore_CheckBox->GetValue();

	one = (int)REAL_Motor1_CheckBox->GetValue();
	two = (int)REAL_Motor2_CheckBox->GetValue();
	three = (int)REAL_Motor3_CheckBox->GetValue();
	spread = (int)REAL_Motor4_CheckBox->GetValue();

	FILE *fp = fopen(toSave.mb_str(), "w");

	if (!fp)
	{
		wxPuts(wxT("Invalid file found."));
		return;
	}

	_buffer = 0;

	fprintf(fp, "%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld\n",
		_buffer, cpg, cv, _cvmult, _delmult, delta,
		position, spread, strain, three, two, _velmult,
		velocity, one, after, before);

	wxString temp;

	temp = m_cv[0]->GetValue(); WriteLineToFile(temp, fp);
	temp = m_cv[1]->GetValue(); WriteLineToFile(temp, fp);
	temp = m_cv[2]->GetValue(); WriteLineToFile(temp, fp);
	temp = m_cv[3]->GetValue(); WriteLineToFile(temp, fp);

	temp = m_cpg[0]->GetValue(); WriteLineToFile(temp, fp);
	temp = m_cpg[1]->GetValue(); WriteLineToFile(temp, fp);
	temp = m_cpg[2]->GetValue(); WriteLineToFile(temp, fp);
	temp = m_cpg[3]->GetValue(); WriteLineToFile(temp, fp);

	temp = REAL_TerminationCondition_TextCtrl->GetValue(); WriteLineToFile(temp, fp);
	temp = REAL_Before_TextCtrl->GetValue();               WriteLineToFile(temp, fp);
	temp = REAL_After_TextCtrl->GetValue();                WriteLineToFile(temp, fp);
	temp = REAL_FileName_StaticText->GetLabel();           WriteLineToFile(temp, fp);

	fclose(fp);
}


void RealPanel::ClearCode()
{
	// Clear Code is also partly handled by the BHControlMain class
    REAL_FileName_StaticText->SetLabel(wxT("n/a"));

    for(unsigned int i = 0; i < file_data.size(); i++)
    {
        if(file_data[i] != NULL)
        {
            delete[] file_data[i];
            file_data[i] = NULL;
        }
    }


    file_data.clear();
}


void RealPanel::GenerateCpp(wxString toSave)
{
	// Generate a real-time C++ file
	wxFile file;

	// Check to see if user included ".cpp" at the end of their save file
	if (!toSave.EndsWith(wxT(".cpp")))
		toSave = toSave + wxT(".cpp"); // if not append it

	if (file.Create(toSave, true))
	{
		wxString prepare, start;

		// Get a string representing the selected motors
		char motors[5];
		int counter = 0;
		if (REAL_Motor1_CheckBox->GetValue()) motors[counter++] = '1';
		if (REAL_Motor2_CheckBox->GetValue()) motors[counter++] = '2';
		if (REAL_Motor3_CheckBox->GetValue()) motors[counter++] = '3';
		if (REAL_Motor4_CheckBox->GetValue()) motors[counter++] = 'S';
		motors[counter] = 0;

		long cvelmult, delmult, fvelmult;

		if (!(REAL_CVelMultiplier_TextCtrl->GetValue()).ToLong(&cvelmult))
			return;
		if (!(REAL_DeltaMultiplier_TextCtrl->GetValue()).ToLong(&delmult))
			return;
		if (!(REAL_FVelMultiplier_TextCtrl->GetValue()).ToLong(&fvelmult))
			return;

		// Save the RTSetFlags and RTStart commands into wxStrings
		char buf[1024];
		bool param_position = REAL_Position_CheckBox->GetValue();
		bool param_strain = REAL_Strain_CheckBox->GetValue();
		bool param_delta = REAL_Delta_CheckBox->GetValue();
		bool param_velocity = REAL_Velocity_CheckBox->GetValue();
		sprintf(buf, "RTSetFlags( \"%s\", %d, %d, %d, 0, %d, %d, %d, %d, %d, %d,0,0,0,0 )",
			motors, REAL_ControlVelocity_CheckBox->GetValue(), (int)cvelmult, REAL_ControlPropGain_CheckBox->GetValue(), param_velocity, (int)fvelmult,
			param_strain, param_position, param_delta, (int)delmult);
		prepare = wxString(buf, wxConvUTF8);
		sprintf(buf, "RTStart( \"%s\" )", motors);
		start = wxString(buf, wxConvUTF8);

		// Store the status of active wxTextCtrl windows
		bool flags[8];
		flags[0] = REAL_Motor1_CheckBox->GetValue() && REAL_ControlVelocity_CheckBox->GetValue();
		flags[1] = REAL_Motor2_CheckBox->GetValue() && REAL_ControlVelocity_CheckBox->GetValue();
		flags[2] = REAL_Motor3_CheckBox->GetValue() && REAL_ControlVelocity_CheckBox->GetValue();
		flags[3] = REAL_Motor4_CheckBox->GetValue() && REAL_ControlVelocity_CheckBox->GetValue();

		flags[4] = REAL_Motor1_CheckBox->GetValue() && REAL_ControlPropGain_CheckBox->GetValue();
		flags[5] = REAL_Motor2_CheckBox->GetValue() && REAL_ControlPropGain_CheckBox->GetValue();
		flags[6] = REAL_Motor3_CheckBox->GetValue() && REAL_ControlPropGain_CheckBox->GetValue();
		flags[7] = REAL_Motor4_CheckBox->GetValue() && REAL_ControlPropGain_CheckBox->GetValue();

		// Send this information to the CppGenerator along with pointers to other parts of the RealTime tab
		// generate the string, write it to file, and close the file
		file.Write(CppGenerator::generateRealTimeFile(REAL_Before_TextCtrl->GetValue(), REAL_After_TextCtrl->GetValue(), prepare, start, &m_cv, &m_cpg, REAL_TerminationCondition_TextCtrl, m_file_path, flags));
		file.Close();
	}

	toSave = toSave.BeforeLast('.') + wxT(".mak");

	if (file.Create(toSave, true))
	{
		// Send the name of the file to create a makefile corresponding to it and then save and close the file
		file.Write(CppGenerator::generateMakefile((toSave.BeforeLast('.')).AfterLast('/')));
		file.Close();
	}
}


bool RealPanel::PrepareRT()
{
    PlotRefresh();

    // Make sure there were no errors in parsing or substituting before continuing
    if (!ParseWindows() || !SubstituteVariables())
    {
        wxMessageDialog response(NULL, wxT("There was a syntax error encountered during parsing.\nMake sure proper parentheses are included.  Main\nproblems to look for: negative numbers should be enclosed in \nparentheses (e.g. -4 should be (-4)), conditional expressions \nmust have all parts in parentheses (A) ? (B) : (C), \nand make sure to explicitly denote inequalities with \nextra parentheses."), wxT("Syntax - Error"), wxOK | wxICON_ERROR);
        response.ShowModal();
        return false;
    }

    // Get the active motors
    char motors[5];
    int counter = 0;
    if (REAL_Motor1_CheckBox->GetValue()) motors[counter++] = '1';
	if (REAL_Motor2_CheckBox->GetValue()) motors[counter++] = '2';
	if (REAL_Motor3_CheckBox->GetValue()) motors[counter++] = '3';
	if (REAL_Motor4_CheckBox->GetValue()) motors[counter++] = 'S';
	motors[counter] = 0;

	// Parse multipliers
    if (!(REAL_CVelMultiplier_TextCtrl->GetValue()).ToLong(&cvelmult) ||
		!(REAL_DeltaMultiplier_TextCtrl->GetValue()).ToLong(&delmult) ||
		!(REAL_FVelMultiplier_TextCtrl->GetValue()).ToLong(&fvelmult))
	{
        wxMessageDialog response(NULL, wxT("One of the RealTime Multipliers cannot be converted to an integer."), wxT("Integer Conversion Error"), wxOK | wxICON_ERROR);
        response.ShowModal();
        return false;
	}

	for (int i = 0; i < 4; i++)
	{
		int samplereg;
		char motor[] = "1";
		motor[0] += i;
		m_hand->Get(motor, "SAMPLE", &samplereg);
		//printf("samplereg = %d\n", samplereg);
		sampleperiod[i] = (16.0 * (((double)samplereg) + 1.0)) / 2000000.0; // 2.0 MHz external clock (units are in seconds)
		sampleperiod[i] *= 1000.0; // convert sample period to be in milliseconds
		//printf("sampleperiod[%d] = %0.6f\n", i, sampleperiod[i]);
	}

    // Clear the deques of graph data
    for (unsigned int i = 0; i < 4; i++)
        for (unsigned int j = 0; j < 8; j++)
            m_graph_data[i][j].clear();


    // Set flags for RealTime according to parameters in the tab
    bool LCV = REAL_ControlVelocity_CheckBox->GetValue();
    bool LCPG = REAL_ControlPropGain_CheckBox->GetValue();

	bool LFV = REAL_Velocity_CheckBox->GetValue();
	bool LFS = REAL_Strain_CheckBox->GetValue();
	bool LFAP = REAL_Position_CheckBox->GetValue();
	bool LFDP = REAL_Delta_CheckBox->GetValue();

	// Clear control position flag for 280 hand
	if (use280Config)
	{
		m_hand->Set("", "LCP", 0);
	    m_hand->Set("", "LFPPS", 0);
	}

	// Set RealTime flags
    if (m_hand->RTSetFlags(motors, LCV, cvelmult, LCPG, false,
        LFV, fvelmult, LFS, LFAP, LFDP, delmult,
		false, false, false, false))
	{
        wxMessageDialog response(NULL, wxT("The RealTime SetFlags method returned a non-zero error."), wxT("RTSetFlags - Error"), wxOK | wxICON_ERROR);
        response.ShowModal();
        return false;
	}

    // Start RealTime mode with the selected motors
	if (m_hand->RTStart(motors))
	{
        wxMessageDialog response(NULL, wxT("The RealTime Start method returned a non-zero error."), wxT("RTStart - Error"), wxOK | wxICON_ERROR);
        response.ShowModal();
		return false;
	}

    // Update RealTime mode once
	if (m_hand->RTUpdate(false, true))
		return false;

	// Start keeping track of time once RTUpdate has been called
	N = 0;
    time = 0;
    t_real.Start();

    return true;
}


void RealPanel::InterpretAndSet(float time)
{
	for (int m = 0; m < 4; m++)
	{
		// Stores all the RealTime data into a matrix buffer
		motor_data[m][0] = ((float)m_hand->RTGetDeltaPos(m + '1')) * delmult;
		motor_data[m][1] = (!file_data.empty()) ? ((file_data[N % file_data.size()])[m]) : 0;   // file data
		motor_data[m][2] = N;
		motor_data[m][3] = (float)m_hand->RTGetPosition( m+'1' );
		motor_data[m][4] = (float)m_hand->RTGetStrain(m + '1' );
		motor_data[m][5] = time;
		motor_data[m][6] = use280Config ? (float)m_hand->RTGetVelocity(m+'1') : (((float)m_hand->RTGetVelocity(m+'1')) * ((float)fvelmult) / 10.0f);

		// Copy the RealTime data into corresponding deque
		m_graph_data[m][0].push_back(motor_data[m][3]);     // position
		m_graph_data[m][1].push_back(motor_data[m][6]);     // velocity
		m_graph_data[m][2].push_back(motor_data[m][4]);     // strain
		m_graph_data[m][3].push_back(motor_data[m][0]);     // delta position

		if (!file_data.empty())
			m_graph_data[m][4].push_back(motor_data[m][1]); // file data

		m_graph_data[m][5].push_back(time);                 // time passed (seconds)

//        if(m == 1) {
//            wxPuts(wxString::Format(wxT("DP%i - value is: %f"), m+1,  motor_data[m][0]));
//            wxPuts(wxString::Format(wxT("P%i - value is: %f"), m+1,  motor_data[m][3]));
//            wxPuts(wxString::Format(wxT("S%i - value is: %f"), m+1,  motor_data[m][4]));
//            wxPuts(wxString::Format(wxT("V%i - value is: %f"), m+1,  motor_data[m][6]));
//
//            wxPuts(wxString::Format(wxT("T%i - value is: %f"), m+1,  motor_data[m][5]));
//        }
	}

//    wxPuts(wxString::Format(wxT("Time: %f"), time));
}

bool RealPanel::ParseWindows()
{
	// Parse the expressions and store them as parsed NodeExpr instances

	// Remove old expressions
	for (int i = 0; i < 8; i++)
		if (m_exprs[i] != NULL)
		{
			delete m_exprs[i];
			m_exprs[i] = NULL;
		}

	// Parse each text window and return an error if parsing failed

	if (m_cv[0]->IsEnabled()) {
		m_exprs[0] = ParserRT::Parse(m_cv[0]->GetValue(), 1);
		if (!m_exprs[0])
			return false;
	}

	if (m_cpg[0]->IsEnabled()) {
		m_exprs[1] = ParserRT::Parse(m_cpg[0]->GetValue(), 1);
		if (!m_exprs[1])
			return false;
	}

	if (m_cv[1]->IsEnabled()) {
		m_exprs[2] = ParserRT::Parse(m_cv[1]->GetValue(), 2);
		if(!m_exprs[2])
			return false;
	}

	if (m_cpg[1]->IsEnabled()) {
		m_exprs[3] = ParserRT::Parse(m_cpg[1]->GetValue(), 2);
		if (!m_exprs[3])
			return false;
	}

	if (m_cv[2]->IsEnabled()) {
		m_exprs[4] = ParserRT::Parse(m_cv[2]->GetValue(), 3);
		if (!m_exprs[4])
			return false;
	}

	if (m_cpg[2]->IsEnabled()) {
		m_exprs[5] = ParserRT::Parse(m_cpg[2]->GetValue(), 3);
		if (!m_exprs[5])
			return false;
	}

	if (m_cv[3]->IsEnabled()) {
		m_exprs[6] = ParserRT::Parse(m_cv[3]->GetValue(), 4);
		if (!m_exprs[6])
			return false;
	}

	if (m_cpg[3]->IsEnabled()) {
		m_exprs[7] = ParserRT::Parse(m_cpg[3]->GetValue(), 4);
		if (!m_exprs[7])
			return false;
	}

	if (m_term_expr != NULL)
		delete m_term_expr;

	m_term_expr = ParserRT::Parse(REAL_TerminationCondition_TextCtrl->GetValue(), 1);
	if (!m_term_expr)
		return false;

	return true;
}

bool RealPanel::SubstituteVariables()
{
	// Substitute in pointers to the NodeExpr variables

	// All the variable names
	wxString variables[] = { wxT("D"), wxT("F"), wxT("N"), wxT("P"), wxT("S"), wxT("T"), wxT("V") };

	// For each NodeExpr
	for (int i = 0; i < 8; i++)
	{
		if (m_exprs[i] != NULL)
		{
			// For each variable
			for (int j = 0; j < 7; j++)
			{
				// For each motor
				for (int k = 1; k <= 4; k++)
					if (!m_exprs[i]->Subst(variables[j] + wxString::Format(wxT("%i"), k), &motor_data[k-1][j]))
						return false;
			}
		}
	}

	// Do the same thing for the termination condition
	if (m_term_expr != NULL)
	{
		for (int j = 0; j < 7; j++)
		{
			// Substitute in the generic variable as a pointer to motor 1's data
			if (!m_term_expr->Subst(variables[j], &motor_data[0][j]))
				return false;

			for (int k = 1; k <= 4; k++)
				if (!m_term_expr->Subst(variables[j] + wxString::Format(wxT("%i"), k), &motor_data[k-1][j]))
					return false;
		}
	}

	return true;
}

bool RealPanel::Run()
{
	// Run one iteration of RealTime mode
	time = (int)t_real.GetElapsedInMilliSecs();

	//InterpretAndSet(time);

	// Instantiate all variables, evaluate, save data
	float value;

	// Interpret valid expressions, otherwise push zero onto their graph data
	if (m_exprs[0] != NULL)
	{
		value = m_exprs[0]->Interp();

		//wxPuts(wxString::Format(wxT("Value 1 is: %i"), (int) value));
		m_hand->RTSetVelocity( '1', (int)(value + 0.5) );

		m_graph_data[0][6].push_back(use280Config ? (int)(value + 0.5) : ((int)(value + 0.5)) * ((cvelmult / 16.0) / sampleperiod[0]));
	}
	else
		m_graph_data[0][6].push_back(0);

	if (m_exprs[1] != NULL)
	{
		value = m_exprs[1]->Interp();

		// wxPuts(wxString::Format(wxT("Value 2 is: %i"), (int) value));
		m_hand->RTSetGain( '1', (int)(value + 0.5) );
		m_graph_data[0][7].push_back(value);
	}
	else
		m_graph_data[0][7].push_back(0);

	if (m_exprs[2] != NULL)
	{
		value = m_exprs[2]->Interp();

		// wxPuts(wxString::Format(wxT("Value 3 is: %i"), (int) value));
		m_hand->RTSetVelocity( '2', (int)(value + 0.5) );
		m_graph_data[1][6].push_back(use280Config ? (int)(value + 0.5) : ((int)(value + 0.5)) * ((cvelmult / 16.0) / sampleperiod[1]));
	}
	else
		m_graph_data[1][6].push_back(0);

	if (m_exprs[3] != NULL)
	{
		value = m_exprs[3]->Interp();

		// wxPuts(wxString::Format(wxT("Value 4 is: %i"), (int) value));
		m_hand->RTSetGain( '2', (int)(value + 0.5) );
		m_graph_data[1][7].push_back(value);
	}
	else
		m_graph_data[1][7].push_back(0);

	if (m_exprs[4] != NULL)
	{
		value = m_exprs[4]->Interp();

		// wxPuts(wxString::Format(wxT("Value 5 is: %i"), (int) value));
		m_hand->RTSetVelocity( '3', (int)(value + 0.5) );
		m_graph_data[2][6].push_back(use280Config ? (int)(value + 0.5) : ((int)(value + 0.5)) * ((cvelmult / 16.0) / sampleperiod[2]));
	}
	else
		m_graph_data[2][6].push_back(0);

	if (m_exprs[5] != NULL)
	{
		value = m_exprs[5]->Interp();

		// wxPuts(wxString::Format(wxT("Value 6 is: %i"), (int) value));
		m_hand->RTSetGain( '3', (int)(value + 0.5) );
		m_graph_data[2][7].push_back(value);
	}
	else
		m_graph_data[2][7].push_back(0);

	if (m_exprs[6] != NULL)
	{
		value = m_exprs[6]->Interp();

		// wxPuts(wxString::Format(wxT("Value 7 is: %i"), (int) value));
		m_hand->RTSetVelocity( '4', (int)(value + 0.5) );
		m_graph_data[3][6].push_back(use280Config ? (int)(value + 0.5) : ((int)(value + 0.5)) * ((cvelmult / 16.0) / sampleperiod[3]));
	}
	else
		m_graph_data[3][6].push_back(0);

	if (m_exprs[7] != NULL)
	{
		value = m_exprs[7]->Interp();

		// wxPuts(wxString::Format(wxT("Value 8 is: %i"), (int) value));
		m_hand->RTSetGain( '4', (int)(value + 0.5) );
		m_graph_data[3][7].push_back(value);
	}
	else
		m_graph_data[3][7].push_back(0);

	//wxPuts(wxT("Interped expressions"));

	// Evaluate termination condition
	if (m_term_expr != NULL)
	{
		value = m_term_expr->Interp();
		// wxPuts(wxString::Format(wxT("Value term is: %i"), (int) value));
	}
	else
		return false;

	// Return false if the termination condition is true
	if (value)
		return false;

	if (m_hand->RTUpdate(1, 1))
		return false;

	InterpretAndSet(time);

	N++;

	// Refresh the graphs
	PlotRefresh();

	// Otherwise continue running realtime mode
	return true;
}


void RealPanel::LoadFile(wxString toLoad)
{
	// Load a file into a deque of pointers to float[4]
	// File data can then be used during the running of RealTime mode
	m_file_path = toLoad;

	m_file_path.BeforeFirst('\n');
	m_file_path.Trim();

	// Clear the deque
	for (unsigned int i = 0; i < file_data.size(); i++)
	{
		if (file_data[i] != NULL)
			delete[] file_data[i];
	}
	file_data.clear();

	// Read from file
	FILE* fp = fopen(toLoad.mb_str(), "rt");
	if (!fp)
		return;

	float* values = new float[4];

	// Scan each line and fill up the deque
	while (fscanf(fp, "%f %f %f %f", &values[0], &values[1], &values[2], &values[3]) != EOF)
	{
		wxPuts(wxString::Format(wxT("Values: %f %f %f %f\n"), values[0], values[1], values[2], values[3]));
		file_data.push_back(values);
	}

	wxPuts(wxT("Loaded File"));
	fclose(fp);

	// Show that the file is loaded
	REAL_FileName_StaticText->SetLabel(toLoad);
}


///////////////////////////////////////////////////////////////////////////////
// RealTime - Plot Data
///////////////////////////////////////////////////////////////////////////////

void RealPanel::PlotSave(wxString toSave, wxArrayInt* displayed, int n_start, int n_end)
{
	// Save the data from graphs into a ".csv" formattted file
	// n_start and n_end decide the length of the ".csv" file (if both values are the same or
	// an invalid range is selected then the entire graph is saved to the .csv file)

	if (!toSave.EndsWith(wxT(".csv")))
		toSave.Append(wxT(".csv"));

	wxPuts(wxT("Saving... ") + toSave);

	// Open a file
	FILE* fp = fopen( toSave.mb_str(), "w" );

	if (!fp)
		return;

	bool param_flags[8];

	for (unsigned int i = 0; i < 8; i++)
		param_flags[i] = false;

	// Set labels on the top denoting the columns
	wxString labels = wxT("N,");

	for (unsigned int i = 0; i < displayed->GetCount(); i++)
		param_flags[displayed->Item(i)] = true;

	for (unsigned int i = 0; i < 8; i++)
	{
		if (param_flags[i])
		{
			switch(i)
			{
				case 0:
					labels.Append(wxT("Position1,"));
					labels.Append(wxT("Position2,"));
					labels.Append(wxT("Position3,"));
					labels.Append(wxT("Position4,"));
					break;
				case 1:
					labels.Append(wxT("Velocity1,"));
					labels.Append(wxT("Velocity2,"));
					labels.Append(wxT("Velocity3,"));
					labels.Append(wxT("Velocity4,"));
					break;
				case 2:
					labels.Append(wxT("Strain1,"));
					labels.Append(wxT("Strain2,"));
					labels.Append(wxT("Strain3,"));
					labels.Append(wxT("Strain4,"));
					break;
				case 3:
					labels.Append(wxT("Delta1,"));
					labels.Append(wxT("Delta2,"));
					labels.Append(wxT("Delta3,"));
					labels.Append(wxT("Delta4,"));
					break;
				case 4:
					labels.Append(wxT("F_Data1,"));
					labels.Append(wxT("F_Data2,"));
					labels.Append(wxT("F_Data3,"));
					labels.Append(wxT("F_Data4,"));
					break;
				case 5:
					labels.Append(wxT("Time1,"));
					labels.Append(wxT("Time2,"));
					labels.Append(wxT("Time3,"));
					labels.Append(wxT("Time4,"));
					break;
				case 6:
					labels.Append(wxT("Ctrl_Vel1,"));
					labels.Append(wxT("Ctrl_Vel2,"));
					labels.Append(wxT("Ctrl_Vel3,"));
					labels.Append(wxT("Ctrl_Vel4,"));
					break;
				case 7:
					labels.Append(wxT("Ctrl_Gain1,"));
					labels.Append(wxT("Ctrl_Gain2,"));
					labels.Append(wxT("Ctrl_Gain3,"));
					labels.Append(wxT("Ctrl_Gain4,"));
					break;
				default:
					break;
			}
		}
	}

	labels = labels.BeforeLast(',');

	char buf[2048];

	// Write labels to the file
	strcpy(buf, labels.mb_str());
	fprintf(fp, "%s\n", buf);

	// Error checking from n start to end (for saving only part of a graph)
	if (n_start < 0)
		n_start = 0;
	else if ((unsigned int)n_start > m_graph_data[0][0].size())
		n_start = m_graph_data[0][0].size();

	if (n_end < 0)
		n_end = 0;
	else if ((unsigned int)n_end > m_graph_data[0][0].size())
		n_end = m_graph_data[0][0].size();

	if (n_end < n_start)
		n_end = n_start;
	else if(n_start == n_end)
	{
		n_start = 0;
		n_end = m_graph_data[0][0].size();
	}

	// Write a line of data for selected variables
	for (int i = n_start; i < n_end; i++)
	{
		wxString buffer = wxString::Format(wxT("%i,"), i);

		for (unsigned int j = 0; j < 8; j++)
		{
			if (param_flags[j])
			{
				buffer.Append(wxString::Format(wxT("%f,"), (m_graph_data[0][j])[i]));
				buffer.Append(wxString::Format(wxT("%f,"), (m_graph_data[1][j])[i]));
				buffer.Append(wxString::Format(wxT("%f,"), (m_graph_data[2][j])[i]));
				buffer.Append(wxString::Format(wxT("%f,"), (m_graph_data[3][j])[i]));
			}
		}

		// Save the variable
		buffer = buffer.BeforeLast(',');
		strcpy(buf, buffer.mb_str());
		fprintf(fp, "%s\n", buf);
	}

	// Close the file
	fclose(fp);
}


void RealPanel::PlotRefresh()
{
	// Update the graph drawing area

	// Render a really large graph first
	for (unsigned int i = 0; i < 4; i++)
		m_graphs[i]->Fit(-.20 * N, 1.2 * N,-50000,50000);

	// Get the extrema of all functions plotted
	double graph_low = GraphData::getLowest();
	double graph_high = GraphData::getHighest();

	// Redraw the graph based on the extrema
	for (unsigned int i = 0; i < 4; i++)
		m_graphs[i]->Fit(-.20 * N , 1.2 * N,(int)graph_low - .05 * (int)graph_low, (int)graph_high + .05 * (int)graph_high);
}


void RealPanel::PlotUpdateDisplay(wxArrayInt *toDisplay)
{
	if (toDisplay)
	{
		// Set all graphs invisible
		for (unsigned int i = 0; i < 4; i++)
			for (unsigned int j = 0; j < m_plots[i].size(); j++)
				(m_plots[i])[j]->SetVisible(false);

		// Reset extrema
		GraphData::resetExtrema();

		// Set selected graphs visible
		for (unsigned int i = 0; i < toDisplay->GetCount(); i++)
		{
			(m_plots[0])[toDisplay->Item(i)]->SetVisible(true);
			(m_plots[1])[toDisplay->Item(i)]->SetVisible(true);
			(m_plots[2])[toDisplay->Item(i)]->SetVisible(true);
			(m_plots[3])[toDisplay->Item(i)]->SetVisible(true);
		}

	}
}


void RealPanel::Service()
{
	if (m_real_before_running)
	{
		// If execute before is checked
		if (REAL_ExecuteBefore_CheckBox->GetValue())
		{
			// run supervisory code until done
			// if there is an error running supervisory mode stop realtime mode completely
			if (!m_super_panel->SupervisoryExternalRun())
			{
				m_real_before_running = false;
				m_real_after_running = false;
				m_real_realtime_running = false;

				m_real_plot_panel->RTStopped(); // signal plot panel that RealTime mode finished
			}
		}

		// If supervisory mode is done, prepare RT mode
		if (m_super_panel->ExternalRunDone())
		{
			if (PrepareRT())
			{
				wxPuts(wxT("Prepared RT..."));
				m_real_before_running = false;
				m_real_realtime_running = true; // run RealTime mode next
			}
			else
			{
				// Unable to prepare RealTime mode, stop running
				wxPuts(wxT("Did not prepare RT"));
				m_real_before_running = false;
				m_real_realtime_running = false;

				REAL_Run_Button->Enable(1);
				REAL_Abort_Button->Enable(0);

				m_real_plot_panel->RTStopped(); // signal plot panel that RealTime mode finished
			}
		}
	}
	else if (m_real_realtime_running)
	{
		// Run RealTime mode until finished
		if (!Run())
		{
			printf("RealTime Run() done\n");

			// RealTime finished running
			m_real_realtime_running = false;
			m_real_after_running = true;

			m_hand->RTAbort();
			m_hand->Command("T");

			// Prepare the execute after supervisory code
			m_super_panel->PrepareSupervisoryExternalRun(REAL_After_TextCtrl->GetValue());
			// wxPuts(wxT("Done RT..."));
		}
		// wxPuts(wxT("Running RT..."));
	}
	else if (m_real_after_running)
	{
		// Run the supervisory after code
		// If execute after is enabled
		if (REAL_ExecuteAfter_CheckBox->GetValue())
		{
			// Continue running while there are no errors
			bool cycle;
			wxPuts(wxT("Trying to run super after..."));
			if (!m_super_panel->SupervisoryExternalRun(&cycle) || cycle)
			{
				m_real_before_running = false;
				m_real_after_running = false;
				m_real_realtime_running = false;

				if (!cycle)
				{
					wxPuts(wxT("Super after error..."));
					REAL_Run_Button->Enable(1);
					REAL_Abort_Button->Enable(0);

					m_real_plot_panel->RTStopped(); // signal plot panel that RealTime mode finished
				}
			}

			if (cycle)
				// "CYCLE" found, restart
				RTRun();
		}
		else
		{
			m_real_after_running = false;
			REAL_Run_Button->Enable(1);
			REAL_Abort_Button->Enable(0);

			m_real_plot_panel->RTStopped(); // signal plot panel that RealTime mode finished
		}

		// If supervisory mode is done, set done
		if (m_super_panel->ExternalRunDone())
		{
			wxPuts(wxT("Super after done..."));
			m_real_after_running = false;
			REAL_Run_Button->Enable(1);
			REAL_Abort_Button->Enable(0);

			m_real_plot_panel->RTStopped(); // signal plot panel that RealTime mode finished
		}
		wxPuts(wxT("Super after not done..."));
	}
}

int RealPanel::RTRun()
{
	REAL_Run_Button->Enable(0);
	REAL_Abort_Button->Enable(1);

	for (int m = 0; m < 4; m++)
		for (int i = 0; i < 7; i++)
			motor_data[m][i] = 0;

	if (REAL_ExecuteBefore_CheckBox->GetValue())
	{
		m_real_before_running = true;
		m_super_panel->PrepareSupervisoryExternalRun(REAL_Before_TextCtrl->GetValue());
	}
	else
	{
		if (PrepareRT())
		{
			PlotUpdateDisplay(m_real_plot_panel->getRTListboxSelections());

			m_real_realtime_running = true;
		}
		else
		{
			wxPuts(wxT("Did not prepare RT"));

			REAL_Run_Button->Enable(1);
			REAL_Abort_Button->Enable(0);
			return -1;
		}
	}
	return 0;
}


void RealPanel::Abort()
{
	// Abort RealTime mode
	REAL_Run_Button->Enable(1);
	REAL_Abort_Button->Enable(0);
	m_hand->RTAbort();
	m_hand->Command("T");
}


void RealPanel::EnterTab()
{
	if (use280Config)
	{
		REAL_Delta_CheckBox->Enable(0);
		REAL_FVelMultiplier_TextCtrl->Enable(0);
		REAL_DeltaMultiplier_TextCtrl->Enable(0);
		REAL_CVelMultiplier_TextCtrl->Enable(0);
		REAL_ControlPropGain_CheckBox->Enable(0);
	}
}

void RealPanel::LeaveTab()
{
	RTAbort();
	m_hand->Command("T");
}

bool RealPanel::RTIsRunning()
{
	return m_real_before_running || m_real_realtime_running || m_real_after_running;
}

void RealPanel::RTAbort()
{
	REAL_Run_Button->Enable(1);
	REAL_Abort_Button->Enable(0);

	if (RTIsRunning())
	{
		if (m_real_realtime_running)
		{
			m_hand->RTAbort();
			m_hand->Command("T");
		}

		m_real_after_running = false;
		m_real_before_running = false;
		m_real_realtime_running = false;
	}
}
