#include "RealPlotPanel.h"

//(*InternalHeaders(RealPlotPanel)
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
#include <wx/listbox.h>
#include <wx/statbox.h>
#include <wx/intl.h>
#include <wx/button.h>
#include <wx/string.h>
//*)


#include "BHand.h"

#include "RealPanel.h"
#include "Super_Tab/SuperPanel.h"



//(*IdInit(RealPlotPanel)
const long RealPlotPanel::ID_STATICBOX1 = wxNewId();
const long RealPlotPanel::ID_STATICBOX2 = wxNewId();
const long RealPlotPanel::ID_RT_Shortcuts_StaticBox = wxNewId();
const long RealPlotPanel::ID_RTPD_LockAspect_CheckBox = wxNewId();
const long RealPlotPanel::ID_RTPD_Run_Button = wxNewId();
const long RealPlotPanel::ID_RTPD_Abort_Button = wxNewId();
const long RealPlotPanel::ID_RTPD_ListBox = wxNewId();
const long RealPlotPanel::ID_RTPD_NStart_StaticText = wxNewId();
const long RealPlotPanel::ID_RTPD_NEnd_StaticText = wxNewId();
const long RealPlotPanel::ID_RTPD_NStart_TextCtrl = wxNewId();
const long RealPlotPanel::ID_RTPD_NEnd_TextCtrl = wxNewId();
const long RealPlotPanel::ID_RTPD_Refresh_Button = wxNewId();
const long RealPlotPanel::ID_RTPD_SavePlot_Button = wxNewId();
const long RealPlotPanel::ID_STATICTEXT1 = wxNewId();
const long RealPlotPanel::ID_STATICTEXT2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(RealPlotPanel,wxPanel)
	//(*EventTable(RealPlotPanel)
	//*)
END_EVENT_TABLE()

RealPlotPanel::RealPlotPanel(wxWindow* parent, BHand *hand, RealPanel *real_panel, SuperPanel *super_panel, wxWindowID id, const wxPoint& pos, const wxSize& size)
	: m_hand(hand), m_real_panel(real_panel), m_super_panel(super_panel)
{
	//(*Initialize(RealPlotPanel)
	Create(parent, wxID_ANY, wxDefaultPosition, wxSize(803,636), wxTAB_TRAVERSAL, _T("wxID_ANY"));
	StaticBox1 = new wxStaticBox(this, ID_STATICBOX1, _("Graph Visualization"), wxPoint(632,540), wxSize(144,96), 0, _T("ID_STATICBOX1"));
	StaticBox2 = new wxStaticBox(this, ID_STATICBOX2, _("Plot Data"), wxPoint(632,172), wxSize(144,360), 0, _T("ID_STATICBOX2"));
	RT_Shortcuts_StaticBox = new wxStaticBox(this, ID_RT_Shortcuts_StaticBox, _("Real Time Shortcuts"), wxPoint(632,28), wxSize(144,136), 0, _T("ID_RT_Shortcuts_StaticBox"));
	RTPD_LockAspect_CheckBox = new wxCheckBox(this, ID_RTPD_LockAspect_CheckBox, _("Lock Aspect"), wxPoint(652,568), wxSize(104,20), 0, wxDefaultValidator, _T("ID_RTPD_LockAspect_CheckBox"));
	RTPD_LockAspect_CheckBox->SetValue(false);
	RTPD_Run_Button = new wxButton(this, ID_RTPD_Run_Button, _("Run"), wxPoint(668,64), wxSize(75,28), 0, wxDefaultValidator, _T("ID_RTPD_Run_Button"));
	RTPD_Abort_Button = new wxButton(this, ID_RTPD_Abort_Button, _("Abort"), wxPoint(668,112), wxSize(75,28), 0, wxDefaultValidator, _T("ID_RTPD_Abort_Button"));
	RTPD_Abort_Button->Disable();
	RTPD_ListBox = new wxListBox(this, ID_RTPD_ListBox, wxPoint(644,192), wxSize(120,204), 0, 0, wxLB_MULTIPLE, wxDefaultValidator, _T("ID_RTPD_ListBox"));
	RTPD_ListBox->Append(_("Position"));
	RTPD_ListBox->Append(_("Velocity"));
	RTPD_ListBox->Append(_("Strain"));
	RTPD_ListBox->Append(_("Delta Position"));
	RTPD_ListBox->Append(_("File Data"));
	RTPD_ListBox->Append(_("Time Stamp"));
	RTPD_ListBox->Append(_("Ctrl Velocity"));
	RTPD_ListBox->Append(_("Ctrl Prop. Gain"));
	RTPD_NStart_StaticText = new wxStaticText(this, ID_RTPD_NStart_StaticText, _("N ="), wxPoint(672,432), wxDefaultSize, 0, _T("ID_RTPD_NStart_StaticText"));
	RTPD_NEnd_StaticText = new wxStaticText(this, ID_RTPD_NEnd_StaticText, _("to"), wxPoint(676,464), wxDefaultSize, 0, _T("ID_RTPD_NEnd_StaticText"));
	RTPD_NStart_TextCtrl = new wxTextCtrl(this, ID_RTPD_NStart_TextCtrl, _("0"), wxPoint(700,432), wxSize(44,20), wxTE_RIGHT, wxDefaultValidator, _T("ID_RTPD_NStart_TextCtrl"));
	RTPD_NEnd_TextCtrl = new wxTextCtrl(this, ID_RTPD_NEnd_TextCtrl, _("0"), wxPoint(700,464), wxSize(44,20), wxTE_RIGHT, wxDefaultValidator, _T("ID_RTPD_NEnd_TextCtrl"));
	RTPD_Refresh_Button = new wxButton(this, ID_RTPD_Refresh_Button, _("Refresh"), wxPoint(668,596), wxSize(75,28), 0, wxDefaultValidator, _T("ID_RTPD_Refresh_Button"));
	RTPD_SavePlot_Button = new wxButton(this, ID_RTPD_SavePlot_Button, _("Save"), wxPoint(668,492), wxSize(75,28), 0, wxDefaultValidator, _T("ID_RTPD_SavePlot_Button"));
	RTPD_SavePlot_Button->SetToolTip(_("Save Plot data to a \".csv\" file"));
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Plot Range"), wxPoint(660,408), wxSize(84,13), 0, _T("ID_STATICTEXT1"));
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("The domain contains the number of control cycles"), wxPoint(152,638), wxSize(480,21), 0, _T("ID_STATICTEXT2"));
	//*)

	init();

	//!Real Time - Plot Data
	Connect(ID_RTPD_ListBox, wxEVT_COMMAND_LISTBOX_SELECTED, (wxObjectEventFunction)&RealPlotPanel::OnRTListBox);
	Connect(ID_RTPD_Refresh_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPlotPanel::OnRTPlotRefresh);
	Connect(ID_RTPD_SavePlot_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPlotPanel::OnRTPlotSave);
	Connect(ID_RTPD_LockAspect_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&RealPlotPanel::OnRTPlotLockAspect);

	Connect(ID_RTPD_Run_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPlotPanel::OnRTRun);
	Connect(ID_RTPD_Abort_Button, wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&RealPlotPanel::OnRTAbort);
}

RealPlotPanel::~RealPlotPanel()
{
    m_histogram_realtime[0]->DelAllLayers(true, false);
    m_histogram_realtime[1]->DelAllLayers(true, false);
    m_histogram_realtime[2]->DelAllLayers(true, false);
    m_histogram_realtime[3]->DelAllLayers(true, false);

	delete m_histogram_realtime[0];
	delete m_histogram_realtime[1];
	delete m_histogram_realtime[2];
	delete m_histogram_realtime[3];

	delete RT_Listbox_Selections;

	//(*Destroy(RealPlotPanel)
	//*)
}

void RealPlotPanel::init()
{
    RT_Listbox_Selections = new wxArrayInt();

    // Initialize graph widgets for the Real Time Plot Data Tab
    m_histogram_realtime[0] = new mpWindow(this, -1, wxPoint(55, 35), wxSize(568,150), wxSUNKEN_BORDER);
    m_histogram_realtime[1] = new mpWindow(this, -1, wxPoint(55,185), wxSize(568,150), wxSUNKEN_BORDER);
    m_histogram_realtime[2] = new mpWindow(this, -1, wxPoint(55,335), wxSize(568,150), wxSUNKEN_BORDER);
    m_histogram_realtime[3] = new mpWindow(this, -1, wxPoint(55,485), wxSize(568,150), wxSUNKEN_BORDER);

    mpScaleX* xaxis;
    mpScaleY* yaxis;

    for (unsigned int i = 0; i < 4; i++)
    {
        xaxis = new mpScaleX(wxT("X (N)"), mpALIGN_BOTTOM, true, mpX_NORMAL);
        yaxis = new mpScaleY(wxT(""), mpALIGN_LEFT, true);

        m_histogram_realtime[i]->AddLayer( xaxis );
        m_histogram_realtime[i]->AddLayer( yaxis );

        xaxis->SetDrawOutsideMargins(false);
        yaxis->SetDrawOutsideMargins(false);

        m_histogram_realtime[i]->SetScaleX(10.0);
        m_histogram_realtime[i]->SetScaleY(10.0);
        m_histogram_realtime[i]->SetScr(10,10);

        // NOTE: needed on windows, include it anyway on linux
        m_histogram_realtime[i]->EnableDoubleBuffer(true);
        m_histogram_realtime[i]->SetMargins(0, 90, 20, 40);
        m_histogram_realtime[i]->LockAspect(false);
    }
}


///////////////////////////////////////////////////////////////////////////////
// RealTime - Plot Data
///////////////////////////////////////////////////////////////////////////////

void RealPlotPanel::OnRTPlotSave(wxCommandEvent& event)
{
	// Save the plot data of all the graphs into a ".csv" file
	// Specification of the csv format used is in the Real.cpp file
	long n_start, n_end;

	if (!(RTPD_NStart_TextCtrl->GetValue()).ToLong(&n_start))
		return;

	if (!(RTPD_NEnd_TextCtrl->GetValue()).ToLong(&n_end))
		return;

	// Use file save common dialog box for choosing CSV filename
	wxFileDialog FileSave(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_SAVE|wxFD_OVERWRITE_PROMPT, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));

	FileSave.SetWildcard(wxT("Real Time Plot Data (*.csv)|*.csv"));

	if (FileSave.ShowModal() == wxID_OK)
		m_real_panel->PlotSave(FileSave.GetPath(), RT_Listbox_Selections, n_start, n_end);

	FileSave.SetPath(wxT(""));
}

void RealPlotPanel::OnRTPlotRefresh(wxCommandEvent& event)
{
	m_real_panel->PlotRefresh();
}

void RealPlotPanel::OnRTPlotLockAspect(wxCommandEvent& event)
{
	// Locks/Unlocks the apsect ratio accordingly and redraws
	bool lock = RTPD_LockAspect_CheckBox->GetValue();

	for(unsigned int i = 0; i < 4; i++)
		m_histogram_realtime[i]->LockAspect(lock);

	m_real_panel->PlotRefresh();
}

void RealPlotPanel::OnRTListBox(wxCommandEvent& event)
{
	// Toggles graphs on/off and redraws
	int id = event.GetSelection();

	// Update the listbox

	// check to see if the selection is the in selections array
	// if not, add it
	if (wxNOT_FOUND == RT_Listbox_Selections->Index(id))
	{
		RT_Listbox_Selections->Add(id);
		// if it is in the array
		// remove it from the array and deselect it from the ListBox
	}
	else
	{
		RT_Listbox_Selections->Remove(id);
		RTPD_ListBox->Deselect(id);
	}

	// then make sure all previously selected elements are selected
	for (unsigned int i = 0; i < RT_Listbox_Selections->GetCount(); i++)
		RTPD_ListBox->Select(RT_Listbox_Selections->Item(i));

	// refresh and update calls are needed otherwise graph won't redraw correctly

	// Update the graphs that are displayed
	m_real_panel->PlotUpdateDisplay(RT_Listbox_Selections);

	Refresh(TRUE);
	Update();

	// Refresh the graphs
	m_real_panel->PlotRefresh();

	Refresh(TRUE);
	Update();
}

void RealPlotPanel::RTStopped()
{
	RTPD_Run_Button->Enable(1);
	RTPD_Abort_Button->Enable(0);
}

void RealPlotPanel::OnRTRun()
{
	RTPD_Run_Button->Enable(0);
	RTPD_Abort_Button->Enable(1);
	if (m_real_panel->RTRun())
	{
		RTPD_Run_Button->Enable(1);
		RTPD_Abort_Button->Enable(0);
	}
}

void RealPlotPanel::OnRTAbort()
{
	RTPD_Run_Button->Enable(1);
	RTPD_Abort_Button->Enable(0);
	if (m_real_panel->RTIsRunning())
		m_real_panel->RTAbort();
}

void RealPlotPanel::LeaveTab()
{
	RTPD_Run_Button->Enable(1);
	RTPD_Abort_Button->Enable(0);
	if (m_real_panel->RTIsRunning())
		m_real_panel->RTAbort();
}
