#ifndef REALPLOTPANEL_H
#define REALPLOTPANEL_H

#include <wx/filedlg.h>

//(*Headers(RealPlotPanel)
#include <wx/panel.h>
class wxStaticBox;
class wxCheckBox;
class wxTextCtrl;
class wxListBox;
class wxStaticText;
class wxButton;
//*)


class mpWindow;

class BHand;
class BHControlFrame;

class RealPanel;
class SuperPanel;


class RealPlotPanel: public wxPanel
{
public:

	RealPlotPanel(wxWindow* parent, BHand *hand, RealPanel *real_panel, SuperPanel *super_panel, wxWindowID id=wxID_ANY, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize);
	virtual ~RealPlotPanel();

	wxArrayInt* getRTListboxSelections() { return RT_Listbox_Selections; }

	mpWindow* getHistogramRealTime(int i) { return m_histogram_realtime[i]; }

	void RTStopped();
	void LeaveTab();

private:

	BHand *m_hand;

	RealPanel *m_real_panel;
	SuperPanel *m_super_panel;

	wxArrayInt* RT_Listbox_Selections;

	mpWindow* m_histogram_realtime[4];

	void init();

	// Event Handlers
	void OnRTRun();
	void OnRTAbort();

	void OnRTPlotSave(wxCommandEvent& event);
	void OnRTPlotLockAspect(wxCommandEvent& event);
	void OnRTListBox(wxCommandEvent& event);
	void OnRTPlotRefresh(wxCommandEvent& event);

	//(*Handlers(RealPlotPanel)
	void OnRTPD_Run_ButtonClick(wxCommandEvent& event);
	//*)

	//(*Declarations(RealPlotPanel)
	wxStaticText* RTPD_NStart_StaticText;
	wxStaticText* StaticText2;
	wxTextCtrl* RTPD_NStart_TextCtrl;
	wxStaticBox* RT_Shortcuts_StaticBox;
	wxStaticText* StaticText1;
	wxListBox* RTPD_ListBox;
	wxStaticBox* StaticBox1;
	wxStaticBox* StaticBox2;
	wxButton* RTPD_Refresh_Button;
	wxButton* RTPD_Run_Button;
	wxButton* RTPD_SavePlot_Button;
	wxButton* RTPD_Abort_Button;
	wxCheckBox* RTPD_LockAspect_CheckBox;
	wxTextCtrl* RTPD_NEnd_TextCtrl;
	wxStaticText* RTPD_NEnd_StaticText;
	//*)

	//(*Identifiers(RealPlotPanel)
	static const long ID_STATICBOX1;
	static const long ID_STATICBOX2;
	static const long ID_RT_Shortcuts_StaticBox;
	static const long ID_RTPD_LockAspect_CheckBox;
	static const long ID_RTPD_Run_Button;
	static const long ID_RTPD_Abort_Button;
	static const long ID_RTPD_ListBox;
	static const long ID_RTPD_NStart_StaticText;
	static const long ID_RTPD_NEnd_StaticText;
	static const long ID_RTPD_NStart_TextCtrl;
	static const long ID_RTPD_NEnd_TextCtrl;
	static const long ID_RTPD_Refresh_Button;
	static const long ID_RTPD_SavePlot_Button;
	static const long ID_STATICTEXT1;
	static const long ID_STATICTEXT2;
	//*)

	DECLARE_EVENT_TABLE()
};

#endif
