#include "SuperPanel.h"


//(*InternalHeaders(SuperPanel)
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
#include <wx/radiobut.h>
#include <wx/statbox.h>
#include <wx/choice.h>
#include <wx/intl.h>
#include <wx/button.h>
#include <wx/string.h>
//*)

#include <wx/wx.h>
#include <wx/frame.h>
#include <wx/file.h>
#include <wx/filedlg.h>
#include <wx/tokenzr.h>

#include "BHand.h"

#include "Common/CppGenerator.h"


#define ENABLE_DEBUG false


void AddSomeText(wxTextCtrl *aChatWindow, wxString s) // Found on wxWidgets Wiki
{
    // HACK: Under Windows (using wxTE_RICH2) we have trouble ensuring that the last
    // entered line is really at the bottom of the screen. We jump through some
    // hoops to get this working.

    // Count number of newlines (i.e lines)
    int lines = 0;
    const char* cstr = (const char *)s.c_str();
    for ( ; *cstr ; ++cstr)
        if (*cstr == '\n')
            ++lines;

    // Dance...
    aChatWindow->Freeze();               // Freeze the window to prevent scrollbar jumping
    aChatWindow->AppendText(s);          // Add the text
    aChatWindow->ScrollLines(lines + 1); // Scroll down correct number of lines + one (the extra line is important for some cases!)
    aChatWindow->ShowPosition(aChatWindow->GetLastPosition()); // Ensure the last line is shown at the very bottom of the window
    aChatWindow->Thaw();                 // Allow the window to redraw
	aChatWindow->Update();
}


//(*IdInit(SuperPanel)
const long SuperPanel::ID_SUPER_ControlPanel_StaticBox = wxNewId();
const long SuperPanel::ID_SUPER_INIT_STATICBOX = wxNewId();
const long SuperPanel::ID_MOTOR_MOVEMENT_VALUES_STATICBOX = wxNewId();
const long SuperPanel::ID_SUPER_Parameters_StaticBox = wxNewId();
const long SuperPanel::ID_StaticBoxMotorMovement = wxNewId();
const long SuperPanel::ID_MiscStaticBox = wxNewId();
const long SuperPanel::ID_NOTES_TEXTCTRL = wxNewId();
const long SuperPanel::ID_SUPER_Terminal_StaticBox = wxNewId();
const long SuperPanel::ID_SUPER_SessionHistory_StaticText = wxNewId();
const long SuperPanel::ID_SUPER_SessionHistory_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_AutoRun_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_Run_Button = wxNewId();
const long SuperPanel::ID_SUPER_Copy_Button = wxNewId();
const long SuperPanel::ID_SUPER_CommandBuffer_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_CommandBuffer_StaticText = wxNewId();
const long SuperPanel::ID_SUPER_GenerateCpp_Button = wxNewId();
const long SuperPanel::ID_SUPER_ClearSession_Button = wxNewId();
const long SuperPanel::ID_SUPER_TerminalLoad_Button = wxNewId();
const long SuperPanel::ID_SUPER_TerminalSave_Button = wxNewId();
const long SuperPanel::ID_SUPER_ClearBuffer_Button = wxNewId();
const long SuperPanel::ID_SUPER_Motors_StaticBox = wxNewId();
const long SuperPanel::ID_SUPER_Motor1_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_Motor2_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_Motor3_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_Motor4_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_Open_Button = wxNewId();
const long SuperPanel::ID_SUPER_Close_Button = wxNewId();
const long SuperPanel::ID_SUPER_TorqueOpen_Button = wxNewId();
const long SuperPanel::ID_SUPER_TorqueClose_Button = wxNewId();
const long SuperPanel::ID_SUPER_GoHome_Button = wxNewId();
const long SuperPanel::ID_SUPER_GoDefault_Button = wxNewId();
const long SuperPanel::ID_SUPER_Initialize_Button = wxNewId();
const long SuperPanel::ID_SUPER_StopMotor_Button = wxNewId();
const long SuperPanel::ID_SUPER_Abort_Button = wxNewId();
const long SuperPanel::ID_SUPER_MovementAmount_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_GoPosition_Button = wxNewId();
const long SuperPanel::ID_SUPER_StepOpen_Button = wxNewId();
const long SuperPanel::ID_SUPER_StepClose_Button = wxNewId();
const long SuperPanel::ID_SUPER_Default_Button = wxNewId();
const long SuperPanel::ID_SUPER_ControlLoad_Button = wxNewId();
const long SuperPanel::ID_SUPER_ControlSave_Button = wxNewId();
const long SuperPanel::ID_SUPER_Delay_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_Temperature_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_ms_StaticText = wxNewId();
const long SuperPanel::ID_SUPER_C_StaticText = wxNewId();
const long SuperPanel::ID_SUPER_Delay_Button = wxNewId();
const long SuperPanel::ID_SUPER_Temperature_Button = wxNewId();
const long SuperPanel::ID_SUPER_Parameters_Choice = wxNewId();
const long SuperPanel::ID_SUPER_ParametersMotor1_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_ParametersMotor2_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_ParametersMotor3_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_ParametersMotor4_CheckBox = wxNewId();
const long SuperPanel::ID_SUPER_ParametersMotor1_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_ParametersMotor2_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_ParametersMotor3_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_ParametersMotor4_TextCtrl = wxNewId();
const long SuperPanel::ID_SUPER_ParameterGet_Button = wxNewId();
const long SuperPanel::ID_SUPER_ParameterSet_Button = wxNewId();
const long SuperPanel::ID_SUPER_ParameterSetDPAndGo_Button = wxNewId();
const long SuperPanel::ID_SUPER_terminal_ascii_RadioButton = wxNewId();
const long SuperPanel::ID_SUPER_terminal_cpp_RadioButton = wxNewId();
const long SuperPanel::ID_EncoderTicksStaticText = wxNewId();
const long SuperPanel::ID_StaticTextProperty = wxNewId();
const long SuperPanel::ID_StaticTextCategory = wxNewId();
const long SuperPanel::ID_SUPER_Parameters_Category_Choice = wxNewId();
const long SuperPanel::ID_PURPOSE_STATIC_TEXT = wxNewId();
const long SuperPanel::ID_PURPOSE_TEXTCTRL = wxNewId();
const long SuperPanel::ID_NOTES_STATICTEXT = wxNewId();
const long SuperPanel::ID_MOTOR_MOVEMENT_INCLUDED_CHECKBOX = wxNewId();
//*)

BEGIN_EVENT_TABLE(SuperPanel,wxPanel)
	//(*EventTable(SuperPanel)
	//*)
END_EVENT_TABLE()

SuperPanel::SuperPanel(wxWindow* parent, BHand *hand, wxWindowID id, const wxPoint& pos, const wxSize& size)
	: m_hand(hand), m_supervise_running(false), shouldAbort(false), m_response(NULL), ascii_selected(true), m_panelEnabled(false) //, cpp_session(wxT(""))
{
	//(*Initialize(SuperPanel)
	Create(parent, wxID_ANY, wxDefaultPosition, wxSize(776,663), wxTAB_TRAVERSAL, _T("wxID_ANY"));
	SUPER_ControlPanel_StaticBox = new wxStaticBox(this, ID_SUPER_ControlPanel_StaticBox, _("Control Panel"), wxPoint(4,304), wxSize(768,352), 0, _T("ID_SUPER_ControlPanel_StaticBox"));
	SUPER_INIT_StaticBox = new wxStaticBox(this, ID_SUPER_INIT_STATICBOX, _("Init, etc."), wxPoint(20,448), wxSize(96,100), 0, _T("ID_SUPER_INIT_STATICBOX"));
	MOTOR_MOVEMENT_VALUES_StaticBox = new wxStaticBox(this, ID_MOTOR_MOVEMENT_VALUES_STATICBOX, _("Motor Movement (with or without values)"), wxPoint(124,448), wxSize(300,100), 0, _T("ID_MOTOR_MOVEMENT_VALUES_STATICBOX"));
	SUPER_Parameters_StaticBox = new wxStaticBox(this, ID_SUPER_Parameters_StaticBox, _("Properties"), wxPoint(432,320), wxSize(332,324), 0, _T("ID_SUPER_Parameters_StaticBox"));
	StaticBoxMotorMovement = new wxStaticBox(this, ID_StaticBoxMotorMovement, _("Motor Movement (without values)"), wxPoint(124,328), wxSize(300,116), 0, _T("ID_StaticBoxMotorMovement"));
	MiscStaticBox = new wxStaticBox(this, ID_MiscStaticBox, _("Misc"), wxPoint(20,552), wxSize(404,92), 0, _T("ID_MiscStaticBox"));
	notesTextCtrl = new wxTextCtrl(this, ID_NOTES_TEXTCTRL, _("The notes for this property are ..."), wxPoint(520,448), wxSize(228,36), wxTE_MULTILINE|wxTE_READONLY, wxDefaultValidator, _T("ID_NOTES_TEXTCTRL"));
	SUPER_Terminal_StaticBox = new wxStaticBox(this, ID_SUPER_Terminal_StaticBox, _("Terminal"), wxPoint(32,24), wxSize(696,264), 0, _T("ID_SUPER_Terminal_StaticBox"));
	SUPER_SessionHistory_StaticText = new wxStaticText(this, ID_SUPER_SessionHistory_StaticText, _("Session History"), wxPoint(56,48), wxSize(132,17), 0, _T("ID_SUPER_SessionHistory_StaticText"));
	SUPER_SessionHistory_TextCtrl = new wxTextCtrl(this, ID_SUPER_SessionHistory_TextCtrl, wxEmptyString, wxPoint(56,72), wxSize(264,160), wxTE_AUTO_SCROLL|wxTE_MULTILINE|wxTE_READONLY|wxHSCROLL|wxTE_RICH2|wxDOUBLE_BORDER|wxVSCROLL, wxDefaultValidator, _T("ID_SUPER_SessionHistory_TextCtrl"));
	SUPER_AutoRun_CheckBox = new wxCheckBox(this, ID_SUPER_AutoRun_CheckBox, _("Auto Run"), wxPoint(612,48), wxDefaultSize, 0, wxDefaultValidator, _T("ID_SUPER_AutoRun_CheckBox"));
	SUPER_AutoRun_CheckBox->SetValue(true);
	SUPER_Run_Button = new wxButton(this, ID_SUPER_Run_Button, _("<- Run"), wxPoint(344,84), wxSize(80,28), 0, wxDefaultValidator, _T("ID_SUPER_Run_Button"));
	SUPER_Copy_Button = new wxButton(this, ID_SUPER_Copy_Button, _("Copy ->"), wxPoint(344,192), wxSize(80,28), 0, wxDefaultValidator, _T("ID_SUPER_Copy_Button"));
	SUPER_CommandBuffer_TextCtrl = new wxTextCtrl(this, ID_SUPER_CommandBuffer_TextCtrl, wxEmptyString, wxPoint(448,72), wxSize(256,160), wxTE_PROCESS_ENTER|wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2, wxDefaultValidator, _T("ID_SUPER_CommandBuffer_TextCtrl"));
	SUPER_CommandBuffer_StaticText = new wxStaticText(this, ID_SUPER_CommandBuffer_StaticText, _("Command Buffer"), wxPoint(448,48), wxSize(148,17), 0, _T("ID_SUPER_CommandBuffer_StaticText"));
	SUPER_GenerateCpp_Button = new wxButton(this, ID_SUPER_GenerateCpp_Button, _("Generate C++"), wxPoint(72,240), wxSize(106,28), 0, wxDefaultValidator, _T("ID_SUPER_GenerateCpp_Button"));
	SUPER_ClearSession_Button = new wxButton(this, ID_SUPER_ClearSession_Button, _("Clear Session"), wxPoint(192,240), wxSize(106,28), 0, wxDefaultValidator, _T("ID_SUPER_ClearSession_Button"));
	SUPER_TerminalLoad_Button = new wxButton(this, ID_SUPER_TerminalLoad_Button, _("Load"), wxPoint(448,240), wxSize(64,28), 0, wxDefaultValidator, _T("ID_SUPER_TerminalLoad_Button"));
	SUPER_TerminalSave_Button = new wxButton(this, ID_SUPER_TerminalSave_Button, _("Save"), wxPoint(520,240), wxSize(64,28), 0, wxDefaultValidator, _T("ID_SUPER_TerminalSave_Button"));
	SUPER_ClearBuffer_Button = new wxButton(this, ID_SUPER_ClearBuffer_Button, _("Clear Buffer"), wxPoint(612,240), wxSize(92,28), 0, wxDefaultValidator, _T("ID_SUPER_ClearBuffer_Button"));
	SUPER_Motors_StaticBox = new wxStaticBox(this, ID_SUPER_Motors_StaticBox, _("Motors"), wxPoint(16,328), wxSize(100,116), 0, _T("ID_SUPER_Motors_StaticBox"));
	SUPER_Motor1_CheckBox = new wxCheckBox(this, ID_SUPER_Motor1_CheckBox, _("One"), wxPoint(24,344), wxSize(88,22), 0, wxDefaultValidator, _T("ID_SUPER_Motor1_CheckBox"));
	SUPER_Motor1_CheckBox->SetValue(false);
	SUPER_Motor2_CheckBox = new wxCheckBox(this, ID_SUPER_Motor2_CheckBox, _("Two"), wxPoint(24,368), wxSize(88,22), 0, wxDefaultValidator, _T("ID_SUPER_Motor2_CheckBox"));
	SUPER_Motor2_CheckBox->SetValue(false);
	SUPER_Motor3_CheckBox = new wxCheckBox(this, ID_SUPER_Motor3_CheckBox, _("Three"), wxPoint(24,392), wxSize(88,22), 0, wxDefaultValidator, _T("ID_SUPER_Motor3_CheckBox"));
	SUPER_Motor3_CheckBox->SetValue(false);
	SUPER_Motor4_CheckBox = new wxCheckBox(this, ID_SUPER_Motor4_CheckBox, _("Spread"), wxPoint(24,416), wxSize(88,22), 0, wxDefaultValidator, _T("ID_SUPER_Motor4_CheckBox"));
	SUPER_Motor4_CheckBox->SetValue(false);
	SUPER_Open_Button = new wxButton(this, ID_SUPER_Open_Button, _("Open"), wxPoint(136,356), wxSize(76,28), 0, wxDefaultValidator, _T("ID_SUPER_Open_Button"));
	SUPER_Open_Button->SetToolTip(_("Commands the selected motor(s) to move fingers in the open direction"));
	SUPER_Close_Button = new wxButton(this, ID_SUPER_Close_Button, _("Close"), wxPoint(136,400), wxSize(76,28), 0, wxDefaultValidator, _T("ID_SUPER_Close_Button"));
	SUPER_Close_Button->SetToolTip(_("Commands the selected motor(s) to move fingers in the close direction towards the palm"));
	SUPER_TorqueOpen_Button = new wxButton(this, ID_SUPER_TorqueOpen_Button, _("Torque Open"), wxPoint(220,356), wxSize(100,28), 0, wxDefaultValidator, _T("ID_SUPER_TorqueOpen_Button"));
	SUPER_TorqueOpen_Button->Disable();
	SUPER_TorqueOpen_Button->SetToolTip(_("Commands velocity of selected motor(s) in the direction that opens the finger(s) with control of motor torque at stall"));
	SUPER_TorqueClose_Button = new wxButton(this, ID_SUPER_TorqueClose_Button, _("Torque Close"), wxPoint(220,400), wxSize(100,28), 0, wxDefaultValidator, _T("ID_SUPER_TorqueClose_Button"));
	SUPER_TorqueClose_Button->Disable();
	SUPER_TorqueClose_Button->SetToolTip(_("Commands velocity of selected motor(s) in the direction that closes the finger(s) with control of motor torque at stall"));
	SUPER_GoHome_Button = new wxButton(this, ID_SUPER_GoHome_Button, _("Go Home"), wxPoint(328,356), wxSize(83,28), 0, wxDefaultValidator, _T("ID_SUPER_GoHome_Button"));
	SUPER_GoHome_Button->SetToolTip(_("Moves the selected motor(s) to position 0"));
	SUPER_GoDefault_Button = new wxButton(this, ID_SUPER_GoDefault_Button, _("Go Default"), wxPoint(328,400), wxSize(83,28), 0, wxDefaultValidator, _T("ID_SUPER_GoDefault_Button"));
	SUPER_GoDefault_Button->SetToolTip(_("Moves selected motor(s) to default position given by parameter DP"));
	SUPER_Initialize_Button = new wxButton(this, ID_SUPER_Initialize_Button, _("Initialize"), wxPoint(32,476), wxSize(72,28), 0, wxDefaultValidator, _T("ID_SUPER_Initialize_Button"));
	SUPER_Initialize_Button->SetToolTip(_("Initializes the selected motor controller(s), preparing them for use by other movement commands"));
	SUPER_StopMotor_Button = new wxButton(this, ID_SUPER_StopMotor_Button, _("Stop Motor"), wxPoint(324,584), wxSize(84,28), 0, wxDefaultValidator, _T("ID_SUPER_StopMotor_Button"));
	SUPER_Abort_Button = new wxButton(this, ID_SUPER_Abort_Button, _("Abort"), wxPoint(344,124), wxSize(80,36), wxDOUBLE_BORDER, wxDefaultValidator, _T("ID_SUPER_Abort_Button"));
	SUPER_Abort_Button->Disable();
	SUPER_Abort_Button->SetToolTip(_("Aborts supervisory"));
	SUPER_MovementAmount_TextCtrl = new wxTextCtrl(this, ID_SUPER_MovementAmount_TextCtrl, _("0"), wxPoint(232,480), wxSize(72,21), wxTE_RIGHT, wxDefaultValidator, _T("ID_SUPER_MovementAmount_TextCtrl"));
	SUPER_GoPosition_Button = new wxButton(this, ID_SUPER_GoPosition_Button, _("GoTo Pos"), wxPoint(224,508), wxSize(88,28), 0, wxDefaultValidator, _T("ID_SUPER_GoPosition_Button"));
	SUPER_GoPosition_Button->SetToolTip(_("Moves selected motors to desired encoder position"));
	SUPER_StepOpen_Button = new wxButton(this, ID_SUPER_StepOpen_Button, _("Step Open"), wxPoint(320,468), wxSize(88,28), 0, wxDefaultValidator, _T("ID_SUPER_StepOpen_Button"));
	SUPER_StepOpen_Button->SetToolTip(_("Opens selected motors by the desired number of encoder ticks"));
	SUPER_StepClose_Button = new wxButton(this, ID_SUPER_StepClose_Button, _("Step Close"), wxPoint(320,508), wxSize(88,28), 0, wxDefaultValidator, _T("ID_SUPER_StepClose_Button"));
	SUPER_StepClose_Button->SetToolTip(_("Closes selected motors by the desired number of encoder ticks"));
	SUPER_Default_Button = new wxButton(this, ID_SUPER_Default_Button, _("Default"), wxPoint(672,494), wxSize(75,28), 0, wxDefaultValidator, _T("ID_SUPER_Default_Button"));
	SUPER_Default_Button->SetToolTip(_("Sets selected motor or global properties back to their factory default values."));
	SUPER_ControlLoad_Button = new wxButton(this, ID_SUPER_ControlLoad_Button, _("Load"), wxPoint(672,528), wxSize(75,28), 0, wxDefaultValidator, _T("ID_SUPER_ControlLoad_Button"));
	SUPER_ControlLoad_Button->SetToolTip(_("Loads selected motor or global properties from non-volatile storage."));
	SUPER_ControlSave_Button = new wxButton(this, ID_SUPER_ControlSave_Button, _("Save"), wxPoint(672,562), wxSize(75,28), 0, wxDefaultValidator, _T("ID_SUPER_ControlSave_Button"));
	SUPER_ControlSave_Button->SetToolTip(_("Saves selected motor or global properties to non-volatile storage."));
	SUPER_Delay_TextCtrl = new wxTextCtrl(this, ID_SUPER_Delay_TextCtrl, _("1000"), wxPoint(36,572), wxSize(56,21), wxTE_RIGHT, wxDefaultValidator, _T("ID_SUPER_Delay_TextCtrl"));
	SUPER_Temperature_TextCtrl = new wxTextCtrl(this, ID_SUPER_Temperature_TextCtrl, _("0"), wxPoint(156,604), wxSize(40,21), wxTE_RIGHT, wxDefaultValidator, _T("ID_SUPER_Temperature_TextCtrl"));
	SUPER_Temperature_TextCtrl->Disable();
	SUPER_ms_StaticText = new wxStaticText(this, ID_SUPER_ms_StaticText, _("ms"), wxPoint(100,576), wxSize(32,16), 0, _T("ID_SUPER_ms_StaticText"));
	SUPER_C_StaticText = new wxStaticText(this, ID_SUPER_C_StaticText, _("C"), wxPoint(200,608), wxSize(28,16), 0, _T("ID_SUPER_C_StaticText"));
	SUPER_Delay_Button = new wxButton(this, ID_SUPER_Delay_Button, _("Delay"), wxPoint(36,600), wxSize(96,28), 0, wxDefaultValidator, _T("ID_SUPER_Delay_Button"));
	SUPER_Delay_Button->SetToolTip(_("Inserts a delay that may be useful between moves"));
	SUPER_Temperature_Button = new wxButton(this, ID_SUPER_Temperature_Button, _("Temperature"), wxPoint(140,572), wxSize(96,28), 0, wxDefaultValidator, _T("ID_SUPER_Temperature_Button"));
	SUPER_Temperature_Button->SetToolTip(_("Gets the present temperature on the CPU board"));
	SUPER_Parameters_Choice = new wxChoice(this, ID_SUPER_Parameters_Choice, wxPoint(520,372), wxSize(228,28), 0, 0, 0, wxDefaultValidator, _T("ID_SUPER_Parameters_Choice"));
	SUPER_ParametersMotor1_CheckBox = new wxCheckBox(this, ID_SUPER_ParametersMotor1_CheckBox, _("Value 1"), wxPoint(472,494), wxDefaultSize, 0, wxDefaultValidator, _T("ID_SUPER_ParametersMotor1_CheckBox"));
	SUPER_ParametersMotor1_CheckBox->SetValue(false);
	SUPER_ParametersMotor2_CheckBox = new wxCheckBox(this, ID_SUPER_ParametersMotor2_CheckBox, _("Value 2"), wxPoint(472,522), wxDefaultSize, 0, wxDefaultValidator, _T("ID_SUPER_ParametersMotor2_CheckBox"));
	SUPER_ParametersMotor2_CheckBox->SetValue(false);
	SUPER_ParametersMotor3_CheckBox = new wxCheckBox(this, ID_SUPER_ParametersMotor3_CheckBox, _("Value 3"), wxPoint(472,550), wxDefaultSize, 0, wxDefaultValidator, _T("ID_SUPER_ParametersMotor3_CheckBox"));
	SUPER_ParametersMotor3_CheckBox->SetValue(false);
	SUPER_ParametersMotor4_CheckBox = new wxCheckBox(this, ID_SUPER_ParametersMotor4_CheckBox, _("Value 4"), wxPoint(472,578), wxDefaultSize, 0, wxDefaultValidator, _T("ID_SUPER_ParametersMotor4_CheckBox"));
	SUPER_ParametersMotor4_CheckBox->SetValue(false);
	SUPER_ParametersMotor1_TextCtrl = new wxTextCtrl(this, ID_SUPER_ParametersMotor1_TextCtrl, _("0"), wxPoint(560,490), wxSize(76,21), wxTE_RIGHT, wxDefaultValidator, _T("ID_SUPER_ParametersMotor1_TextCtrl"));
	SUPER_ParametersMotor1_TextCtrl->Disable();
	SUPER_ParametersMotor2_TextCtrl = new wxTextCtrl(this, ID_SUPER_ParametersMotor2_TextCtrl, _("0"), wxPoint(560,518), wxSize(76,21), wxTE_RIGHT, wxDefaultValidator, _T("ID_SUPER_ParametersMotor2_TextCtrl"));
	SUPER_ParametersMotor2_TextCtrl->Disable();
	SUPER_ParametersMotor3_TextCtrl = new wxTextCtrl(this, ID_SUPER_ParametersMotor3_TextCtrl, _("0"), wxPoint(560,546), wxSize(76,21), wxTE_RIGHT, wxDefaultValidator, _T("ID_SUPER_ParametersMotor3_TextCtrl"));
	SUPER_ParametersMotor3_TextCtrl->Disable();
	SUPER_ParametersMotor4_TextCtrl = new wxTextCtrl(this, ID_SUPER_ParametersMotor4_TextCtrl, _("0"), wxPoint(560,574), wxSize(76,21), wxTE_RIGHT, wxDefaultValidator, _T("ID_SUPER_ParametersMotor4_TextCtrl"));
	SUPER_ParametersMotor4_TextCtrl->Disable();
	SUPER_ParameterGet_Button = new wxButton(this, ID_SUPER_ParameterGet_Button, _("Get"), wxPoint(486,602), wxSize(68,28), 0, wxDefaultValidator, _T("ID_SUPER_ParameterGet_Button"));
	SUPER_ParameterGet_Button->SetToolTip(_("Gets selected motor or global property value(s)."));
	SUPER_ParameterSet_Button = new wxButton(this, ID_SUPER_ParameterSet_Button, _("Set"), wxPoint(564,602), wxSize(68,28), 0, wxDefaultValidator, _T("ID_SUPER_ParameterSet_Button"));
	SUPER_ParameterSet_Button->Disable();
	SUPER_ParameterSet_Button->SetToolTip(_("Sets selected motor or global property value(s)."));
	SUPER_ParameterSetDPAndGo_Button = new wxButton(this, ID_SUPER_ParameterSetDPAndGo_Button, _("Set DP and Go"), wxPoint(644,602), wxSize(108,28), 0, wxDefaultValidator, _T("ID_SUPER_ParameterSetDPAndGo_Button"));
	SUPER_ParameterSetDPAndGo_Button->Disable();
	SUPER_terminal_ascii_RadioButton = new wxRadioButton(this, ID_SUPER_terminal_ascii_RadioButton, _("ASCII"), wxPoint(192,48), wxSize(68,22), 0, wxDefaultValidator, _T("ID_SUPER_terminal_ascii_RadioButton"));
	SUPER_terminal_ascii_RadioButton->SetValue(true);
	SUPER_terminal_cpp_RadioButton = new wxRadioButton(this, ID_SUPER_terminal_cpp_RadioButton, _("C++"), wxPoint(260,48), wxSize(60,22), 0, wxDefaultValidator, _T("ID_SUPER_terminal_cpp_RadioButton"));
	EncoderTicksStaticText = new wxStaticText(this, ID_EncoderTicksStaticText, _("Encoder Ticks"), wxPoint(224,464), wxDefaultSize, 0, _T("ID_EncoderTicksStaticText"));
	StaticTextProperty = new wxStaticText(this, ID_StaticTextProperty, _("Property"), wxPoint(444,376), wxSize(72,17), 0, _T("ID_StaticTextProperty"));
	StaticTextCategory = new wxStaticText(this, ID_StaticTextCategory, _("Category"), wxPoint(444,344), wxSize(64,17), 0, _T("ID_StaticTextCategory"));
	Super_Parameters_Category_Choice = new wxChoice(this, ID_SUPER_Parameters_Category_Choice, wxPoint(520,340), wxSize(228,28), 0, 0, 0, wxDefaultValidator, _T("ID_SUPER_Parameters_Category_Choice"));
	purposeStaticText = new wxStaticText(this, ID_PURPOSE_STATIC_TEXT, _("Purpose"), wxPoint(444,408), wxSize(68,13), 0, _T("ID_PURPOSE_STATIC_TEXT"));
	purposeTextCtrl = new wxTextCtrl(this, ID_PURPOSE_TEXTCTRL, _("The purpose of the propery is ..."), wxPoint(520,404), wxSize(228,36), wxTE_MULTILINE|wxTE_READONLY, wxDefaultValidator, _T("ID_PURPOSE_TEXTCTRL"));
	notesStaticText = new wxStaticText(this, ID_NOTES_STATICTEXT, _("Notes"), wxPoint(444,452), wxSize(68,13), 0, _T("ID_NOTES_STATICTEXT"));
	MotorMovementIncludedCheckBox = new wxCheckBox(this, ID_MOTOR_MOVEMENT_INCLUDED_CHECKBOX, _("Included"), wxPoint(136,480), wxSize(92,22), 0, wxDefaultValidator, _T("ID_MOTOR_MOVEMENT_INCLUDED_CHECKBOX"));
	MotorMovementIncludedCheckBox->SetValue(false);
	//*)

	cyclePtr = NULL;
	init();

	//!Supervise - Terminal
	Connect(ID_SUPER_CommandBuffer_TextCtrl, wxEVT_COMMAND_TEXT_ENTER, (wxObjectEventFunction)&SuperPanel::OnSuperTerminalEnterHit);
	Connect(ID_SUPER_Run_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperTerminalRun);
	Connect(ID_SUPER_Copy_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperTerminalCopy);
	Connect(ID_SUPER_GenerateCpp_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperTerminalGenerateCpp);
	Connect(ID_SUPER_ClearSession_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperTerminalClearSession);
	Connect(ID_SUPER_TerminalLoad_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperTerminalLoad);
	Connect(ID_SUPER_TerminalSave_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperTerminalSave);
	Connect(ID_SUPER_ClearBuffer_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperTerminalClearBuffer);

	Connect(ID_SUPER_AutoRun_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperAutoRunCheckBox);

	Connect(ID_SUPER_terminal_ascii_RadioButton,wxEVT_COMMAND_RADIOBUTTON_SELECTED,(wxObjectEventFunction)&SuperPanel::OnSUPER_terminal_ascii_RadioButtonSelect);
	Connect(ID_SUPER_terminal_cpp_RadioButton,wxEVT_COMMAND_RADIOBUTTON_SELECTED,(wxObjectEventFunction)&SuperPanel::OnSUPER_terminal_cpp_RadioButtonSelect);

	//!Supervise - Control Panel Toggle Motors
	Connect(ID_SUPER_Motor1_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperControlMotor1Box);
	Connect(ID_SUPER_Motor2_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperControlMotor2Box);
	Connect(ID_SUPER_Motor3_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperControlMotor3Box);
	Connect(ID_SUPER_Motor4_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperControlMotor4Box);

	//!Supervise - Control Panel Toggle Buttons
	Connect(ID_SUPER_GoPosition_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlGoPosition);
	Connect(ID_SUPER_StepClose_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlStepClose);
	Connect(ID_SUPER_StepOpen_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlStepOpen);
	Connect(ID_SUPER_Open_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlOpen);
	Connect(ID_SUPER_Close_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlClose);
	Connect(ID_SUPER_TorqueOpen_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlTorqueOpen);
	Connect(ID_SUPER_TorqueClose_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlTorqueClose);
	Connect(ID_SUPER_GoHome_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlGoHome);
	Connect(ID_SUPER_GoDefault_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlGoDefault);
	Connect(ID_SUPER_Initialize_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlInitialize);
	Connect(ID_SUPER_StopMotor_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlStop);
	Connect(ID_SUPER_Default_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlDefault);
	Connect(ID_SUPER_ControlLoad_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlLoad);
	Connect(ID_SUPER_ControlSave_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlSave);
	Connect(ID_SUPER_Abort_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlAbort);
	Connect(ID_SUPER_Delay_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlDelay);
	Connect(ID_SUPER_Temperature_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperControlTemperature);

	//!Supervise - Control Panel - Parameters

	Connect(ID_SUPER_ParametersMotor1_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperParamMotor1Box);
	Connect(ID_SUPER_ParametersMotor2_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperParamMotor2Box);
	Connect(ID_SUPER_ParametersMotor3_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperParamMotor3Box);
	Connect(ID_SUPER_ParametersMotor4_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSuperParamMotor4Box);
	Connect(ID_SUPER_ParameterGet_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperParamGet);
	Connect(ID_SUPER_ParameterSet_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperParamSet);
	Connect(ID_SUPER_ParameterSetDPAndGo_Button,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&SuperPanel::OnSuperParamSetDP);


	Connect(ID_SUPER_Parameters_Category_Choice, wxEVT_COMMAND_CHOICE_SELECTED, (wxObjectEventFunction)&SuperPanel::OnSuperParamCategoryChoice);
	Connect(ID_SUPER_Parameters_Choice, wxEVT_COMMAND_CHOICE_SELECTED, (wxObjectEventFunction)&SuperPanel::OnSuperParamChoice);

	Connect(ID_SUPER_ParametersMotor1_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSUPER_ParametersMotor1_CheckBoxClick);
	Connect(ID_SUPER_ParametersMotor2_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSUPER_ParametersMotor2_CheckBoxClick);
	Connect(ID_SUPER_ParametersMotor3_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSUPER_ParametersMotor3_CheckBoxClick);
	Connect(ID_SUPER_ParametersMotor4_CheckBox, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnSUPER_ParametersMotor4_CheckBoxClick);

	Connect(ID_MOTOR_MOVEMENT_INCLUDED_CHECKBOX, wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction)&SuperPanel::OnMotorMovementIncludedCheckBox);
}

SuperPanel::~SuperPanel()
{
	delete FileSave;

	if (m_response != NULL)
        delete m_response;

	//(*Destroy(SuperPanel)
	//*)
}

void SuperPanel::EnablePanel(bool flag)
{
	m_panelEnabled = flag;

	// Terminal
	SUPER_Terminal_StaticBox->Enable(flag);
	SUPER_SessionHistory_StaticText->Enable(flag);
	SUPER_terminal_ascii_RadioButton->Enable(flag);
	SUPER_terminal_cpp_RadioButton->Enable(flag);
	SUPER_SessionHistory_TextCtrl->Enable(flag);
	SUPER_GenerateCpp_Button->Enable(flag);
	SUPER_ClearSession_Button->Enable(flag);

	SUPER_Run_Button->Enable(flag);
	if (!flag)
		SUPER_Abort_Button->Enable(flag); // disabled by default
	SUPER_Copy_Button->Enable(flag);

	SUPER_CommandBuffer_StaticText->Enable(flag);
	SUPER_AutoRun_CheckBox->Enable(flag);
	SUPER_CommandBuffer_TextCtrl->Enable(flag);
	SUPER_TerminalLoad_Button->Enable(flag);
	SUPER_TerminalSave_Button->Enable(flag);
	SUPER_ClearBuffer_Button->Enable(flag);

	// Control Panel
	SUPER_ControlPanel_StaticBox->Enable(flag);

	SUPER_Motors_StaticBox->Enable(flag);
	SUPER_Motor1_CheckBox->Enable(flag);
	SUPER_Motor2_CheckBox->Enable(flag);
	SUPER_Motor3_CheckBox->Enable(flag);
	SUPER_Motor4_CheckBox->Enable(flag);

	StaticBoxMotorMovement->Enable(flag);
	SUPER_Open_Button->Enable(flag);
	SUPER_Close_Button->Enable(flag);
	if (!flag)
	{
		SUPER_TorqueOpen_Button->Enable(flag); // disabled by default
		SUPER_TorqueClose_Button->Enable(flag); // disabled by default
	}
	SUPER_GoHome_Button->Enable(flag);
	SUPER_GoDefault_Button->Enable(flag);

	SUPER_INIT_StaticBox->Enable(flag);
	SUPER_Initialize_Button->Enable(flag);

	MOTOR_MOVEMENT_VALUES_StaticBox->Enable(flag);
	MotorMovementIncludedCheckBox->Enable(flag);
	EncoderTicksStaticText->Enable(flag);
	SUPER_MovementAmount_TextCtrl->Enable(flag);
	SUPER_GoPosition_Button->Enable(flag);
	SUPER_StepOpen_Button->Enable(flag);
	SUPER_StepClose_Button->Enable(flag);

	MiscStaticBox->Enable(flag);
	SUPER_Delay_TextCtrl->Enable(flag);
	SUPER_ms_StaticText->Enable(flag);
	SUPER_Delay_Button->Enable(flag);
	SUPER_Temperature_Button->Enable(flag);
	SUPER_Temperature_TextCtrl->Enable(flag);
	SUPER_C_StaticText->Enable(flag);
	SUPER_StopMotor_Button->Enable(flag);

	SUPER_ParametersMotor1_CheckBox->Enable(flag);
	SUPER_ParametersMotor2_CheckBox->Enable(flag);
	SUPER_ParametersMotor3_CheckBox->Enable(flag);
	SUPER_ParametersMotor4_CheckBox->Enable(flag);
	SUPER_ParametersMotor1_TextCtrl->Enable(flag);
	SUPER_ParametersMotor2_TextCtrl->Enable(flag);
	SUPER_ParametersMotor3_TextCtrl->Enable(flag);
	SUPER_ParametersMotor4_TextCtrl->Enable(flag);

	SUPER_Default_Button->Enable(flag);
	SUPER_ControlLoad_Button->Enable(flag);
	SUPER_ControlSave_Button->Enable(flag);

	SUPER_ParameterGet_Button->Enable(flag);

	if (!flag)
	{
		SUPER_ParameterSet_Button->Enable(flag); // disabled by default
		SUPER_ParameterSetDPAndGo_Button->Enable(flag); // disabled by default
	}
}

void SuperPanel::init()
{
	generateMotorString(1);
	generateMotorString(2);

	enableControlPanelButtons();

	//! filesave is used for all saving of variables
	FileSave = new wxFileDialog(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_SAVE|wxFD_OVERWRITE_PROMPT, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));

	fillPropertiesListBoxes();
}

void SuperPanel::InitLibrary()
{
	fillPropertiesListBoxes();
}

void SuperPanel::fillPropertiesListBoxes()
{
	// Note: the hardware model will be correct only after Init is called
	BHandHardware *hardwareModel = m_hand->getHardwareDesc();

	//printf("SuperPanel::fillPropertiesListBoxes modelNum=%s\n", hardwareModel->getModelNumber());

	if (hardwareModel == NULL)
		return;

	// Clear the Categories ListBox
	Super_Parameters_Category_Choice->Clear();

	// Fill BarrettHand Property Category ListBox
	for (unsigned int i = 0; i < hardwareModel->getBHandNumProperties(); i++)
	{
		BHandProperty *property = hardwareModel->getBHandProperty(i);

		// Look for Property Category Text in the Property Category ListBox
		bool found = false;
		for (unsigned int j = 0; j < Super_Parameters_Category_Choice->GetCount(); j++)
			found |= (strcmp(Super_Parameters_Category_Choice->GetString(j).mb_str(wxConvUTF8), property->getCategory()) == 0);

		// Append new Property Category Text to the Property Category ListBox
		if (!found)
			Super_Parameters_Category_Choice->Append(wxString(property->getCategory(), wxConvUTF8));
	}

	// Set Property Category ListBox text
	Super_Parameters_Category_Choice->SetSelection(0);

	// Fill BarrettHand Property ListBox
	fillPropertyChoice();
}


void SuperPanel::fillPropertyChoice()
{
	// Note: the hardware model will be correct only after Init is called
	BHandHardware *hardwareModel = m_hand->getHardwareDesc();

	//printf("SuperPanel::fillPropertyChoice modelNum=%s\n", hardwareModel->getModelNumber());

	if (hardwareModel == NULL)
		return;


	// Clear contents of Property ListBox
	SUPER_Parameters_Choice->Clear();

	// Fill BarrettHand Property ListBox
	for (unsigned int i = 0; i < hardwareModel->getBHandNumProperties(); i++)
	{
		BHandProperty *property = hardwareModel->getBHandProperty(i);

		int selectedPropertyCategoryIndex = Super_Parameters_Category_Choice->GetSelection();

		if (selectedPropertyCategoryIndex != wxNOT_FOUND)
		{
			wxString selectedPropertyCategoryText =
				Super_Parameters_Category_Choice->GetString(selectedPropertyCategoryIndex);

			if ((strcmp(selectedPropertyCategoryText.mb_str(wxConvUTF8), property->getCategory()) == 0))
			{
				wxString propertyText = wxString(property->getName(), wxConvUTF8) + wxT(": ") + wxString(property->getDesc(), wxConvUTF8);

				SUPER_Parameters_Choice->Append(propertyText);
			}
		}
	}

	// Set Property ListBox text
	SUPER_Parameters_Choice->SetSelection(0);

	updatePropertyAttributes();
}


//! creates a dialog box with the error message and stops supervisory commands from continuing
void SuperPanel::ThrowError(wxString message)
{
    if (m_response != NULL)
        delete m_response;

    m_response = new wxMessageDialog(NULL, message, wxT("Control Panel - Error"), wxOK | wxICON_ERROR);
    shouldAbort = true;
    m_response->ShowModal();
}


//! updates the command buffer / session history windows accordingly
void SuperPanel::UpdateTextCrtl(wxString ascii_message, wxString cpp_message)
{
	if (SUPER_AutoRun_CheckBox->GetValue())
	{
		// Update each internal representation
		if (ascii_message.Length() > 0) ascii_session.Append(ascii_message + wxT("\n"));
		if (cpp_message.Length() > 0) cpp_session.Append(cpp_message + wxT("\n"));

		// Update each external representation using the current selected format
		if (ascii_selected)
		{
			if (ascii_message.Length() > 0)
				AddSomeText(SUPER_SessionHistory_TextCtrl, ascii_message + wxT("\n"));
		}
		else
		{
			if (cpp_message.Length() > 0)
				AddSomeText(SUPER_SessionHistory_TextCtrl, cpp_message + wxT("\n"));
		}
		//SUPER_SessionHistory_TextCtrl->Update();
	}
	else
	{
		if (ascii_message.Length() > 0)
		{
			AddSomeText(SUPER_CommandBuffer_TextCtrl, ascii_message + wxT("\n"));
			//SUPER_CommandBuffer_TextCtrl->Update();
		}
	}
}


//! parses a string for motor values and stores them in the buffer
int SuperPanel::parseMotorString(wxString input, char *buf)
{
	int total = 0;
	int counter = 0;
	int size = input.Length();
	char *temp = new char[size + 1];
	strcpy(temp, (const char*)input.mb_str(wxConvUTF8));

	bool inc[5] = { false, false, false, false, false };

	// Clear Whitespace at beginning of motor string
	const char *ptemp = temp;
	while (ptemp[0] == ' ' || ptemp[0] == '\t' || ptemp[0] == '\r' || ptemp[0] == '\n')
	{
		ptemp++;
		size--;
		total++;
	}

	for (int i = 0; i < size; i++)
	{
		total++;
		     if (ptemp[i] == '1') { if (!inc[0]) buf[counter++] = '1'; inc[0] = true; }
		else if (ptemp[i] == '2') { if (!inc[1]) buf[counter++] = '2'; inc[1] = true; }
		else if (ptemp[i] == '3') { if (!inc[2]) buf[counter++] = '3'; inc[2] = true; }
		else if (ptemp[i] == '4') { if (!inc[3]) buf[counter++] = '4'; inc[4] = true; }
		else if (ptemp[i] == 'G' || ptemp[i] == 'g') { if (!inc[4]) buf[counter++] = 'G'; inc[4] = true; }
		else if (ptemp[i] == 'S' || ptemp[i] == 's') { if (!inc[3]) buf[counter++] = 'S'; inc[3] = true; }
		else break;
	}

	// NULL terminate buffer and deallocate memory for temporary array
	buf[counter] = '\0';
	delete[] temp;

	return total - 1;
}

//! fixes spaces so commands can be parsed correctly
void SuperPanel::FixSpaces(wxString *toFix)
{
	int num_replaced;

	do {

		num_replaced = 0;

		num_replaced += toFix->Replace(wxT("\t"), wxT(" "));
		num_replaced += toFix->Replace(wxT("  "), wxT(" "));

	} while (num_replaced > 0);
}

//! parse the value after a command (example GM 4000, 4000 would be parsed and saved in long* value)
bool SuperPanel::parseCommandValue(wxString input, long *value)
{
	wxString after = wxT("");
	after.Append(input.AfterLast(' '));

	// Returns true if value is found otherwise false
	if(after.IsEmpty()) {
		return false;
	} else {
		if(!(after).ToLong(value)) {
			return false;
		} else {
			return true;
		}
	}
}

//! takes commands from the Command Buffer window and converts them to C++ function calls
//! is programmed to be able to handle multiple lines of input but in this application input
//! length will only be one line
wxString SuperPanel::asciiToCpp(wxString input)
{
	wxString toReturn = wxT("");
	char tmotors[6];
	long value;

	while (!input.IsEmpty())
	{
		// Get the input line
		wxString currentLine = input.BeforeFirst('\n');
		currentLine.MakeUpper();

		// Get the motors that the command will be issued to
		// and the position in the string when the motors end
		int endofmotors = parseMotorString(currentLine, tmotors);

		wxString motors(tmotors, wxConvUTF8);

		// Setup string tokenizer for parsing the command
		wxStringTokenizer tkz(currentLine.Mid(endofmotors));
		wxString command;
		bool includesValue = false;
		wxString param = wxT("");

		// Get command and first parameter
		if (tkz.HasMoreTokens())
		{
			command = tkz.GetNextToken();
			if (tkz.HasMoreTokens() && (param = tkz.GetNextToken()).ToLong(&value))
				includesValue = true;
		}
		else
		{
			input = input.AfterFirst('\n');
			continue;
		}

		// Check to see what the command is and handle accordingly
		     if (!command.Cmp(wxT("IC"   ))) { toReturn.Append(wxT("StepClose(\"") + motors + (includesValue ? wxString::Format(wxT("\", %i)"), (int)value) : wxT("\")"))); }
		else if (!command.Cmp(wxT("IO"   ))) { toReturn.Append(wxT( "StepOpen(\"") + motors + (includesValue ? wxString::Format(wxT("\", %i)"), (int)value) : wxT("\")"))); }
		else if (!command.Cmp(wxT("FSET" )) && tkz.HasMoreTokens() && tkz.GetNextToken().ToLong(&value)) { toReturn.Append(wxT("FSet(\"") + motors + wxT("\", \"") + param + wxString::Format(wxT("\", %i)"), (int)value)); }
		else if (!command.Cmp(wxT("FGET" )) && param.Length() > 0) { toReturn.Append(wxT("FGet(\"") + motors + wxT("\", \"") + param + wxT("\", &values)")); }
		else if (!command.Cmp(wxT("PSET" )) && tkz.HasMoreTokens() && tkz.GetNextToken().ToLong(&value)) { toReturn.Append(wxT("PSet(\"") + param + wxString::Format(wxT("\", %i)"), (int)value)); }
		else if (!command.Cmp(wxT("PGET" )) && !param.Cmp(wxT("TEMP"))) { toReturn.Append(wxT("Temperature(&value)")); }
		else if (!command.Cmp(wxT("PGET" )) && param.Length() > 0) { toReturn.Append(wxT("PGet(\"") + param + wxT("\", &value)")); }
		else if (!command.Cmp(wxT("DELAY")) && motors.Length() == 0 && includesValue) { toReturn.Append(wxString::Format(wxT("Delay(%i)"), (int)value)); }
		else if (!command.Cmp(wxT("HOME" ))) { toReturn.Append(wxT(    "GoToHome(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("M"    ))) { toReturn.Append(wxT("GoToPosition(\"") + motors + (includesValue ? wxString::Format(wxT("\", %i)"), (int)value) : wxT("\")"))); }
		else if (!command.Cmp(wxT("FDEF" ))) { toReturn.Append(wxT(     "Default(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("FSAVE"))) { toReturn.Append(wxT(        "Save(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("FLOAD"))) { toReturn.Append(wxT(        "Load(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("HI"   ))) { toReturn.Append(wxT(    "InitHand(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("TO"   ))) { toReturn.Append(wxT(  "TorqueOpen(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("TC"   ))) { toReturn.Append(wxT( "TorqueClose(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("T"    ))) { toReturn.Append(wxT(   "StopMotor(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("O"    ))) { toReturn.Append(wxT(        "Open(\"") + motors + wxT("\")")); }
		else if (!command.Cmp(wxT("C"    ))) { toReturn.Append(wxT(       "Close(\"") + motors + wxT("\")")); }
		else
		{
			// If the command isn't found, send using default m_hand->Command(const char* send, char* receive)
			toReturn.Append(wxT("Command(\"") + currentLine + wxT("\", buf)"));
		}

		toReturn.Append(wxT("\n"));

		input = input.AfterFirst('\n');
	}

	return toReturn;
}

//! takes commands from the Command Buffer window and processes them into function calls on the hand.
//! Function is programmed to be able to handle multiple lines of input but in this application input
//! length will only be one line

//! function will return false if an error occurs or if there is nothing left to execute
bool SuperPanel::asciiToFunctionCalls(wxString input)
{
	wxString toReturn;
	char motors[6];
	char buf[100];
	long value;

	if (input.IsEmpty())
		return false;

	while (!input.IsEmpty())
	{
		// Get the input line
		wxString currentLine = input.BeforeFirst('\n');
		currentLine.MakeUpper();

		// Get the motors that the command will be issued to
		// and the position in the string when the motors end
		int endofmotors = parseMotorString(currentLine, motors);

		// Setup string tokenizer for parsing the command
		wxStringTokenizer tkz(currentLine.Mid(endofmotors));
		wxString command;
		bool includesValue = false;
		wxString param = wxT("");

		// Get command and first parameter
		if (tkz.HasMoreTokens())
		{
			command = tkz.GetNextToken();
			if (tkz.HasMoreTokens() && (param = tkz.GetNextToken()).ToLong(&value))
				includesValue = true;
		}
		else
		{
			input = input.AfterFirst('\n');
			continue;
		}


		// Process command accordingly and perform matching function call
		if (!command.Cmp(wxT("IC")))
		{
			int result = 0;
			if (includesValue ? (result = m_hand->StepClose(motors, value)) : m_hand->StepClose(motors))
			{
				if (result == BHERR_OUTOFRANGE)
					ThrowError(wxT("StepClose value out of range"));
				else
					ThrowError(wxT("Selected motors failed to step close.  Check hand to see if selected motors are initalized or if there is an obstruction."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("IO")))
		{
			int result = 0;
			if (includesValue ? (result = m_hand->StepOpen(motors, value)) : m_hand->StepOpen(motors))
			{
				if (result == BHERR_OUTOFRANGE)
					ThrowError(wxT("StepOpen value out of range"));
				else
					ThrowError(wxT("Selected motors failed to step open.  Check hand to see if selected motors are initalized or if there is an obstruction."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("FSET")))
		{
			if (tkz.HasMoreTokens() && tkz.GetNextToken().ToLong(&value) && m_hand->Set(motors, param.mb_str(wxConvUTF8), (int)value))
			{
				ThrowError(wxT("Failed to set a parameter from the hand.  There may be a problem with the hand."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("FGET")))
		{
			unsigned int mCount = countMotors(toBHMotors(motors));
			int *values = NULL;
			if (mCount > 0) values = new int[mCount];

			if (param.Length() > 0 && m_hand->Get(motors, param.mb_str(wxConvUTF8), values))
			{
				if (values != NULL)
					delete[] values;
				ThrowError(wxT("Failed to get a parameter from the hand.  There may be a problem with the hand."));
				return false;
			}

			wxString results = wxT(">>");
			for (unsigned int i = 0; i < mCount; i++)
				results += wxString::Format(wxT(" %i"), values[i]);
			results += wxT("\n");

			delete[] values;

			ascii_session.Append(results);
			AddSomeText(SUPER_SessionHistory_TextCtrl, results);
		}
		else if (!command.Cmp(wxT("PSET")))
		{
			if (tkz.HasMoreTokens() && tkz.GetNextToken().ToLong(&value) && m_hand->PSet(param.mb_str(wxConvUTF8), (int)value))
			{
				ThrowError(wxT("Failed to set a parameter from the hand.  There may be a problem with the hand."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("PGET")) && !param.Cmp(wxT("TEMP")))
		{
			int temp_val;
			if (m_hand->Temperature(&temp_val))
			{
				ThrowError(wxT("Failed to read temperature.  There may be a problem with the hand."));
				return false;
			}
			wxString result = wxString::Format(wxT(">> %i\n"), temp_val);
			ascii_session.Append(result);
			AddSomeText(SUPER_SessionHistory_TextCtrl, result);
			SUPER_Temperature_TextCtrl->SetValue(wxString::Format(wxT("%i"), temp_val));
		}
		else if (!command.Cmp(wxT("PGET")))
		{
			int val;

			if (param.Length() > 0 && m_hand->PGet(param.mb_str(wxConvUTF8), &val))
			{
				ThrowError(wxT("Failed to get a global parameter from the hand.  There may be a problem with the hand."));
				return false;
			}

			wxString results = wxString::Format(wxT(">> %i\n"), val);
			ascii_session.Append(results);
			AddSomeText(SUPER_SessionHistory_TextCtrl, results);
		}
		else if (!command.Cmp(wxT("DELAY")))
		{
			int result = 0;
			if (includesValue && (result = m_hand->Delay((int)value)))
			{
				if (result == BHERR_OUTOFRANGE)
					ThrowError(wxT("Delay value out of range"));
				else
					ThrowError(wxT("Could not set the delay on the hand."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("HOME")))
		{
			if (m_hand->GoToHome(motors))
			{
				ThrowError(wxT("All motors must be initialized in order to go to the home position or there may be an obstruction."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("M")))
		{
			if (includesValue)
			{
				int result;
				if ((result = m_hand->GoToPosition(motors, value)))
				{
					if (result == BHERR_OUTOFRANGE)
						ThrowError(wxT("GoToPosition value out of range"));
					else
						ThrowError(wxT("Selected motors failed to to go specified position.  Check hand to see if selected motors are initialized or if there is an obstruction."));
					return false;
				}
			}
			else if (m_hand->GoToDefault(motors))
			{
				ThrowError(wxT("Selected motors failed to go to the default position.  Check hand to see if all motors are initialized."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("FDEF")))
		{
			if (m_hand->Default(motors))
			{
				ThrowError(wxT("Selected motors failed to load defaults."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("FSAVE")))
		{
			if (m_hand->Save(motors))
			{
				ThrowError(wxT("Selected motors failed to save parameter values to EEPROM."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("FLOAD")))
		{
			if (m_hand->Load(motors))
			{
				ThrowError(wxT("Selected motors failed to load parameters from EEPROM."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("HI")))
		{
			if (m_hand->InitHand(motors))
			{
				ThrowError(wxT("Selected motors failed to initialize.  There may be a problem with one of the hand motors."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("TC")))
		{
			if (m_hand->TorqueClose(motors))
			{
				ThrowError(wxT("Selected motors failed to torque close.  Check hand to see if selected motors are initialized."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("TO")))
		{
			if (m_hand->TorqueOpen(motors))
			{
				ThrowError(wxT("Selected motors failed to torque open.  Check hand to see if selected motors are initialized."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("T")))
		{
			if (m_hand->StopMotor(motors))
			{
				ThrowError(wxT("Selected motors failed to stop.  Check hand to see if selected motors are initialized."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("O")))
		{
			if (m_hand->Open(motors))
			{
				ThrowError(wxT("Selected motors failed to open.  Check hand to see if selected motors are initialized."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("C")))
		{
			if (m_hand->Close(motors))
			{
				ThrowError(wxT("Selected motors failed to close.  Check hand to see if selected motors are initialized."));
				return false;
			}
		}
		else if (!command.Cmp(wxT("CYCLE")))
		{
			//cycleFilePath = FileDialog_BH->GetPath();
			if (cyclePtr != NULL)
			{
				*cyclePtr = true;
			}
			else if (cycleFilePath.Length() > 0)
				SUPER_CommandBuffer_TextCtrl->LoadFile(cycleFilePath);

			//if (SUPER_AutoRun_CheckBox->IsChecked())
			//	runCommandsInBuffer();
		}
		else
		{
			// No command found, call using default m_hand->Command(const char* send, char* receive)
			if (m_hand->Command(currentLine.mb_str(), buf))
			{
				ThrowError(wxT("Failed to issue specified command to the hand."));
				return false;
			}
			if (strlen(buf) > 0)
			{
				// Print information in the buffer to screen
				wxString temp(buf, wxConvUTF8);
				wxString result = wxT(">> ") + temp + wxT("\n");
				ascii_session.Append(result);
				AddSomeText(SUPER_SessionHistory_TextCtrl, result);
			}
		}

        input = input.AfterFirst('\n');
    }

    return true; // success
}

//! generates a motor string for one of the two groups
//! of motor checkboxes in the control panel window
void SuperPanel::generateMotorString(int group)
{
	char* currentgroup;

	// Assign pointer the desired motor group
	if (group == 1)
		currentgroup = m_motors;
	else if (group == 2)
		currentgroup = m_motors_param;
	else
		return;

	int current = 0;

	// Check the checkbox group to see which motors are selected
	if (group == 1)
	{
		if (SUPER_Motor1_CheckBox->GetValue()) currentgroup[current++] = '1';
		if (SUPER_Motor2_CheckBox->GetValue()) currentgroup[current++] = '2';
		if (SUPER_Motor3_CheckBox->GetValue()) currentgroup[current++] = '3';
		if (SUPER_Motor4_CheckBox->GetValue()) currentgroup[current++] = 'S';
	}
	else if (group == 2)
	{
		if (SUPER_ParametersMotor1_CheckBox->GetValue()) currentgroup[current++] = '1';
		if (SUPER_ParametersMotor2_CheckBox->GetValue()) currentgroup[current++] = '2';
		if (SUPER_ParametersMotor3_CheckBox->GetValue()) currentgroup[current++] = '3';
		if (SUPER_ParametersMotor4_CheckBox->GetValue()) currentgroup[current++] = 'S';
	}

	// NULL terminate motor string
	currentgroup[current] = '\0';

	// Set wxWidgets motor string representation
	if (group == 1)
	{
		m_motors_string.Clear();
		m_motors_string = wxString(m_motors, wxConvUTF8);
	}
	else if (group == 2)
	{
		m_motors_param_string.Clear();
		m_motors_param_string = wxString(m_motors_param, wxConvUTF8);
	}
}


//! run the code in the command buffer window
//! runs one instruction at a time (called by BHControlMain)
//! (in order to handle aborts)
bool SuperPanel::TerminalRun()
{
	//printf("\nSuperPanel TerminalRun() ");
    wxString buffer_value = SUPER_CommandBuffer_TextCtrl->GetValue();

	// Checks to see whether or not supervisory mode should abort
    if (!buffer_value.IsEmpty() && !shouldAbort)
    {
        //get the first command from the buffer
        wxString currentLine = buffer_value.BeforeFirst('\n');

		if (currentLine.IsEmpty())
		{
			// consume this empty line
			// update the command buffer
			SUPER_CommandBuffer_TextCtrl->SetValue((SUPER_CommandBuffer_TextCtrl->GetValue()).AfterFirst('\n'));
			SUPER_CommandBuffer_TextCtrl->Update();

			return true;
		}


		currentLine.Append(wxT("\n"));

        //convert it to C++ code
        wxString cpp_converted = asciiToCpp(currentLine);

        //update session histories
        ascii_session.Append(currentLine);
        cpp_session.Append(cpp_converted);

        //update the GUI session history in the correct format
		if (ascii_selected)
			AddSomeText(SUPER_SessionHistory_TextCtrl, currentLine);
        else
            AddSomeText(SUPER_SessionHistory_TextCtrl, cpp_converted);

		//SUPER_SessionHistory_TextCtrl->Update();

        //update the command buffer
        SUPER_CommandBuffer_TextCtrl->SetValue((SUPER_CommandBuffer_TextCtrl->GetValue()).AfterFirst('\n'));
		SUPER_CommandBuffer_TextCtrl->Update();

        //send the command to the hand
        //if an error is thrown, shouldAbort will be set to true
        return asciiToFunctionCalls(currentLine);
    }

    return false;
}

//! Used by RealTime_Tab to see if it is done executing supervisory commands
bool SuperPanel::ExternalRunDone()
{
    return externalToRun.IsEmpty();
}

//! Used by RealTime_Tab to ready supervisory commands to run
void SuperPanel::PrepareSupervisoryExternalRun(wxString toRun) {
    externalToRun = wxT("");
    externalToRun.Append(toRun);
}

//! Used by RealTime_Tab to run supervisory commands
bool SuperPanel::SupervisoryExternalRun(bool *cycle)
{
	if (cycle != NULL)
		*cycle = false;

    if(!externalToRun.IsEmpty() && !shouldAbort) {
        //get the first commands to run
#ifdef LINUX
        wxString currentLine = externalToRun.BeforeFirst('\n');
#else
        wxString currentLine = externalToRun.BeforeFirst('\r');
#endif
        currentLine.Append(wxT("\n"));
        //advance a line
#ifdef LINUX
        externalToRun = externalToRun.AfterFirst('\n');
#else
        externalToRun = externalToRun.AfterFirst('\r');
#endif

		cyclePtr = cycle;
		//attempt to run
		bool result = asciiToFunctionCalls(currentLine);
		cyclePtr = NULL;
        return result;

    } else {
        return false;
    }
}



//! Return false if no motors are selected for hand commands, otherwise return true
bool SuperPanel::motorsSelected()
{
	if (strlen(m_motors) <= 0)
	{
		ThrowError(wxT("No motors are currently selected."));
		return false;
	}
	else
		return true;
}



//! sets parameters for specified motors
int SuperPanel::setPropertyValues()
{
	// Get selected BarrettHand property
	BHandProperty *bhandProperty = getSelectedProperty();

	// Check to ensure that a property is selected
	if (bhandProperty == NULL)
		return -1;


	const char *parameter = bhandProperty->getName();
	bool isGlobal = bhandProperty->isGlobal();

	// create a wxString of property
	wxString param = wxString(parameter, wxConvUTF8);

	if (isGlobal)
	{
		long value;
		if ((SUPER_ParametersMotor1_CheckBox->GetValue() && !SUPER_ParametersMotor1_TextCtrl->GetValue().ToLong(&value)))
		{
			ThrowError(wxT("Unable to convert value one to an integer"));
			return -1;
		}

		if (SUPER_ParametersMotor1_CheckBox->GetValue())
		{
			UpdateTextCrtl(
				wxT("PSET ") + param + wxString::Format(wxT(" %d"), (int)value),
				wxT("PSet(\"") + param + wxString::Format(wxT("\", %d)"), (int)value));

			if (SUPER_AutoRun_CheckBox->GetValue() && m_hand->PSet(parameter, value))
				ThrowError(wxT("Could not set global property ") + param);
		}

		return 0;
	}


	long value[4];
	if ((SUPER_ParametersMotor1_CheckBox->GetValue() && !SUPER_ParametersMotor1_TextCtrl->GetValue().ToLong(&value[0])) ||
		(SUPER_ParametersMotor2_CheckBox->GetValue() && !SUPER_ParametersMotor2_TextCtrl->GetValue().ToLong(&value[1])) ||
		(SUPER_ParametersMotor3_CheckBox->GetValue() && !SUPER_ParametersMotor3_TextCtrl->GetValue().ToLong(&value[2])) ||
		(SUPER_ParametersMotor4_CheckBox->GetValue() && !SUPER_ParametersMotor4_TextCtrl->GetValue().ToLong(&value[3])))
	{
		ThrowError(wxT("Unable to convert one of the motor property fields to integer"));
		return -1;
	}

	if (SUPER_ParametersMotor1_CheckBox->GetValue())
	{
		UpdateTextCrtl(
			wxT("1FSET ") + param + wxString::Format(wxT(" %d"), (int)value[0]),
			wxT("Set(\"1\", \"") + param + wxString::Format(wxT("\", %d)"), (int)value[0]));

		if (SUPER_AutoRun_CheckBox->GetValue() && m_hand->Set("1", parameter, value[0]))
			ThrowError(wxT("Could not set property ") + param + wxT(" for motor one."));
	}
	if (SUPER_ParametersMotor2_CheckBox->GetValue())
	{
		UpdateTextCrtl(
			wxT("2FSET ") + param + wxString::Format(wxT(" %d"), (int)value[1]),
			wxT("Set(\"2\", \"") + param + wxString::Format(wxT("\", %d)"), (int)value[1]));

		if (SUPER_AutoRun_CheckBox->GetValue() && m_hand->Set("2", parameter, value[1]))
			ThrowError(wxT("Could not set property ") + param + wxT(" for motor two."));
	}
	if (SUPER_ParametersMotor3_CheckBox->GetValue())
	{
		UpdateTextCrtl(
			wxT("3FSET ") + param + wxString::Format(wxT(" %d"), (int)value[2]),
			wxT("Set(\"3\", \"") + param + wxString::Format(wxT("\", %d)"), (int)value[2]));

		if (SUPER_AutoRun_CheckBox->GetValue() && m_hand->Set("3", parameter, value[2]))
			ThrowError(wxT("Could not set property ") + param + wxT(" for motor three."));
	}
	if (SUPER_ParametersMotor4_CheckBox->GetValue())
	{
		UpdateTextCrtl(
			wxT("4FSET ") + param + wxString::Format(wxT(" %d"), (int)value[3]),
			wxT("Set(\"4\", \"") + param + wxString::Format(wxT("\", %d)"), (int)value[3]));

		if (SUPER_AutoRun_CheckBox->GetValue() && m_hand->Set("4", parameter, value[3]))
			ThrowError(wxT("Could not set property ") + param + wxT(" for motor four."));
	}

	//char buf[100];
	//wxString command = wxT("FSET ") + param + wxT(" ");
	//if(SUPER_ParametersMotor4_CheckBox->GetValue()) {
	//    if(SUPER_AutoRun_CheckBox->GetValue() && m_hand->Command((wxT("S") + command + SUPER_ParametersMotor4_TextCtrl->GetValue()).mb_str(), buf)) {
	//        ThrowError(wxT("Could not set parameter ") + param + wxT(" for motor spread."));
	//    }
	//    UpdateTextCrtl(wxT("S") + command + SUPER_ParametersMotor4_TextCtrl->GetValue(),
	//                        wxT("Command( \"S" + command  + SUPER_ParametersMotor4_TextCtrl->GetValue() + wxT("\", buf )")));
	//}
	return 0;
}


//! Supervise - Terminal
void SuperPanel::OnSuperTerminalClearSession(wxCommandEvent& event)
{
	ascii_session.Clear();
	cpp_session.Clear();
	SUPER_SessionHistory_TextCtrl->Clear();
}

void SuperPanel::OnSuperTerminalClearBuffer(wxCommandEvent& event)
{
	SUPER_CommandBuffer_TextCtrl->Clear();
}


//! copy from session history to the Command Buffer
void SuperPanel::OnSuperTerminalCopy(wxCommandEvent& event)
{
	// text will be written to the where the text cursor is in the wxTextCtrl window
	if (SUPER_SessionHistory_TextCtrl->GetStringSelection().Cmp(wxT("")))
		SUPER_CommandBuffer_TextCtrl->WriteText(SUPER_SessionHistory_TextCtrl->GetStringSelection() + wxT("\n"));
	else
		SUPER_CommandBuffer_TextCtrl->WriteText(SUPER_SessionHistory_TextCtrl->GetValue() + wxT("\n"));

	wxString toSet = wxT("");

	//delete any lines beginning with ">>" in the command buffer (not valid syntax)
	for (int i = 0; i < SUPER_CommandBuffer_TextCtrl->GetNumberOfLines(); i++)
	{
		wxString temp = SUPER_CommandBuffer_TextCtrl->GetLineText(i);
		if (!temp.Contains(wxT(">>")))
			toSet.Append(temp + wxT("\n"));
	}

	SUPER_CommandBuffer_TextCtrl->SetValue(toSet);
}

//! process command buffer if enter key is and auto-run is enabled, otherwise add a newline
void SuperPanel::OnSuperTerminalEnterHit(wxCommandEvent& event)
{
    if (SUPER_AutoRun_CheckBox->GetValue())
    {
#ifndef LINUX
		// The purpose of the following two lines is to remove the newline character in Windows
		long pos = SUPER_CommandBuffer_TextCtrl->GetInsertionPoint();
		SUPER_CommandBuffer_TextCtrl->Remove(pos > 0 ? pos-1 : pos, pos);
#endif
		//wxPuts(wxT("Running\n"));

		runCommandsInBuffer();
    }
    else
    {
#ifdef LINUX
		//windows still adds the newline even if the event consumed by this function
		//linux does not
		SUPER_CommandBuffer_TextCtrl->WriteText(wxT("\n"));
#endif
    }
}

void SuperPanel::runCommandsInBuffer()
{
	m_supervise_running = true;
	SUPER_Run_Button->Enable(0);
	SUPER_Abort_Button->Enable(1);
	SUPER_CommandBuffer_TextCtrl->SetEditable(false);
}

//! run supervisory commands (all in the command buffer)
void SuperPanel::OnSuperTerminalRun(wxCommandEvent& event)
{
	runCommandsInBuffer();
}

//! abort active state in supervisory mode
void SuperPanel::OnSuperControlAbort(wxCommandEvent& event)
{
	shouldAbort = true;
    //m_supervise_running = false;
	//SUPER_Run_Button->Enable(1);
    //SUPER_Abort_Button->Enable(0);
}


//! generate C++ code and corresponding makefile (both in the same directory specified by user)
//! makefile and C++ code work cross-platform
void SuperPanel::OnSuperTerminalGenerateCpp(wxCommandEvent& event)
{
    FileSave->SetWildcard(wxT("C++ File (*.cpp)|*.cpp"));

    if (FileSave->ShowModal() == wxID_OK)
    {
		wxString toSave = FileSave->GetPath();

		wxFile file;

		//check to see if user included .cpp at the end of their save file
		if (!toSave.Contains(wxT(".cpp")))
		{
			//if not, add it for him/her
			toSave = toSave + wxT(".cpp");
		}

		//generate the cpp file for the supervisory commands
		if (file.Create(toSave, true))
		{
			file.Write(CppGenerator::generateSupervisoryFile(cpp_session));
			file.Close();
		}

		toSave = toSave.BeforeLast('.') + wxT(".mak");

		//generate the makefile (will appear in the same directory as the cpp file)
		if (file.Create(toSave, true))
		{
			file.Write(CppGenerator::generateMakefile((toSave.BeforeLast('.')).AfterLast('/')));
			file.Close();
		}
    }

    FileSave->SetPath(wxT(""));
}

//! Load supervisory ASCII commands into the Command Buffer
void SuperPanel::OnSuperTerminalLoad(wxCommandEvent& event)
{
	// Create a BarrettHand Supervisory Command load dialog box
	wxFileDialog *FileDialog_BH = new wxFileDialog(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_OPEN, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	FileDialog_BH->SetWildcard(wxT("BHand Commands (*.bh)|*.bh"));

	if (FileDialog_BH->ShowModal() == wxID_OK)
	{
		cycleFilePath = FileDialog_BH->GetPath();
		SUPER_CommandBuffer_TextCtrl->LoadFile(cycleFilePath);

		if (SUPER_AutoRun_CheckBox->IsChecked())
			runCommandsInBuffer();
	}

	delete FileDialog_BH;
}

//! Save supervisory ASCII commands from the Command Buffer to a file
void SuperPanel::OnSuperTerminalSave(wxCommandEvent& event)
{
	//save as a .bh file
	FileSave->SetWildcard(wxT("BHand Commands (*.bh)|*.bh"));

	if (FileSave->ShowModal() == wxID_OK)
	{
		wxString toSave = FileSave->GetPath();

		// Saves supervisory commands from the command buffer into a file
		wxFile file;

		// check to see if user included .bh at the end of their save file
		if (!toSave.Contains(wxT(".bh")))
			toSave = toSave + wxT(".bh"); //if not, add it to the filename

		if (file.Create(toSave, true))
			file.Write(SUPER_CommandBuffer_TextCtrl->GetValue());
	}

	FileSave->SetPath(wxT(""));
}

//! Supervise - Control Panel

//! toggle Motors in the supervisory control panel
void SuperPanel::OnSuperControlMotor1Box(wxCommandEvent& event) { if (SUPER_Motor1_CheckBox->GetValue()) SUPER_Motor4_CheckBox->SetValue(false); generateMotorString(1); enableControlPanelButtons(); }
void SuperPanel::OnSuperControlMotor2Box(wxCommandEvent& event) { if (SUPER_Motor2_CheckBox->GetValue()) SUPER_Motor4_CheckBox->SetValue(false); generateMotorString(1); enableControlPanelButtons(); }
void SuperPanel::OnSuperControlMotor3Box(wxCommandEvent& event) { if (SUPER_Motor3_CheckBox->GetValue()) SUPER_Motor4_CheckBox->SetValue(false); generateMotorString(1); enableControlPanelButtons(); }
void SuperPanel::OnSuperControlMotor4Box(wxCommandEvent& event)
{
	if (SUPER_Motor4_CheckBox->GetValue())
	{
		SUPER_Motor1_CheckBox->SetValue(false);
		SUPER_Motor2_CheckBox->SetValue(false);
		SUPER_Motor3_CheckBox->SetValue(false);
	}
	generateMotorString(1);
	enableControlPanelButtons();
}


//! functions for buttons in supervisory mode
void SuperPanel::OnSuperControlOpen(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("O"), wxT("Open(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->Open(m_motors))
			ThrowError(wxT("Selected motors failed to open.  Check hand to see if selected motors are initialized."));
	}
}

void SuperPanel::OnSuperControlClose(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("C"), wxT("Close(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->Close(m_motors))
			ThrowError(wxT("Selected motors failed to close.  Check hand to see if selected motors are initialized."));
	}
}

void SuperPanel::OnSuperControlTorqueOpen(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("TO"), wxT("TorqueOpen(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->TorqueOpen(m_motors))
			ThrowError(wxT("Selected motors failed to open.  Check hand to see if selected motors are initialized."));
	}
}

void SuperPanel::OnSuperControlTorqueClose(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("TC"), wxT("TorqueClose(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->TorqueClose(m_motors))
			ThrowError(wxT("Selected motors failed to close.  Check hand to see if selected motors are initialized."));
	}
}

void SuperPanel::OnSuperControlGoHome(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->GoToHome(m_motors))
			ThrowError(wxT("All motors must be initialized in order to go to the home position or if there is an obstruction."));

		UpdateTextCrtl(m_motors_string + wxT("HOME"), wxT("GoToHome(\"") + m_motors_string + wxT("\")"));
	}
}

void SuperPanel::OnSuperControlGoDefault(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("M"), wxT("GoToDefault(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->GoToDefault(m_motors))
			ThrowError(wxT("Selected motors failed to go to the default position.  Check hand to see if all motors are initialized."));
	}
}

void SuperPanel::OnSuperControlInitialize(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("HI"), wxT("InitHand(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->InitHand(m_motors))
			ThrowError(wxT("Selected motors failed to initialize.  There may be a problem with one of the hand motors."));
	}
}

void SuperPanel::OnSuperControlStop(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("T"), wxT("StopMotor(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->StopMotor(m_motors))
			ThrowError(wxT("Selected motors failed to stop.  Check hand to see if selected motors are initialized."));
	}
}

void SuperPanel::OnSuperControlDefault(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("FDEF"), wxT("Default(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->Default(m_motors))
			ThrowError(wxT("Selected motors failed to load defaults."));
	}
}

void SuperPanel::OnSuperControlSave(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("FSAVE"), wxT("Save(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->Save(m_motors))
			ThrowError(wxT("Selected motors failed to save parameter values to EEPROM."));
	}
}

void SuperPanel::OnSuperControlLoad(wxCommandEvent& event)
{
	if (motorsSelected())
	{
		UpdateTextCrtl(m_motors_string + wxT("FLOAD"), wxT("Load(\"") + m_motors_string + wxT("\")"));

		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->Load(m_motors))
			ThrowError(wxT("Selected motors failed to load parameters from EEPROM."));
	}
}

void SuperPanel::OnSuperControlGoPosition(wxCommandEvent& event)
{
	long number;
	if (!(SUPER_MovementAmount_TextCtrl->GetValue()).ToLong(&number))
		return;

	if (motorsSelected())
	{
		int value = (int)number;

		UpdateTextCrtl(m_motors_string + wxT("M ") + wxString::Format(wxT("%i"), (int)value), wxT("GoToPosition(\"") + m_motors_string + wxT("\", ") + wxString::Format(wxT("%i"), (int)value) +  wxT("\")"));

		int result = 0;
		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && (result = m_hand->GoToPosition(m_motors, value)))
		{
			if (result == BHERR_OUTOFRANGE)
				ThrowError(wxT("GotoPosition value out of range"));
			else
				ThrowError(wxT("Selected motors failed to to go specified position.  Check hand to see if selected motors are initialized or if there is an obstruction."));
		}
	}
}

void SuperPanel::OnSuperControlStepOpen(wxCommandEvent& event)
{
	long number;
	if (!(SUPER_MovementAmount_TextCtrl->GetValue()).ToLong(&number))
		return;

	if (motorsSelected())
	{
		int value = (int)number;

		if (MotorMovementIncludedCheckBox->GetValue())
			UpdateTextCrtl(m_motors_string + wxT("IO ") + wxString::Format(wxT("%i"),value), wxT("StepOpen(\"") + m_motors_string + wxT("\", ") + wxString::Format(wxT("%i"),value) +  wxT(")"));
		else
			UpdateTextCrtl(m_motors_string + wxT("IO"), wxT("StepOpen(\"") + m_motors_string + wxT("\")"));

		int result = 0;
		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && MotorMovementIncludedCheckBox->GetValue() ?
			(result = m_hand->StepOpen(m_motors, value)) : m_hand->StepOpen(m_motors))
		{
			if (result == BHERR_OUTOFRANGE)
				ThrowError(wxT("StepOpen value out of range"));
			else
				ThrowError(wxT("Selected motors failed to step open.  Check hand to see if selected motors are initalized or if there is an obstruction."));
		}
	}
}

void SuperPanel::OnSuperControlStepClose(wxCommandEvent& event)
{
    long number;
    if (!(SUPER_MovementAmount_TextCtrl->GetValue()).ToLong(&number))
        return;

    if (motorsSelected())
    {
		int value = (int)number;

		if (MotorMovementIncludedCheckBox->GetValue())
			UpdateTextCrtl(m_motors_string + wxT("IC ") + wxString::Format(wxT("%i"),value), wxT("StepClose(\"") + m_motors_string + wxT("\", ") + wxString::Format(wxT("%i"),value) +  wxT(")"));
		else
			UpdateTextCrtl(m_motors_string + wxT("IC "), wxT("StepClose(\"") + m_motors_string + wxT("\")"));

		int result = 0;
		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && MotorMovementIncludedCheckBox->GetValue() ?
			(result = m_hand->StepClose(m_motors, value)) : m_hand->StepClose(m_motors))
		{
			if (result == BHERR_OUTOFRANGE)
				ThrowError(wxT("StepClose value out of range"));
			else
				ThrowError(wxT("Selected motors failed to step close.  Check hand to see if selected motors are initalized or if there is an obstruction."));
		}
    }
}

void SuperPanel::OnSuperControlDelay(wxCommandEvent& event)
{
	unsigned long number;
	if (!(SUPER_Delay_TextCtrl->GetValue()).ToULong(&number))
		return;

	unsigned int delay = (unsigned int)number;

	UpdateTextCrtl(wxT("DELAY ") + wxString::Format(wxT("%i"),delay), wxT("Delay(") + wxString::Format(wxT("%i"),delay) + wxT(")"));

	int result;
	if ((result = m_hand->Delay(delay)))
	{
		if (result == BHERR_OUTOFRANGE)
			ThrowError(wxT("Delay value out of range"));
		else
			ThrowError(wxT("Could not set the delay on the hand."));
	}
}

void SuperPanel::OnSuperControlTemperature(wxCommandEvent& event)
{
	UpdateTextCrtl(wxT("PGET TEMP"), wxT("Temperature(&value)"));

	int value;
	if (!m_hand->Temperature(&value))
	{
		if (SUPER_AutoRun_CheckBox->GetValue())
		{
			wxString temperatureResult = wxString::Format(wxT(">> %i\n"), value);
			ascii_session.Append(temperatureResult);
			AddSomeText(SUPER_SessionHistory_TextCtrl, temperatureResult);
		}
		SUPER_Temperature_TextCtrl->SetValue(wxString::Format(wxT("%i"), value));
	}
	else
		ThrowError(wxT("Failed to read temperature.  There may be a problem with the hand."));
}


///////////////////////////////////////////////////////////////////////////////
// Supervise - Properties
///////////////////////////////////////////////////////////////////////////////

// Create the motor string to get/set properties from
void SuperPanel::OnSuperParamMotor1Box(wxCommandEvent& event) { generateMotorString(2); }
void SuperPanel::OnSuperParamMotor2Box(wxCommandEvent& event) { generateMotorString(2); }
void SuperPanel::OnSuperParamMotor3Box(wxCommandEvent& event) { generateMotorString(2); }
void SuperPanel::OnSuperParamMotor4Box(wxCommandEvent& event) { generateMotorString(2); }


void SuperPanel::updatePropertyValues()
{
	// Get parameters for specified motors
	char buf[100];

	// Get selected BarrettHand property
	BHandProperty *bhandProperty = getSelectedProperty();

	// Check to ensure that a property is selected
	if (bhandProperty == NULL)
		return;

	const char *parameter = bhandProperty->getName();
	bool isGlobal = bhandProperty->isGlobal();

	if (isGlobal)
	{
		// create wxString for property and partial command
		wxString param = wxString(parameter, wxConvUTF8);
		wxString command = wxT("PGET ") + param;

		if (SUPER_ParametersMotor1_CheckBox->GetValue())
		{
			UpdateTextCrtl(command, wxT("PGet(\"") + param + wxT("\")"));
			int result;
			if (!m_hand->PGet(parameter, &result))
			{
				wxString wxStrResult = wxString::Format(wxT("%i"), result);
				SUPER_ParametersMotor1_TextCtrl->SetValue(wxStrResult);

				if (SUPER_AutoRun_CheckBox->GetValue())
				{
					//wxString result = wxT(">> ") + wxString(buf, wxConvUTF8) + wxT("\n");
					wxString result = wxT(">> ") + wxStrResult + wxT("\n");
					ascii_session.Append(result);
					AddSomeText(SUPER_SessionHistory_TextCtrl, result);
				}
			}
			else
				ThrowError(wxT("Could not retrieve global parameter ") + param);
		}
		return;
	}

	// create wxString for property and partial command
	wxString param = wxString(parameter, wxConvUTF8);
	wxString command = wxT("FGET ") + param;

	if (SUPER_ParametersMotor1_CheckBox->GetValue())
	{
		UpdateTextCrtl(wxT("1") + command, wxT("Command(\"1" + command + wxT("\", buf)")));
		if (!m_hand->Command((wxT("1") + command).mb_str(), buf))
		{
			SUPER_ParametersMotor1_TextCtrl->SetValue(wxString(buf, wxConvUTF8));

			if (SUPER_AutoRun_CheckBox->GetValue())
			{
				wxString result = wxT(">> ") + wxString(buf, wxConvUTF8) + wxT("\n");
				ascii_session.Append(result);
				AddSomeText(SUPER_SessionHistory_TextCtrl, result);
			}
		}
		else
			ThrowError(wxT("Could not retrieve parameter ") + param + wxT(" for motor one."));
	}
	if (SUPER_ParametersMotor2_CheckBox->GetValue())
	{
		UpdateTextCrtl(wxT("2") + command, wxT("Command(\"2" + command + wxT("\", buf)")));
		if (!m_hand->Command((wxT("2") + command).mb_str(), buf))
		{
			SUPER_ParametersMotor2_TextCtrl->SetValue(wxString(buf, wxConvUTF8));

			if (SUPER_AutoRun_CheckBox->GetValue())
			{
				wxString result = wxT(">> ") + wxString(buf, wxConvUTF8) + wxT("\n");
				ascii_session.Append(result);
				AddSomeText(SUPER_SessionHistory_TextCtrl, result);
			}
		}
		else
			ThrowError(wxT("Could not retrieve parameter ") + param + wxT(" for motor two."));
	}
	if (SUPER_ParametersMotor3_CheckBox->GetValue())
	{
		UpdateTextCrtl(wxT("3") + command, wxT("Command( \"3" + command + wxT("\", buf )")));
		if (!m_hand->Command((wxT("3") + command).mb_str(), buf))
		{
			SUPER_ParametersMotor3_TextCtrl->SetValue(wxString(buf, wxConvUTF8));

			if (SUPER_AutoRun_CheckBox->GetValue())
			{
				wxString result = wxT(">> ") + wxString(buf, wxConvUTF8) + wxT("\n");
				ascii_session.Append(result);
				AddSomeText(SUPER_SessionHistory_TextCtrl, result);
			}
		}
		else
			ThrowError(wxT("Could not retrieve parameter ") + param + wxT(" for motor three."));
	}
	if (SUPER_ParametersMotor4_CheckBox->GetValue())
	{
		UpdateTextCrtl(wxT("S") + command, wxT("Command( \"S" + command + wxT("\", buf )")));
		if (!m_hand->Command((wxT("S") + command).mb_str(), buf))
		{
			SUPER_ParametersMotor4_TextCtrl->SetValue(wxString(buf, wxConvUTF8));

			if (SUPER_AutoRun_CheckBox->GetValue())
			{
				wxString result = wxT(">> ") + wxString(buf, wxConvUTF8) + wxT("\n");
				ascii_session.Append(result);
				AddSomeText(SUPER_SessionHistory_TextCtrl, result);
			}
		}
		else
			ThrowError(wxT("Could not retrieve parameter ") + param + wxT(" for spread motor."));
	}

    /*if (SUPER_ParametersMotor4_CheckBox->GetValue())
    {
		UpdateTextCrtl(
			wxT("4FGET ") + param,
			wxT("Get(\"4\", \"") + param + wxT("\")"));

		int result;
        if (m_hand->Get("4", parameter, &result) == 0)
        {
            SUPER_ParametersMotor4_TextCtrl->SetValue(wxString::Format(wxT("%d"), result));

            //if (SUPER_AutoRun_CheckBox->GetValue())
            //{
            //    ascii_session.Append(wxT(">> ") + wxString(buf, wxConvUTF8) + wxT("\n"));
            //    SUPER_SessionHistory_TextCtrl->AppendText(wxT(">> ") + wxString(buf, wxConvUTF8) + wxT("\n"));
            //}
        }
        else
            ThrowError(wxT("Could not retrieve motor parameter ") + param + wxT(" for motor four."));
    }*/
}


void SuperPanel::OnSuperParamGet(wxCommandEvent& event)
{
	updatePropertyValues(); // Updates the GUI and each motor's property textctrl with its value
}

void SuperPanel::OnSuperParamSet(wxCommandEvent& event)
{
	setPropertyValues(); // Set the motor property values in the textctrl
}

void SuperPanel::OnSuperParamSetDP(wxCommandEvent& event)
{
	setPropertyValues(); // "DP" property must be selected so set the desired value(s) for each selected motor

	generateMotorString(2);

	if (m_motors_param_string.Length() > 0)
	{
		UpdateTextCrtl(m_motors_param_string + wxT("M"), wxT("GoToDefault(\"") + m_motors_param_string + wxT("\")"));

		// Note - this does not seem to work for the 280 hand spread motor when hold equals 1

		// Move to specified motor positions
		if (SUPER_AutoRun_CheckBox->GetValue() && !ENABLE_DEBUG && m_hand->GoToDefault(m_motors_param))
			ThrowError(wxT("Selected motors failed to go to the default position.  Check hand to see if all motors are initialized."));
	}
}




int SuperPanel::getSelectedPropertyIndex()
{
	// Get the selected property name in the Property ListBox
	wxString selectedText = SUPER_Parameters_Choice->GetStringSelection();

	// Get char pointer to a copy of selected property name
	char selectedChars[1024];
	if (selectedText.Len() > 1000)
		return -1;
	strcpy(selectedChars, (const char*)selectedText.mb_str(wxConvUTF8));

	// Look for the ':' character and NULL terminate the string
	for (unsigned int i = 0; i < selectedText.Len(); i++)
	{
		if (selectedChars[i] == ':')
			selectedChars[i] = 0; // NULL terminate the string
	}

	// Get pointers to BarrettHand hardware
	BHandHardware *hardware = m_hand->getHardwareDesc();
	if (hardware == NULL)
		return -1;

	for (unsigned int j = 0; j < hardware->getBHandNumProperties(); j++)
	{
		BHandProperty *property = hardware->getBHandProperty(j);

		if (strcmp(selectedChars, property->getName()) == 0)
			return j;
	}

	return -1; // not found
}


BHandProperty * SuperPanel::getSelectedProperty()
{
	int propertyIndex = getSelectedPropertyIndex();

	// Check if there is no selected property
	if (propertyIndex < 0)
		return NULL;

	// Get pointers to BarrettHand hardware and the selected property
	BHandHardware *hardware = m_hand->getHardwareDesc();
	if (hardware == NULL)
		return NULL;

	// Return pointer to selected property
	BHandProperty *property = hardware->getBHandProperty(propertyIndex);
	return property;
}




void SuperPanel::updatePropertyAttributes()
{
	BHandProperty *bhandProperty = getSelectedProperty();
	if (bhandProperty == NULL)
		return;

	///////////////////////////////////////////////////////////////////////////
	// Get property attributes
	///////////////////////////////////////////////////////////////////////////

	const char *name = bhandProperty->getName();
	//const char *desc = bhandProperty->getDesc();

	bool isGlobal = bhandProperty->isGlobal();
	bool isReadOnly = bhandProperty->isReadOnly();

	//int minValue = bhandProperty->getMinValue();
	//int maxValue = bhandProperty->getMaxValue();

	const char *purpose = bhandProperty->getPurpose();
	const char *notes = bhandProperty->getNotes();

	///////////////////////////////////////////////////////////////////////////
	// Update property attributes
	///////////////////////////////////////////////////////////////////////////

	// Set Global or Motor Radio button
	//setNonGlobalParameter(!isGlobal);

	// Set contents of purpose & notes text controls
	purposeTextCtrl->SetValue(wxString(purpose, wxConvUTF8));
	notesTextCtrl->SetValue(wxString(notes, wxConvUTF8));

	if (m_panelEnabled)
	{
		// Enable or Disable Set button
		SUPER_ParameterSet_Button->Enable(!isReadOnly);

		// Show just the checkboxes/textctrls necessary for input/output
		SUPER_ParametersMotor2_CheckBox->Show(!isGlobal);
		SUPER_ParametersMotor3_CheckBox->Show(!isGlobal);
		SUPER_ParametersMotor4_CheckBox->Show(!isGlobal);

		SUPER_ParametersMotor2_TextCtrl->Show(!isGlobal);
		SUPER_ParametersMotor3_TextCtrl->Show(!isGlobal);
		SUPER_ParametersMotor4_TextCtrl->Show(!isGlobal);


		// Enable or Disable "Set DP And Go" button
		SUPER_ParameterSetDPAndGo_Button->Enable(strcmp(name, "DP") == 0);
	}
}


void SuperPanel::OnSuperParamCategoryChoice(wxCommandEvent& event)
{
	fillPropertyChoice();

	// New property selected, update displayed property values and attributes
	updatePropertyValues();
	updatePropertyAttributes();
}

void SuperPanel::OnSuperParamChoice(wxCommandEvent& event)
{
	// New property selected, update displayed property values and attributes
	updatePropertyValues();
	updatePropertyAttributes();
}




void SuperPanel::Service()
{
	if (m_supervise_running)
	{
		// Run Supervisory command unless aborting
		if (!shouldAbort && !TerminalRun())
		{
			// Finished running supervisory commands or an error occurred
			SUPER_CommandBuffer_TextCtrl->SetEditable(true);
			SUPER_Run_Button->Enable(1);
			SUPER_Abort_Button->Enable(0);
			m_supervise_running = false;
		}

		if (shouldAbort)
		{
			m_hand->StopMotor("GS");
			// Abort running supervisory commands
			SUPER_CommandBuffer_TextCtrl->SetEditable(true);
			SUPER_Run_Button->Enable(1);
			SUPER_Abort_Button->Enable(0);
			m_supervise_running = false;
			shouldAbort = false;
		}
	}
}

void SuperPanel::OnSuperAutoRunCheckBox(wxCommandEvent& event)
{
	if (SUPER_AutoRun_CheckBox->GetValue())
		runCommandsInBuffer();
}

void SuperPanel::OnSUPER_terminal_ascii_RadioButtonSelect(wxCommandEvent& event)
{
	ascii_selected = true;
	SUPER_SessionHistory_TextCtrl->Clear();
	SUPER_SessionHistory_TextCtrl->SetValue(ascii_session);

	SUPER_Copy_Button->Enable();
}

void SuperPanel::OnSUPER_terminal_cpp_RadioButtonSelect(wxCommandEvent& event)
{
	ascii_selected = false;
	SUPER_SessionHistory_TextCtrl->Clear();
	SUPER_SessionHistory_TextCtrl->SetValue(cpp_session);

	SUPER_Copy_Button->Disable();
}

void SuperPanel::OnSUPER_ParametersMotor1_CheckBoxClick(wxCommandEvent& event)
{
	SUPER_ParametersMotor1_TextCtrl->Enable(SUPER_ParametersMotor1_CheckBox->GetValue());
}
void SuperPanel::OnSUPER_ParametersMotor2_CheckBoxClick(wxCommandEvent& event)
{
	SUPER_ParametersMotor2_TextCtrl->Enable(SUPER_ParametersMotor2_CheckBox->GetValue());
}
void SuperPanel::OnSUPER_ParametersMotor3_CheckBoxClick(wxCommandEvent& event)
{
	SUPER_ParametersMotor3_TextCtrl->Enable(SUPER_ParametersMotor3_CheckBox->GetValue());
}
void SuperPanel::OnSUPER_ParametersMotor4_CheckBoxClick(wxCommandEvent& event)
{
	SUPER_ParametersMotor4_TextCtrl->Enable(SUPER_ParametersMotor4_CheckBox->GetValue());
}

void SuperPanel::enableControlPanelButtons()
{
	bool en =
		SUPER_Motor1_CheckBox->GetValue() ||
		SUPER_Motor2_CheckBox->GetValue() ||
		SUPER_Motor3_CheckBox->GetValue() ||
		SUPER_Motor4_CheckBox->GetValue();

	SUPER_Initialize_Button->Enable(en);
	SUPER_StopMotor_Button->Enable(en);

	SUPER_Open_Button->Enable(en);
	SUPER_Close_Button->Enable(en);

	//SUPER_TorqueOpen_Button->Enable(en);
	//SUPER_TorqueClose_Button->Enable(en);

	SUPER_GoHome_Button->Enable(en);
	SUPER_GoDefault_Button->Enable(en);

	MotorMovementIncludedCheckBox->Enable(en);
	SUPER_GoPosition_Button->Enable(en && MotorMovementIncludedCheckBox->GetValue());
	SUPER_StepOpen_Button->Enable(en);
	SUPER_StepClose_Button->Enable(en);

	SUPER_Default_Button->Enable(en);
	SUPER_ControlLoad_Button->Enable(en);
	SUPER_ControlSave_Button->Enable(en);
}

bool SuperPanel::IsRunning()
{
	return m_supervise_running;
}

void SuperPanel::LeaveTab()
{
	m_hand->StopMotor("GS");
	if (m_supervise_running)
	{
		SUPER_CommandBuffer_TextCtrl->SetEditable(true);
		SUPER_Run_Button->Enable(1);
    	SUPER_Abort_Button->Enable(0);
	    m_supervise_running = false;
	}
}

void SuperPanel::OnMotorMovementIncludedCheckBox(wxCommandEvent& event)
{
	// Enable/Disable GotoPosition button
	SUPER_GoPosition_Button->Enable(MotorMovementIncludedCheckBox->GetValue());
}
