#ifndef BHAND_KINEMATICS_H
#define BHAND_KINEMATICS_H

#include "BMatrix.h"

class BHandKinematics
{
public:
	BHandKinematics();
	~BHandKinematics();

	void fillCapThetaBefore(double *pos);
	void fillCapTheta(double *motorEncPos, double *innerEncPos = NULL);

	void getBHandMatrices(int k, BMatrix<double> *wTo1, BMatrix<double> *wTo2, BMatrix<double> *wTo3, BMatrix<double> *wTo4); //, BMatrix<double> **matrices, int numMatrices);

	static void setD3(double d3) { dhDParam[3] = d3; }
	void fillmatrix(int i, BMatrix<double> &m, double theta, double r);

	void test();

private:

	void fillF1MatrixWtoT(BMatrix<double> &m); // test wrist to tool matrix

	static double dhAParam[5];
	static double dhAlphaParam[5];
	static double dhDParam[5];

	BMatrix<double> capTheta; // configuration dependent

	double capPhi2, capPhi3;
};

#endif
