#ifndef BOUNDINGSPHERE_H_INCLUDED
#define BOUNDINGSPHERE_H_INCLUDED

#include "HandModel.h"


class VRMLModel;

class BoundingSphere {

    public:
        BoundingSphere(float radius, GLdouble x, GLdouble y, GLdouble z, VRMLModel* parent);
        ~BoundingSphere();

        void Render() const;
        bool hasSameParent(BoundingSphere* toCheck);
        void updateTransformation(const GLdouble* transformation);
        bool checkIntersection(BoundingSphere* toCheck);

        //! get functions
        float getRadius();
        GLdouble* getTransformation();
        GLdouble* getPositionTransformed();
        VRMLModel* getParent();

        //! set functions
        void setTransformation(const GLdouble* trans);
        void setPositionTransformed(const GLdouble* pos);

    private:

        float m_radius;
        GLdouble m_position[4];
        GLdouble m_position_transformed[4];
        GLdouble m_transform[16];
        VRMLModel* m_parent;
};

#endif // BOUNDINGSPHERE_H_INCLUDED
