#include "HandFingerSpreadable.h"

HandFingerSpreadable::HandFingerSpreadable(float x, float y, float z, float pitch, float yaw, float roll, float amount, bool pickable)
 : HandFinger(x, y, z, pitch, yaw, roll, amount, pickable)
{
    xOffset = 0.0;
}

void HandFingerSpreadable::Render() {

    glPushMatrix();

    //! rotation of Y axis
    glTranslatef(-xOffset/10.0f, 0.0, -0.00);
    glRotatef(m_rot[1], 0.0, 1.0, 0.0);
    glTranslatef(xOffset/10.0f, 0.0, 0.00);

    //! second rotation of X axis with respect to HandMiddle
    glTranslatef(0.0f, 0.38f/10.0f, 0.5f/10.0f);
    glRotatef(rotVal, 1.0, 0.0, 0.0);
    glTranslatef(0.0f, -0.38f/10.0f, -0.5f/10.0f);

    //!default translation
    glTranslatef(m_pos[0], m_pos[1], m_pos[2]);

    //! rotation of Z axis
    glRotatef(m_rot[2], 0.0, 0.0, 1.0);

    //! rotation of X axis
    glTranslatef(0.0f, 0.0f, -0.258f/10.0f);
    glRotatef(m_rot[0], 1.0, 0.0, 0.0);
    glTranslatef(0.0f, 0.0f, 0.258f/10.0f);
    //! default rotation
    glRotatef(-32.0, 1.0, 0.0, 0.0);
    //! default scale
    glScalef(scale, scale, scale);

    if(m_selected) {
        glCallList(partDL_selected);
    } else {
        glCallList(partDL);
    }

    glGetDoublev(GL_MODELVIEW_MATRIX, trans);

    for(unsigned int i = 0; i < m_b_spheres.size(); i++) {
        m_b_spheres[i]->updateTransformation(trans);
    }

    glPopMatrix();

}
