#include "HandJoint.h"

#include "HandModel.h"

#define _CULL_FACE	GL_BACK
#define _MAT_FACE	GL_FRONT_AND_BACK

GLfloat ambMatFingerjoint0000[]=
{
	0.8490f, 0.8490f, 0.8490f, 1.0000f
};
GLfloat diffMatFingerjoint0000[]=
{
	0.7917f, 0.7917f, 0.7917f, 1.0000f
};
GLfloat specMatFingerjoint0000[]=
{
	0.6591f, 0.6591f, 0.6591f, 1.0000f
};
GLfloat emissMatFingerjoint0000[]=
{
	0.1573f, 0.1573f, 0.1573f, 1.0000f
};

HandJoint::HandJoint(float x, float y, float z, float pitch, float yaw, float roll, float amount, bool pickable)
{
    InitDL();
    CreateColor();
    m_pos[0] = x;
    m_pos[1] = y;
    m_pos[2] = z;
    m_rot[0] = pitch;
    m_rot[1] = yaw;
    m_rot[2] = roll;
    scale = amount;

    m_pickable = pickable;
}

void HandJoint::Render() {
    glPushMatrix();

    glTranslatef(m_pos[0], m_pos[1], m_pos[2]);
    glRotatef(m_rot[0], 1.0, 0.0, 0.0);
    glRotatef(m_rot[1], 0.0, 1.0, 0.0);
    glRotatef(m_rot[2], 0.0, 0.0, 1.0);
    glTranslatef(0.0f, 0.0f, 0.11f/10.0f);
    glScalef(scale, scale, scale);

    glCallList(partDL);
    glPopMatrix();
}

void HandJoint::DrawPart()
{
#ifdef DRAW_HAND_MODEL
    glPushAttrib(GL_ALL_ATTRIB_BITS);
	/*** The following lines have been inserted by Vrml2OGL V1.01 ***/
	glEnable(GL_NORMALIZE);
	glCullFace(_CULL_FACE);
	glEnable(GL_CULL_FACE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	/*** End of insert **********************************************/
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 26.8800f);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingerjoint0000);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingerjoint0000);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingerjoint0000);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingerjoint0000);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameJoint_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
	/*** The following lines have been inserted by Vrml2OGL V1.01 ***/
	glDisable(GL_BLEND);
	glDisable(GL_CULL_FACE);
	glDisable(GL_NORMALIZE);
	/*** End of insert **********************************************/
	glPopAttrib();
#endif
}
