#include "HandMiddle.h"

#include "HandModel.h"

#define _CULL_FACE	GL_BACK
#define _MAT_FACE	GL_FRONT_AND_BACK

#define SELECTED_VALUE 0.4f

GLfloat ambMatMiddledigit0000[]=
{
	0.8490f, 0.8490f, 0.8490f, 1.0000f
};
GLfloat diffMatMiddledigit0000[]=
{
	0.7917f, 0.7917f, 0.7917f, 1.0000f
};
GLfloat specMatMiddledigit0000[]=
{
	0.6591f, 0.6591f, 0.6591f, 1.0000f
};
GLfloat emissMatMiddledigit0000[]=
{
	0.1573f, 0.1573f, 0.1573f, 1.0000f
};

HandMiddle::HandMiddle(float x, float y, float z, float pitch, float yaw, float roll, float amount, bool pickable)
{
    InitDL();
    CreateColor();
    m_pos[0] = x;
    m_pos[1] = y;
    m_pos[2] = z;
    m_rot[0] = pitch;
    m_rot[1] = yaw;
    m_rot[2] = roll;
    scale = amount;

    m_pickable = pickable;

    m_selected = false;
}

void HandMiddle::InitDL() {

    partDL = glGenLists(1);
    glNewList(partDL, GL_COMPILE);
    DrawPart();
    glEndList();

    ambMatMiddledigit0000[0] = SELECTED_VALUE;

    partDL_selected = glGenLists(2);
    glNewList(partDL_selected, GL_COMPILE);
    DrawPart();
    glEndList();

    ambMatMiddledigit0000[0] = 0.8490f;
}

void HandMiddle::setSelected(bool flag) {
    m_selected = flag;
}

void HandMiddle::Render() {
    glPushMatrix();

    //glRotatef(m_rot[1], 0.0, 1.0, 0.0);
    //glTranslatef(0.0, -0.01, 0.4);

    glTranslatef(m_pos[0], m_pos[1], m_pos[2]);

    glRotatef(m_rot[2], 0.0, 0.0, 1.0);

    glTranslatef(0.0f, 0.0f, -0.85f/10.0f);
    glRotatef(m_rot[1], 0.0, 1.0, 0.0);
    glTranslatef(0.0f, 0.0f, 0.85f/10.0f);

    glTranslatef(0.0f, 0.01f/10.0f, -0.345f/10.0f);
    glRotatef(m_rot[0], 1.0, 0.0, 0.0);
    glTranslatef(0.0f, -0.01f/10.0f, 0.345f/10.0f);

    glScalef(scale, scale, scale);

    if(m_selected) {
        glCallList(partDL_selected);
    } else {
        glCallList(partDL);
    }

    glGetDoublev(GL_MODELVIEW_MATRIX, trans);

    for(unsigned int i = 0; i < m_b_spheres.size(); i++) {
        m_b_spheres[i]->updateTransformation(trans);
    }

    glPopMatrix();
}

void HandMiddle::DrawPart()
{
#ifdef DRAW_HAND_MODEL
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	/*** The following lines have been inserted by Vrml2OGL V1.01 ***/
	glEnable(GL_NORMALIZE);
	glCullFace(_CULL_FACE);
	glEnable(GL_CULL_FACE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	/*** End of insert **********************************************/
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 24.8800f);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatMiddledigit0000);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatMiddledigit0000);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatMiddledigit0000);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatMiddledigit0000);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameMiddle_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
	/*** The following lines have been inserted by Vrml2OGL V1.01 ***/
	glDisable(GL_BLEND);
	glDisable(GL_CULL_FACE);
	glDisable(GL_NORMALIZE);
	/*** End of insert **********************************************/
	glPopAttrib();
#endif
}
