#include "HandModel.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

const char hand3dModelFilename[][64] = {
	"../../src/Visual_Tab/Models/HandBase.3d",
	"../../src/Visual_Tab/Models/HandJoint.3d",
	"../../src/Visual_Tab/Models/HandKnuckle1.3d",
	"../../src/Visual_Tab/Models/HandKnuckle2.3d",
	"../../src/Visual_Tab/Models/HandKnuckle3.3d",
	"../../src/Visual_Tab/Models/HandMiddle.3d",
	"../../src/Visual_Tab/Models/HandFinger1.3d",
	"../../src/Visual_Tab/Models/HandFinger2.3d",
	"../../src/Visual_Tab/Models/HandFinger3.3d",
	"../../src/Visual_Tab/Models/HandFinger4.3d",
	"../../src/Visual_Tab/Models/HandFinger5.3d",
	"../../src/Visual_Tab/Models/HandFinger6.3d",
	"../../src/Visual_Tab/Models/HandFinger7.3d",
	"../../src/Visual_Tab/Models/HandFinger8.3d",
	"../../src/Visual_Tab/Models/HandFinger9.3d"
	};

const char *getHand3dModelFilename(HandModelFilenames3d filenameIndex)
{
	return hand3dModelFilename[filenameIndex];
}

void parse3dLine(char *line)
{
	int count = 0;
	bool vertex = false;
	float x = 0, y = 0, z = 0;


	char *pch;
	pch = strtok(line, " ,();");

	while (pch != NULL)
	{
		if (count == 0)
			vertex = (pch[2] == 'V');
		else if (count == 1)
			x = (float)atof(pch);
		else if (count == 2)
			y = (float)atof(pch);
		else if (count == 3)
		{
			z = (float)atof(pch);
			if (vertex)
				glVertex3f(x, y, z);
			else
				glNormal3f(x, y, z);
		}
		//printf("%s\t", pch);
		pch = strtok(NULL, " ,();"); count++;
	}
	//printf("\n");
}

void parseAndDraw3dModel(const char *filename)
{
	FILE *sourcehook = NULL;

	if ((sourcehook = fopen(filename, "r")) == NULL)
		if ((sourcehook = fopen(&filename[3], "r")) == NULL)
			if ((sourcehook = fopen(&filename[6], "r")) == NULL)
				return;


	char line[128];

	while (fgets(line, 127, sourcehook) != NULL)
	{
		//printf("line: %s\n", line);
		parse3dLine(line);
	}
}
