#ifndef HAND_MODEL_H
#define HAND_MODEL_H

// Comment or uncomment to draw the hand model in the OpenGL canvas
#define DRAW_HAND_MODEL

#pragma warning ( disable : 4005 )

#include "GL/gl.h"
// According to http://www.mingw.org/wiki/HOWTO_Use_Mark_J_Kilgards_OpenGL_Utility_Toolkit_GLUT_with_MinGW
// these macros should be defined before including <GL/glut.h>
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE
#define GLUT_DISABLE_ATEXIT_HACK
//#define _STDCALL_SUPPORTED
//#define _M_IX86
#ifndef LINUX
#include <windows.h>
#endif
#include "GL/glut.h"


enum HandModelFilenames3d
{
	HandModelFilenameBase_3d = 0,
	HandModelFilenameJoint_3d,
	HandModelFilenameKnuckle1_3d,
	HandModelFilenameKnuckle2_3d,
	HandModelFilenameKnuckle3_3d,
	HandModelFilenameMiddle_3d,
	HandModelFilenameFinger1_3d,
	HandModelFilenameFinger2_3d,
	HandModelFilenameFinger3_3d,
	HandModelFilenameFinger4_3d,
	HandModelFilenameFinger5_3d,
	HandModelFilenameFinger6_3d,
	HandModelFilenameFinger7_3d,
	HandModelFilenameFinger8_3d,
	HandModelFilenameFinger9_3d
	};

const char *getHand3dModelFilename(HandModelFilenames3d filenameIndex);

void parseAndDraw3dModel(const char *filename);

#endif
