#ifndef VISUAL_DATA_H
#define VISUAL_DATA_H

#include "Poco/NotificationQueue.h"

class BHand;

#define MAX_PPS_ELEMENTS 24


class VisualDataPPS : public Poco::Notification
{
public:
	VisualDataPPS() {}
	~VisualDataPPS() {}

	int data[MAX_PPS_ELEMENTS];
};


class VisualData
{
public:

	static VisualData* getInstance(BHand *bhand = NULL)
	{
		if (m_visualData == NULL && bhand != NULL)
		{
			m_visualData = new VisualData(bhand);
		}
		return m_visualData;
	}

	static void freeInstance()
	{
		if (m_visualData != NULL)
		{
			delete m_visualData;
			m_visualData = NULL;
		}
	}

	int update();

	void tareStrainGauges();

	float getStrain(unsigned int i) { return (i < 3) ? (strainActual[i] - strainTared[i]) : 0; }

private:
	VisualData(BHand *hand);
	~VisualData();

	BHand *m_hand;

	static VisualData *m_visualData;

	// Flags
	volatile bool tareStrain;
	bool updateStrain;
	bool updatePPS;

	// Strain Data
	volatile float strainActual[4];
	volatile float strainTared[4];
};

#endif
