#ifndef VISUAL_FINGER_TIP_H
#define VISUAL_FINGER_TIP_H

#pragma warning ( disable : 4005 )

#include "GL/gl.h"
// According to http://www.mingw.org/wiki/HOWTO_Use_Mark_J_Kilgards_OpenGL_Utility_Toolkit_GLUT_with_MinGW
// these macros should be defined before including <GL/glut.h>
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE
#define GLUT_DISABLE_ATEXIT_HACK

#ifndef LINUX
#include <windows.h>
#endif
#include "GL/glut.h"

#include "Poco/NotificationQueue.h"
#include "Poco/Notification.h"

#include "VisualData.h"

#include "BMatrix.h"

using Poco::NotificationQueue;

class BHand;
class VisualFingerTip;

class VisualFingerTip
{
public:
	VisualFingerTip(int motor);
	~VisualFingerTip();

	void init();

	void update(BHand *bhand);

	void render(BMatrix<double> &trans);

	static VisualFingerTip* getInstance(int motor);

private:
	int m_motor;

	NotificationQueue queue;

	BMatrix<float> pressureMap;

	BMatrix< BVector3<float> > vert;

	static VisualFingerTip *m_fingerTip[3];

};

#endif
