#ifndef VISUAL_PALM_H
#define VISUAL_PALM_H

#pragma warning ( disable : 4005 )

#include "GL/gl.h"
// According to http://www.mingw.org/wiki/HOWTO_Use_Mark_J_Kilgards_OpenGL_Utility_Toolkit_GLUT_with_MinGW
// these macros should be defined before including <GL/glut.h>
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE
#define GLUT_DISABLE_ATEXIT_HACK
//#define _STDCALL_SUPPORTED
//#define _M_IX86
#ifndef LINUX
#include <windows.h>
#endif
#include "GL/glut.h"

#include "Poco/NotificationQueue.h"
#include "Poco/Notification.h"

#include "BMatrix.h"

using Poco::NotificationQueue;

class BHand;
class VisualPalm;

class VisualPalm
{
public:
	VisualPalm();
	~VisualPalm();

	void update(BHand *bhand);

	void render(BMatrix<double> &trans);

	static VisualPalm* getInstance();

private:
	NotificationQueue queue;

	BMatrix<float> pressureMap;

	BMatrix< BVector3<float> > vert;

	static VisualPalm *m_palm;

};

#endif
